/* Generated automatically by the program 'build/genpreds'
   from the machine description file '../../gcc-9.2.1-20190827/gcc/config/cris/cris.md'.  */

#ifndef GCC_TM_CONSTRS_H
#define GCC_TM_CONSTRS_H

static inline bool
satisfies_constraint_m (rtx op)
{
  return (GET_CODE (op) == MEM) && (
#line 26 "../../gcc-9.2.1-20190827/gcc/common.md"
(memory_address_addr_space_p (GET_MODE (op), XEXP (op, 0),
						 MEM_ADDR_SPACE (op))));
}
static inline bool
satisfies_constraint_o (rtx op)
{
  return (GET_CODE (op) == MEM) && (
#line 32 "../../gcc-9.2.1-20190827/gcc/common.md"
(offsettable_nonstrict_memref_p (op)));
}
static inline bool
satisfies_constraint_V (rtx op)
{
  return (GET_CODE (op) == MEM) && ((
#line 41 "../../gcc-9.2.1-20190827/gcc/common.md"
(memory_address_addr_space_p (GET_MODE (op), XEXP (op, 0),
						 MEM_ADDR_SPACE (op)))) && (!(
#line 43 "../../gcc-9.2.1-20190827/gcc/common.md"
(offsettable_nonstrict_memref_p (op)))));
}
static inline bool
satisfies_constraint__l (rtx op)
{
  return (GET_CODE (op) == MEM) && ((
#line 50 "../../gcc-9.2.1-20190827/gcc/common.md"
(GET_CODE (XEXP (op, 0)) == PRE_DEC)) || (
#line 51 "../../gcc-9.2.1-20190827/gcc/common.md"
(GET_CODE (XEXP (op, 0)) == POST_DEC)));
}
static inline bool
satisfies_constraint__g (rtx op)
{
  return (GET_CODE (op) == MEM) && ((
#line 57 "../../gcc-9.2.1-20190827/gcc/common.md"
(GET_CODE (XEXP (op, 0)) == PRE_INC)) || (
#line 58 "../../gcc-9.2.1-20190827/gcc/common.md"
(GET_CODE (XEXP (op, 0)) == POST_INC)));
}
static inline bool
satisfies_constraint_p (rtx ARG_UNUSED (op))
{
  return 
#line 62 "../../gcc-9.2.1-20190827/gcc/common.md"
(address_operand (op, VOIDmode));
}
static inline bool
satisfies_constraint_i (rtx op)
{
  return (
#line 66 "../../gcc-9.2.1-20190827/gcc/common.md"
(CONSTANT_P (op))) && (
#line 67 "../../gcc-9.2.1-20190827/gcc/common.md"
(!flag_pic || LEGITIMATE_PIC_OPERAND_P (op)));
}
static inline bool
satisfies_constraint_s (rtx op)
{
  return (
#line 71 "../../gcc-9.2.1-20190827/gcc/common.md"
(CONSTANT_P (op))) && ((
#line 72 "../../gcc-9.2.1-20190827/gcc/common.md"
(!CONST_SCALAR_INT_P (op))) && (
#line 73 "../../gcc-9.2.1-20190827/gcc/common.md"
(!flag_pic || LEGITIMATE_PIC_OPERAND_P (op))));
}
static inline bool
satisfies_constraint_n (rtx op)
{
  return (
#line 77 "../../gcc-9.2.1-20190827/gcc/common.md"
(CONST_SCALAR_INT_P (op))) && (
#line 78 "../../gcc-9.2.1-20190827/gcc/common.md"
(!flag_pic || LEGITIMATE_PIC_OPERAND_P (op)));
}
static inline bool
satisfies_constraint_E (rtx op)
{
  return (
#line 82 "../../gcc-9.2.1-20190827/gcc/common.md"
(CONST_DOUBLE_AS_FLOAT_P (op))) || (
#line 83 "../../gcc-9.2.1-20190827/gcc/common.md"
(GET_CODE (op) == CONST_VECTOR
		    && GET_MODE_CLASS (GET_MODE (op)) == MODE_VECTOR_FLOAT));
}
static inline bool
satisfies_constraint_F (rtx op)
{
  return (
#line 89 "../../gcc-9.2.1-20190827/gcc/common.md"
(CONST_DOUBLE_AS_FLOAT_P (op))) || (
#line 90 "../../gcc-9.2.1-20190827/gcc/common.md"
(GET_CODE (op) == CONST_VECTOR
		    && GET_MODE_CLASS (GET_MODE (op)) == MODE_VECTOR_FLOAT));
}
static inline bool
satisfies_constraint_X (rtx ARG_UNUSED (op))
{
  return 
#line 95 "../../gcc-9.2.1-20190827/gcc/common.md"
(true);
}
static inline bool
satisfies_constraint_I (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 40 "../../gcc-9.2.1-20190827/gcc/config/cris/constraints.md"
(IN_RANGE (ival, -32, 31)));
}
static inline bool
satisfies_constraint_J (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 45 "../../gcc-9.2.1-20190827/gcc/config/cris/constraints.md"
(IN_RANGE (ival, 0, 63)));
}
static inline bool
satisfies_constraint_Kc (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 50 "../../gcc-9.2.1-20190827/gcc/config/cris/constraints.md"
(IN_RANGE (ival, 0, 31)));
}
static inline bool
satisfies_constraint_Kp (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 55 "../../gcc-9.2.1-20190827/gcc/config/cris/constraints.md"
(exact_log2 (ival) >= 0));
}
static inline bool
satisfies_constraint_L (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 60 "../../gcc-9.2.1-20190827/gcc/config/cris/constraints.md"
(IN_RANGE (ival, -32768, 32767)));
}
static inline bool
satisfies_constraint_M (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 65 "../../gcc-9.2.1-20190827/gcc/config/cris/constraints.md"
(ival == 0));
}
static inline bool
satisfies_constraint_N (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 70 "../../gcc-9.2.1-20190827/gcc/config/cris/constraints.md"
(IN_RANGE (ival, -63, -1)));
}
static inline bool
satisfies_constraint_O (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && ((
#line 75 "../../gcc-9.2.1-20190827/gcc/config/cris/constraints.md"
(IN_RANGE (ival, (65535 - 31), 65535))) || (
#line 76 "../../gcc-9.2.1-20190827/gcc/config/cris/constraints.md"
(IN_RANGE (ival, (255 - 31), 255))));
}
static inline bool
satisfies_constraint_P (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 81 "../../gcc-9.2.1-20190827/gcc/config/cris/constraints.md"
(IN_RANGE (ival, -32768, 65535)));
}
static inline bool
satisfies_constraint_G (rtx op)
{
  machine_mode mode = GET_MODE (op);
  return (GET_CODE (op) == CONST_DOUBLE) && ((
#line 87 "../../gcc-9.2.1-20190827/gcc/config/cris/constraints.md"
(GET_MODE_CLASS (mode) == MODE_FLOAT)) && (
#line 88 "../../gcc-9.2.1-20190827/gcc/config/cris/constraints.md"
(op == CONST0_RTX (mode))));
}
static inline bool
satisfies_constraint_Q (rtx op)
{
  return (GET_CODE (op) == MEM) && (
#line 97 "../../gcc-9.2.1-20190827/gcc/config/cris/constraints.md"
(cris_base_p (XEXP (op, 0), reload_in_progress
					       || reload_completed)));
}
static inline bool
satisfies_constraint_R (rtx op)
{
  return (
#line 104 "../../gcc-9.2.1-20190827/gcc/config/cris/constraints.md"
(cris_biap_index_p (op, reload_in_progress
					   || reload_completed))) || ((
#line 107 "../../gcc-9.2.1-20190827/gcc/config/cris/constraints.md"
(cris_bdap_index_p (op, reload_in_progress
					   || reload_completed))) || (
#line 109 "../../gcc-9.2.1-20190827/gcc/config/cris/constraints.md"
(cris_constant_index_p (op))));
}
static inline bool
satisfies_constraint_T (rtx op)
{
  return (GET_CODE (op) == MEM) && (((GET_CODE (XEXP (op, 0)) == MEM) && (
#line 117 "../../gcc-9.2.1-20190827/gcc/config/cris/constraints.md"
(cris_base_or_autoincr_p (XEXP (XEXP (op, 0), 0),
						       reload_in_progress
						       || reload_completed)))) || ((
#line 121 "../../gcc-9.2.1-20190827/gcc/config/cris/constraints.md"
(CRIS_CONSTANT_P (XEXP (op, 0)))) || ((GET_CODE (XEXP (op, 0)) == PLUS) && (((
#line 125 "../../gcc-9.2.1-20190827/gcc/config/cris/constraints.md"
(cris_base_p (XEXP (XEXP (op, 0), 0),
						     reload_in_progress
						     || reload_completed))) && (
#line 128 "../../gcc-9.2.1-20190827/gcc/config/cris/constraints.md"
(cris_constant_index_p (XEXP (XEXP (op, 0), 1))))) || (((
#line 130 "../../gcc-9.2.1-20190827/gcc/config/cris/constraints.md"
(cris_base_p (XEXP (XEXP (op, 0), 0),
						     reload_in_progress
						     || reload_completed))) && (
#line 133 "../../gcc-9.2.1-20190827/gcc/config/cris/constraints.md"
(cris_bdap_index_p (XEXP (XEXP (op, 0), 1),
							   reload_in_progress
							   || reload_completed)))) || (((
#line 139 "../../gcc-9.2.1-20190827/gcc/config/cris/constraints.md"
(cris_base_p (XEXP (XEXP (op, 0), 1),
						     reload_in_progress
						     || reload_completed))) && (
#line 142 "../../gcc-9.2.1-20190827/gcc/config/cris/constraints.md"
(cris_bdap_index_p (XEXP (XEXP (op, 0), 0),
							   reload_in_progress
							   || reload_completed)))) || ((
#line 146 "../../gcc-9.2.1-20190827/gcc/config/cris/constraints.md"
(cris_base_p (XEXP (XEXP (op, 0), 1),
						     reload_in_progress
						     || reload_completed))) && (
#line 149 "../../gcc-9.2.1-20190827/gcc/config/cris/constraints.md"
(cris_biap_index_p (XEXP (XEXP (op, 0), 0),
							   reload_in_progress
							   || reload_completed))))))))));
}
static inline bool
satisfies_constraint_S (rtx op)
{
  return (
#line 155 "../../gcc-9.2.1-20190827/gcc/config/cris/constraints.md"
(flag_pic)) && ((GET_CODE (op) == CONST) && (
#line 157 "../../gcc-9.2.1-20190827/gcc/config/cris/constraints.md"
(cris_valid_pic_const (op, false))));
}
static inline bool
satisfies_constraint_U (rtx op)
{
  machine_mode mode = GET_MODE (op);
  return (
#line 161 "../../gcc-9.2.1-20190827/gcc/config/cris/constraints.md"
(flag_pic)) && ((
#line 164 "../../gcc-9.2.1-20190827/gcc/config/cris/constraints.md"
(CONSTANT_P (op))) && (cris_nonmemory_operand_or_callable_symbol (op, mode)));
}
#endif /* tm-constrs.h */
