/* Generated automatically by the program `genattrtab'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "alias.h"
#include "options.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "insn-attr.h"
#include "memmodel.h"
#include "tm_p.h"
#include "insn-config.h"
#include "recog.h"
#include "regs.h"
#include "real.h"
#include "output.h"
#include "toplev.h"
#include "flags.h"
#include "emit-rtl.h"

#define operands recog_data.operand

extern int internal_dfa_insn_code_itanium2 (rtx_insn *);
extern int internal_dfa_insn_code_itanium (rtx_insn *);

int
internal_dfa_insn_code_itanium (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return 111 /* 0x6f */;

    }
}

int
internal_dfa_insn_code_itanium2 (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  enum attr_itanium_class cached_itanium_class ATTRIBUTE_UNUSED;
  enum attr_data_speculative cached_data_speculative ATTRIBUTE_UNUSED;
  enum attr_check_load cached_check_load ATTRIBUTE_UNUSED;

  switch (recog_memoized (insn))
    {
    case 1240:  /* *p fetchadd_rel_di */
    case 1239:  /* *p fetchadd_rel_si */
    case 1238:  /* *p fetchadd_acq_di */
    case 1237:  /* *p fetchadd_acq_si */
    case 1236:  /* *p xchg_acq_di */
    case 1235:  /* *p xchg_acq_si */
    case 1234:  /* *p xchg_acq_hi */
    case 1233:  /* *p xchg_acq_qi */
    case 1232:  /* *p cmpxchg_rel_di */
    case 1231:  /* *p cmpxchg_acq_di */
    case 1230:  /* *p cmpxchg_rel_si */
    case 1229:  /* *p cmpxchg_rel_hi */
    case 1228:  /* *p cmpxchg_rel_qi */
    case 1227:  /* *p cmpxchg_acq_si */
    case 1226:  /* *p cmpxchg_acq_hi */
    case 1225:  /* *p cmpxchg_acq_qi */
    case 496:  /* fetchadd_rel_di */
    case 495:  /* fetchadd_rel_si */
    case 494:  /* fetchadd_acq_di */
    case 493:  /* fetchadd_acq_si */
    case 492:  /* xchg_acq_di */
    case 491:  /* xchg_acq_si */
    case 490:  /* xchg_acq_hi */
    case 489:  /* xchg_acq_qi */
    case 488:  /* cmpxchg_rel_di */
    case 487:  /* cmpxchg_acq_di */
    case 486:  /* cmpxchg_rel_si */
    case 485:  /* cmpxchg_rel_hi */
    case 484:  /* cmpxchg_rel_qi */
    case 483:  /* cmpxchg_acq_si */
    case 482:  /* cmpxchg_acq_hi */
    case 481:  /* cmpxchg_acq_qi */
      extract_constrain_insn_cached (insn);
      if (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 29 /* 0x1d */;
        }
      else
        {
	  return 84 /* 0x54 */;
        }

    case 1224:  /* *p *memory_barrier */
    case 480:  /* *memory_barrier */
      extract_constrain_insn_cached (insn);
      if (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 33 /* 0x21 */;
        }
      else
        {
	  return 88 /* 0x58 */;
        }

    case 1179:  /* *p *cmpgt_v2si */
    case 1178:  /* *p *cmpgt_v4hi */
    case 1177:  /* *p *cmpgt_v8qi */
    case 1176:  /* *p *cmpeq_v2si */
    case 1175:  /* *p *cmpeq_v4hi */
    case 1174:  /* *p *cmpeq_v8qi */
    case 1158:  /* *p *ussubv4hi3 */
    case 1157:  /* *p *ussubv8qi3 */
    case 1156:  /* *p *sssubv4hi3 */
    case 1155:  /* *p *sssubv8qi3 */
    case 1154:  /* *p subv2si3 */
    case 1153:  /* *p subv4hi3 */
    case 1152:  /* *p subv8qi3 */
    case 1151:  /* *p *usaddv4hi3 */
    case 1150:  /* *p *usaddv8qi3 */
    case 1149:  /* *p *ssaddv4hi3 */
    case 1148:  /* *p *ssaddv8qi3 */
    case 1147:  /* *p addv2si3 */
    case 1146:  /* *p addv4hi3 */
    case 1145:  /* *p addv8qi3 */
    case 1144:  /* *p negv2si2 */
    case 1143:  /* *p negv4hi2 */
    case 1142:  /* *p negv8qi2 */
    case 435:  /* *cmpgt_v2si */
    case 434:  /* *cmpgt_v4hi */
    case 433:  /* *cmpgt_v8qi */
    case 432:  /* *cmpeq_v2si */
    case 431:  /* *cmpeq_v4hi */
    case 430:  /* *cmpeq_v8qi */
    case 414:  /* *ussubv4hi3 */
    case 413:  /* *ussubv8qi3 */
    case 412:  /* *sssubv4hi3 */
    case 411:  /* *sssubv8qi3 */
    case 410:  /* subv2si3 */
    case 409:  /* subv4hi3 */
    case 408:  /* subv8qi3 */
    case 407:  /* *usaddv4hi3 */
    case 406:  /* *usaddv8qi3 */
    case 405:  /* *ssaddv4hi3 */
    case 404:  /* *ssaddv8qi3 */
    case 403:  /* addv2si3 */
    case 402:  /* addv4hi3 */
    case 401:  /* addv8qi3 */
    case 400:  /* negv2si2 */
    case 399:  /* negv4hi2 */
    case 398:  /* negv8qi2 */
      extract_constrain_insn_cached (insn);
      if (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 20 /* 0x14 */;
        }
      else
        {
	  return 75 /* 0x4b */;
        }

    case 1122:  /* *p ip_value */
    case 377:  /* ip_value */
      extract_constrain_insn_cached (insn);
      if (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 14 /* 0xe */;
        }
      else
        {
	  return 69 /* 0x45 */;
        }

    case 1116:  /* *p prefetch */
    case 368:  /* prefetch */
      extract_constrain_insn_cached (insn);
      if (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 45 /* 0x2d */;
        }
      else
        {
	  return 100 /* 0x64 */;
        }

    case 364:  /* insn_group_barrier */
      extract_constrain_insn_cached (insn);
      if (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 0;
        }
      else
        {
	  return 55 /* 0x37 */;
        }

    case 1113:  /* *p pre_cycle */
    case 361:  /* pre_cycle */
      extract_constrain_insn_cached (insn);
      if (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 54 /* 0x36 */;
        }
      else
        {
	  return 109 /* 0x6d */;
        }

    case 1112:  /* *p nop_x */
    case 360:  /* nop_x */
      extract_constrain_insn_cached (insn);
      if (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 50 /* 0x32 */;
        }
      else
        {
	  return 105 /* 0x69 */;
        }

    case 1111:  /* *p nop_b */
    case 359:  /* nop_b */
      extract_constrain_insn_cached (insn);
      if (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 47 /* 0x2f */;
        }
      else
        {
	  return 102 /* 0x66 */;
        }

    case 1115:  /* *p break_f */
    case 1110:  /* *p nop_f */
    case 367:  /* break_f */
    case 358:  /* nop_f */
      extract_constrain_insn_cached (insn);
      if (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 49 /* 0x31 */;
        }
      else
        {
	  return 104 /* 0x68 */;
        }

    case 1109:  /* *p nop_i */
    case 357:  /* nop_i */
      extract_constrain_insn_cached (insn);
      if (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 48 /* 0x30 */;
        }
      else
        {
	  return 103 /* 0x67 */;
        }

    case 1108:  /* *p nop_m */
    case 356:  /* nop_m */
      extract_constrain_insn_cached (insn);
      if (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 46 /* 0x2e */;
        }
      else
        {
	  return 101 /* 0x65 */;
        }

    case 1107:  /* *p nop */
    case 355:  /* nop */
      extract_constrain_insn_cached (insn);
      if (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 52 /* 0x34 */;
        }
      else
        {
	  return 107 /* 0x6b */;
        }

    case 354:  /* flushrs */
      extract_constrain_insn_cached (insn);
      if (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 28 /* 0x1c */;
        }
      else
        {
	  return 83 /* 0x53 */;
        }

    case 1106:  /* *p bsp_value */
    case 352:  /* bsp_value */
      extract_constrain_insn_cached (insn);
      if (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 12 /* 0xc */;
        }
      else
        {
	  return 67 /* 0x43 */;
        }

    case 1104:  /* *p fr_spill */
    case 350:  /* fr_spill */
      extract_constrain_insn_cached (insn);
      if (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 30 /* 0x1e */;
        }
      else
        {
	  return 85 /* 0x55 */;
        }

    case 1102:  /* *p gr_spill_internal */
    case 348:  /* gr_spill_internal */
      extract_constrain_insn_cached (insn);
      if (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 31 /* 0x1f */;
        }
      else
        {
	  return 86 /* 0x56 */;
        }

    case 347:  /* alloc */
      extract_constrain_insn_cached (insn);
      if (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 32 /* 0x20 */;
        }
      else
        {
	  return 87 /* 0x57 */;
        }

    case 373:  /* safe_across_calls_normal */
    case 372:  /* safe_across_calls_all */
    case 371:  /* pred_rel_mutex */
    case 363:  /* blockage */
    case 362:  /* bundle_selector */
    case 346:  /* prologue_use */
      extract_constrain_insn_cached (insn);
      if (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 53 /* 0x35 */;
        }
      else
        {
	  return 108 /* 0x6c */;
        }

    case 1095:  /* *p call_value_gp */
    case 1094:  /* *p call_gp */
    case 1093:  /* *p sibcall_nogp */
    case 1092:  /* *p call_value_nogp */
    case 1091:  /* *p call_nogp */
    case 333:  /* call_value_gp */
    case 332:  /* call_gp */
    case 331:  /* sibcall_nogp */
    case 330:  /* call_value_nogp */
    case 329:  /* call_nogp */
      extract_constrain_insn_cached (insn);
      if ((which_alternative == 0) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 1;
        }
      else if ((which_alternative == 1) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 2;
        }
      else if ((which_alternative == 0) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 56 /* 0x38 */;
        }
      else if ((which_alternative == 1) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 57 /* 0x39 */;
        }
      else
        {
	  return 111 /* 0x6f */;
        }

    case 326:  /* *abssi2_internal */
    case 324:  /* *absdi2_internal */
      extract_constrain_insn_cached (insn);
      if ((which_alternative == 0) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 17 /* 0x11 */;
        }
      else if ((which_alternative == 1) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 51 /* 0x33 */;
        }
      else if ((which_alternative == 0) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 72 /* 0x48 */;
        }
      else if ((which_alternative == 1) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 106 /* 0x6a */;
        }
      else
        {
	  return 111 /* 0x6f */;
        }

    case 1101:  /* *p *tablejump_internal */
    case 1100:  /* *p indirect_jump */
    case 1099:  /* *p jump */
    case 1098:  /* *p return */
    case 1097:  /* *p return_internal */
    case 1096:  /* *p sibcall_gp */
    case 341:  /* *tablejump_internal */
    case 340:  /* indirect_jump */
    case 339:  /* jump */
    case 338:  /* *return_false */
    case 337:  /* *return_true */
    case 336:  /* return */
    case 335:  /* return_internal */
    case 334:  /* sibcall_gp */
    case 320:  /* doloop_end_internal */
    case 319:  /* *br_false */
    case 318:  /* *br_true */
      extract_constrain_insn_cached (insn);
      if (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 1;
        }
      else
        {
	  return 56 /* 0x38 */;
        }

    case 1086:  /* *p *cmpxf_internal */
    case 1085:  /* *p *cmpdf_internal */
    case 1084:  /* *p *cmpsf_internal */
    case 315:  /* *cmpxf_internal */
    case 314:  /* *cmpdf_internal */
    case 313:  /* *cmpsf_internal */
      extract_constrain_insn_cached (insn);
      if (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 3;
        }
      else
        {
	  return 58 /* 0x3a */;
        }

    case 1141:  /* *p xorv2si3 */
    case 1140:  /* *p xorv4hi3 */
    case 1139:  /* *p xorv8qi3 */
    case 1138:  /* *p iorv2si3 */
    case 1137:  /* *p iorv4hi3 */
    case 1136:  /* *p iorv8qi3 */
    case 1135:  /* *p *andnotv2si */
    case 1134:  /* *p *andnotv4hi */
    case 1133:  /* *p *andnotv8qi */
    case 1132:  /* *p andv2si3 */
    case 1131:  /* *p andv4hi3 */
    case 1130:  /* *p andv8qi3 */
    case 1078:  /* *p xordi3 */
    case 1077:  /* *p iordi3 */
    case 1076:  /* *p *andnot */
    case 1075:  /* *p anddi3 */
    case 397:  /* xorv2si3 */
    case 396:  /* xorv4hi3 */
    case 395:  /* xorv8qi3 */
    case 394:  /* iorv2si3 */
    case 393:  /* iorv4hi3 */
    case 392:  /* iorv8qi3 */
    case 391:  /* *andnotv2si */
    case 390:  /* *andnotv4hi */
    case 389:  /* *andnotv8qi */
    case 388:  /* andv2si3 */
    case 387:  /* andv4hi3 */
    case 386:  /* andv8qi3 */
    case 307:  /* xordi3 */
    case 306:  /* iordi3 */
    case 305:  /* *andnot */
    case 304:  /* anddi3 */
      extract_constrain_insn_cached (insn);
      if ((which_alternative == 1) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 11 /* 0xb */;
        }
      else if ((which_alternative == 0) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 19 /* 0x13 */;
        }
      else if ((which_alternative == 1) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 66 /* 0x42 */;
        }
      else if ((which_alternative == 0) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 74 /* 0x4a */;
        }
      else
        {
	  return 111 /* 0x6f */;
        }

    case 1129:  /* *p one_cmplv2si2 */
    case 1128:  /* *p one_cmplv4hi2 */
    case 1127:  /* *p one_cmplv8qi2 */
    case 1079:  /* *p one_cmpldi2 */
    case 1074:  /* *p one_cmplsi2 */
    case 385:  /* one_cmplv2si2 */
    case 384:  /* one_cmplv4hi2 */
    case 383:  /* one_cmplv8qi2 */
    case 308:  /* one_cmpldi2 */
    case 303:  /* one_cmplsi2 */
      extract_constrain_insn_cached (insn);
      if (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 19 /* 0x13 */;
        }
      else
        {
	  return 74 /* 0x4a */;
        }

    case 1066:  /* *p lshrdi3 */
    case 1065:  /* *p ashrdi3 */
    case 295:  /* lshrdi3 */
    case 294:  /* ashrdi3 */
      extract_constrain_insn_cached (insn);
      if ((which_alternative == 0) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 26 /* 0x1a */;
        }
      else if ((which_alternative == 1) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 27 /* 0x1b */;
        }
      else if ((which_alternative == 0) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 81 /* 0x51 */;
        }
      else if ((which_alternative == 1) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 82 /* 0x52 */;
        }
      else
        {
	  return 111 /* 0x6f */;
        }

    case 1246:  /* *p truncrfxf2 */
    case 1245:  /* *p truncrfdf2 */
    case 1244:  /* *p truncrfsf2 */
    case 1243:  /* *p extendxfrf2 */
    case 1242:  /* *p extenddfrf2 */
    case 1241:  /* *p extendsfrf2 */
    case 1219:  /* *p fmix_lr */
    case 1218:  /* *p *vec_interleave_lowv2sf */
    case 1217:  /* *p *vec_interleave_highv2sf */
    case 1216:  /* *p fswap */
    case 1215:  /* *p fpack */
    case 1214:  /* *p *fselect */
    case 1213:  /* *p *fpcmp */
    case 1212:  /* *p sminv2sf3 */
    case 1211:  /* *p smaxv2sf3 */
    case 1205:  /* *p *negabsv2sf2 */
    case 1204:  /* *p negv2sf2 */
    case 1203:  /* *p absv2sf2 */
    case 1046:  /* *p smaxxf3 */
    case 1045:  /* *p sminxf3 */
    case 1044:  /* *p *ncopysignxf3 */
    case 1043:  /* *p copysignxf3 */
    case 1042:  /* *p *nabsxf2 */
    case 1041:  /* *p negxf2 */
    case 1040:  /* *p absxf2 */
    case 1022:  /* *p smaxdf3 */
    case 1021:  /* *p smindf3 */
    case 1020:  /* *p *ncopysigndf3 */
    case 1019:  /* *p copysigndf3 */
    case 1018:  /* *p *nabsdf2 */
    case 1017:  /* *p negdf2 */
    case 1016:  /* *p absdf2 */
    case 1005:  /* *p smaxsf3 */
    case 1004:  /* *p sminsf3 */
    case 1003:  /* *p *ncopysignsf3 */
    case 1002:  /* *p copysignsf3 */
    case 1001:  /* *p *nabssf2 */
    case 1000:  /* *p negsf2 */
    case 999:  /* *p abssf2 */
    case 515:  /* sqrt_approx_rf */
    case 514:  /* recip_approx_rf */
    case 510:  /* truncrfxf2 */
    case 509:  /* truncrfdf2 */
    case 508:  /* truncrfsf2 */
    case 507:  /* extendxfrf2 */
    case 506:  /* extenddfrf2 */
    case 505:  /* extendsfrf2 */
    case 475:  /* fmix_lr */
    case 474:  /* *vec_interleave_lowv2sf */
    case 473:  /* *vec_interleave_highv2sf */
    case 472:  /* fswap */
    case 471:  /* fpack */
    case 470:  /* *fselect */
    case 469:  /* *fpcmp */
    case 468:  /* sminv2sf3 */
    case 467:  /* smaxv2sf3 */
    case 461:  /* *negabsv2sf2 */
    case 460:  /* negv2sf2 */
    case 459:  /* absv2sf2 */
    case 275:  /* smaxxf3 */
    case 274:  /* sminxf3 */
    case 273:  /* *ncopysignxf3 */
    case 272:  /* copysignxf3 */
    case 271:  /* *nabsxf2 */
    case 270:  /* negxf2 */
    case 269:  /* absxf2 */
    case 251:  /* smaxdf3 */
    case 250:  /* smindf3 */
    case 249:  /* *ncopysigndf3 */
    case 248:  /* copysigndf3 */
    case 247:  /* *nabsdf2 */
    case 246:  /* negdf2 */
    case 245:  /* absdf2 */
    case 234:  /* smaxsf3 */
    case 233:  /* sminsf3 */
    case 232:  /* *ncopysignsf3 */
    case 231:  /* copysignsf3 */
    case 230:  /* *nabssf2 */
    case 229:  /* negsf2 */
    case 228:  /* abssf2 */
      extract_constrain_insn_cached (insn);
      if (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 11 /* 0xb */;
        }
      else
        {
	  return 66 /* 0x42 */;
        }

    case 1249:  /* *p setf_exp_rf */
    case 990:  /* *p *getf_exp_xf */
    case 513:  /* setf_exp_rf */
    case 219:  /* *getf_exp_xf */
      extract_constrain_insn_cached (insn);
      if (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 15 /* 0xf */;
        }
      else
        {
	  return 70 /* 0x46 */;
        }

    case 986:  /* *p umuldi3_highpart */
    case 985:  /* *p smuldi3_highpart */
    case 983:  /* *p madddi4 */
    case 982:  /* *p muldi3 */
    case 975:  /* *p maddsi4 */
    case 974:  /* *p mulsi3 */
    case 215:  /* umuldi3_highpart */
    case 214:  /* smuldi3_highpart */
    case 212:  /* madddi4 */
    case 211:  /* muldi3 */
    case 204:  /* maddsi4 */
    case 203:  /* mulsi3 */
      extract_constrain_insn_cached (insn);
      if (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 40 /* 0x28 */;
        }
      else
        {
	  return 95 /* 0x5f */;
        }

    case 1161:  /* *p pmpyshr2_u */
    case 1160:  /* *p pmpyshr2 */
    case 1159:  /* *p mulv4hi3 */
    case 988:  /* *p popcountdi2 */
    case 967:  /* *p mulhi3 */
    case 417:  /* pmpyshr2_u */
    case 416:  /* pmpyshr2 */
    case 415:  /* mulv4hi3 */
    case 217:  /* popcountdi2 */
    case 196:  /* mulhi3 */
      extract_constrain_insn_cached (insn);
      if (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 25 /* 0x19 */;
        }
      else
        {
	  return 80 /* 0x50 */;
        }

    case 1088:  /* *p *bit_one */
    case 1087:  /* *p *bit_zero */
    case 966:  /* *p *tbit_or_3 */
    case 965:  /* *p *tbit_or_2 */
    case 964:  /* *p *tbit_or_1 */
    case 963:  /* *p *tbit_or_0 */
    case 954:  /* *p *tbit_and_3 */
    case 953:  /* *p *tbit_and_2 */
    case 952:  /* *p *tbit_and_1 */
    case 951:  /* *p *tbit_and_0 */
    case 317:  /* *bit_one */
    case 316:  /* *bit_zero */
    case 195:  /* *tbit_or_3 */
    case 194:  /* *tbit_or_2 */
    case 193:  /* *tbit_or_1 */
    case 192:  /* *tbit_or_0 */
    case 183:  /* *tbit_and_3 */
    case 182:  /* *tbit_and_2 */
    case 181:  /* *tbit_and_1 */
    case 180:  /* *tbit_and_0 */
      extract_constrain_insn_cached (insn);
      if (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 34 /* 0x22 */;
        }
      else
        {
	  return 89 /* 0x59 */;
        }

    case 1083:  /* *p *cmpdi_adjusted */
    case 1082:  /* *p *cmpdi_normal */
    case 1081:  /* *p *cmpsi_adjusted */
    case 1080:  /* *p *cmpsi_normal */
    case 962:  /* *p *cmpdi_orcm_1 */
    case 961:  /* *p *cmpdi_orcm_0 */
    case 960:  /* *p *cmpdi_or_1 */
    case 959:  /* *p *cmpdi_or_0 */
    case 958:  /* *p *cmpsi_orcm_1 */
    case 957:  /* *p *cmpsi_orcm_0 */
    case 956:  /* *p *cmpsi_or_1 */
    case 955:  /* *p *cmpsi_or_0 */
    case 950:  /* *p *cmpdi_andnot_1 */
    case 949:  /* *p *cmpdi_andnot_0 */
    case 948:  /* *p *cmpdi_and_1 */
    case 947:  /* *p *cmpdi_and_0 */
    case 946:  /* *p *cmpsi_andnot_1 */
    case 945:  /* *p *cmpsi_andnot_0 */
    case 944:  /* *p *cmpsi_and_1 */
    case 943:  /* *p *cmpsi_and_0 */
    case 312:  /* *cmpdi_adjusted */
    case 311:  /* *cmpdi_normal */
    case 310:  /* *cmpsi_adjusted */
    case 309:  /* *cmpsi_normal */
    case 191:  /* *cmpdi_orcm_1 */
    case 190:  /* *cmpdi_orcm_0 */
    case 189:  /* *cmpdi_or_1 */
    case 188:  /* *cmpdi_or_0 */
    case 187:  /* *cmpsi_orcm_1 */
    case 186:  /* *cmpsi_orcm_0 */
    case 185:  /* *cmpsi_or_1 */
    case 184:  /* *cmpsi_or_0 */
    case 179:  /* *cmpdi_andnot_1 */
    case 178:  /* *cmpdi_andnot_0 */
    case 177:  /* *cmpdi_and_1 */
    case 176:  /* *cmpdi_and_0 */
    case 175:  /* *cmpsi_andnot_1 */
    case 174:  /* *cmpsi_andnot_0 */
    case 173:  /* *cmpsi_and_1 */
    case 172:  /* *cmpsi_and_0 */
      extract_constrain_insn_cached (insn);
      if (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 18 /* 0x12 */;
        }
      else
        {
	  return 73 /* 0x49 */;
        }

    case 941:  /* *p *iorcmbi3 */
    case 170:  /* *iorcmbi3 */
      extract_constrain_insn_cached (insn);
      if ((which_alternative == 1) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 34 /* 0x22 */;
        }
      else if ((which_alternative == 0) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 51 /* 0x33 */;
        }
      else if ((which_alternative == 1) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 89 /* 0x59 */;
        }
      else if ((which_alternative == 0) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 106 /* 0x6a */;
        }
      else
        {
	  return 111 /* 0x6f */;
        }

    case 1201:  /* *p *vecinit_v2si */
    case 1200:  /* *p *vec_interleave_highv2si */
    case 1199:  /* *p *vec_interleave_lowv2si */
    case 1198:  /* *p *mux2_brcst_hi */
    case 1197:  /* *p *mux2 */
    case 1196:  /* *p mix2_odd */
    case 1195:  /* *p mix2_even */
    case 1194:  /* *p *vec_interleave_highv4hi */
    case 1193:  /* *p *vec_interleave_lowv4hi */
    case 1192:  /* *p mux1_brcst_qi */
    case 1191:  /* *p *mux1_brcst_v8qi */
    case 1190:  /* *p *mux1_alt */
    case 1189:  /* *p *mux1_shuf */
    case 1188:  /* *p *mux1_mix */
    case 1187:  /* *p *mux1_rev */
    case 1186:  /* *p *mix1_odd */
    case 1185:  /* *p *mix1_even */
    case 1184:  /* *p *vec_interleave_highv8qi */
    case 1183:  /* *p *vec_interleave_lowv8qi */
    case 1182:  /* *p vec_pack_ssat_v2si */
    case 1181:  /* *p vec_pack_usat_v4hi */
    case 1180:  /* *p vec_pack_ssat_v4hi */
    case 1173:  /* *p lshrv2si3 */
    case 1172:  /* *p lshrv4hi3 */
    case 1171:  /* *p ashrv2si3 */
    case 1170:  /* *p ashrv4hi3 */
    case 1169:  /* *p ashlv2si3 */
    case 1168:  /* *p ashlv4hi3 */
    case 1167:  /* *p *sminv4hi3 */
    case 1166:  /* *p *uminv8qi3 */
    case 1165:  /* *p *smaxv4hi3 */
    case 1164:  /* *p *umaxv8qi3 */
    case 1163:  /* *p vec_widen_smult_odd_v4hi */
    case 1162:  /* *p vec_widen_smult_even_v4hi */
    case 1061:  /* *p *rotlsi3_internal */
    case 989:  /* *p bswapdi2 */
    case 937:  /* *p *mix4right_3op */
    case 936:  /* *p mix4right */
    case 935:  /* *p *mix4left */
    case 457:  /* *vecinit_v2si */
    case 456:  /* *vec_interleave_highv2si */
    case 455:  /* *vec_interleave_lowv2si */
    case 454:  /* *mux2_brcst_hi */
    case 453:  /* *mux2 */
    case 452:  /* mix2_odd */
    case 451:  /* mix2_even */
    case 450:  /* *vec_interleave_highv4hi */
    case 449:  /* *vec_interleave_lowv4hi */
    case 448:  /* mux1_brcst_qi */
    case 447:  /* *mux1_brcst_v8qi */
    case 446:  /* *mux1_alt */
    case 445:  /* *mux1_shuf */
    case 444:  /* *mux1_mix */
    case 443:  /* *mux1_rev */
    case 442:  /* *mix1_odd */
    case 441:  /* *mix1_even */
    case 440:  /* *vec_interleave_highv8qi */
    case 439:  /* *vec_interleave_lowv8qi */
    case 438:  /* vec_pack_ssat_v2si */
    case 437:  /* vec_pack_usat_v4hi */
    case 436:  /* vec_pack_ssat_v4hi */
    case 429:  /* lshrv2si3 */
    case 428:  /* lshrv4hi3 */
    case 427:  /* ashrv2si3 */
    case 426:  /* ashrv4hi3 */
    case 425:  /* ashlv2si3 */
    case 424:  /* ashlv4hi3 */
    case 423:  /* *sminv4hi3 */
    case 422:  /* *uminv8qi3 */
    case 421:  /* *smaxv4hi3 */
    case 420:  /* *umaxv8qi3 */
    case 419:  /* vec_widen_smult_odd_v4hi */
    case 418:  /* vec_widen_smult_even_v4hi */
    case 290:  /* *rotlsi3_internal */
    case 218:  /* bswapdi2 */
    case 166:  /* *mix4right_3op */
    case 165:  /* mix4right */
    case 164:  /* *mix4left */
      extract_constrain_insn_cached (insn);
      if (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 26 /* 0x1a */;
        }
      else
        {
	  return 81 /* 0x51 */;
        }

    case 1073:  /* *p shrp */
    case 1068:  /* *p *rotldi3_internal */
    case 1067:  /* *p *rotrdi3_internal */
    case 933:  /* *p *depz_internal */
    case 931:  /* *p *insv_internal */
    case 930:  /* *p extzv */
    case 929:  /* *p extv */
    case 302:  /* shrp */
    case 297:  /* *rotldi3_internal */
    case 296:  /* *rotrdi3_internal */
    case 162:  /* *depz_internal */
    case 160:  /* *insv_internal */
    case 159:  /* extzv */
    case 158:  /* extv */
      extract_constrain_insn_cached (insn);
      if (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 21 /* 0x15 */;
        }
      else
        {
	  return 76 /* 0x4c */;
        }

    case 1248:  /* *p fixuns_truncrfdi2_alts */
    case 1247:  /* *p fix_truncrfdi2_alts */
    case 928:  /* *p fixuns_truncrfdi2 */
    case 927:  /* *p fixuns_truncxfdi2 */
    case 926:  /* *p fixuns_truncdfdi2 */
    case 925:  /* *p fixuns_truncsfdi2 */
    case 924:  /* *p floatunsdirf2 */
    case 923:  /* *p floatunsdixf2 */
    case 922:  /* *p floatunsdidf2 */
    case 921:  /* *p floatunsdisf2 */
    case 920:  /* *p fix_truncrfdi2 */
    case 919:  /* *p fix_truncxfdi2 */
    case 918:  /* *p fix_truncdfdi2 */
    case 917:  /* *p fix_truncsfdi2 */
    case 916:  /* *p floatdixf2 */
    case 915:  /* *p floatdirf2 */
    case 512:  /* fixuns_truncrfdi2_alts */
    case 511:  /* fix_truncrfdi2_alts */
    case 157:  /* fixuns_truncrfdi2 */
    case 156:  /* fixuns_truncxfdi2 */
    case 155:  /* fixuns_truncdfdi2 */
    case 154:  /* fixuns_truncsfdi2 */
    case 153:  /* floatunsdirf2 */
    case 152:  /* floatunsdixf2 */
    case 151:  /* floatunsdidf2 */
    case 150:  /* floatunsdisf2 */
    case 149:  /* fix_truncrfdi2 */
    case 148:  /* fix_truncxfdi2 */
    case 147:  /* fix_truncdfdi2 */
    case 146:  /* fix_truncsfdi2 */
    case 145:  /* floatdixf2 */
    case 144:  /* floatdirf2 */
      extract_constrain_insn_cached (insn);
      if (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 4;
        }
      else
        {
	  return 59 /* 0x3b */;
        }

    case 907:  /* *p zero_extendhidi2 */
    case 906:  /* *p zero_extendqidi2 */
    case 136:  /* zero_extendhidi2 */
    case 135:  /* zero_extendqidi2 */
      extract_constrain_insn_cached (insn);
      if ((which_alternative == 1) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 22 /* 0x16 */;
        }
      else if ((which_alternative == 0) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 41 /* 0x29 */;
        }
      else if ((which_alternative == 1) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 77 /* 0x4d */;
        }
      else if ((which_alternative == 0) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 96 /* 0x60 */;
        }
      else
        {
	  return 111 /* 0x6f */;
        }

    case 905:  /* *p extendsidi2 */
    case 134:  /* extendsidi2 */
      extract_constrain_insn_cached (insn);
      if ((which_alternative == 1) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 11 /* 0xb */;
        }
      else if ((which_alternative == 0) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 41 /* 0x29 */;
        }
      else if ((which_alternative == 1) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 66 /* 0x42 */;
        }
      else if ((which_alternative == 0) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 96 /* 0x60 */;
        }
      else
        {
	  return 111 /* 0x6f */;
        }

    case 904:  /* *p extendhidi2 */
    case 903:  /* *p extendqidi2 */
    case 133:  /* extendhidi2 */
    case 132:  /* extendqidi2 */
      extract_constrain_insn_cached (insn);
      if (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 41 /* 0x29 */;
        }
      else
        {
	  return 96 /* 0x60 */;
        }

    case 898:  /* *p movti_internal */
    case 126:  /* movti_internal */
      extract_constrain_insn_cached (insn);
      if ((which_alternative == 2) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 8;
        }
      else if ((which_alternative != 2) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 51 /* 0x33 */;
        }
      else if ((which_alternative == 2) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 63 /* 0x3f */;
        }
      else if ((which_alternative != 2) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 106 /* 0x6a */;
        }
      else
        {
	  return 111 /* 0x6f */;
        }

    case 1223:  /* *p *vec_extractv2sf_1_be */
    case 1222:  /* *p *vec_extractv2sf_1_le */
    case 1221:  /* *p *vec_extractv2sf_0_be */
    case 1220:  /* *p *vec_extractv2sf_0_le */
    case 1118:  /* *p builtin_setjmp_receiver */
    case 1117:  /* *p nonlocal_goto_receiver */
    case 1090:  /* *p *seq_internal */
    case 1089:  /* *p *sne_internal */
    case 1072:  /* *p *rotlti3_internal */
    case 1071:  /* *p *lshrti3_internal */
    case 1070:  /* *p *ashrti3_internal */
    case 1069:  /* *p *ashlti3_internal */
    case 1064:  /* *p *shladd_elim */
    case 1060:  /* *p *rotrsi3_internal */
    case 995:  /* *p negti2 */
    case 994:  /* *p *umulditi3_internal */
    case 993:  /* *p *mulditi3_internal */
    case 992:  /* *p subti3 */
    case 991:  /* *p addti3 */
    case 984:  /* *p *madddi4_elim */
    case 934:  /* *p shift_mix4left */
    case 894:  /* *p *load_tprel_ie */
    case 888:  /* *p *load_dtprel_gd */
    case 884:  /* *p load_dtpmod */
    case 479:  /* *vec_extractv2sf_1_be */
    case 478:  /* *vec_extractv2sf_1_le */
    case 477:  /* *vec_extractv2sf_0_be */
    case 476:  /* *vec_extractv2sf_0_le */
    case 379:  /* probe_stack_range */
    case 370:  /* builtin_setjmp_receiver */
    case 369:  /* nonlocal_goto_receiver */
    case 353:  /* set_bsp */
    case 325:  /* *cmovsi_internal */
    case 323:  /* *cmovdi_internal */
    case 322:  /* *seq_internal */
    case 321:  /* *sne_internal */
    case 301:  /* *rotlti3_internal */
    case 300:  /* *lshrti3_internal */
    case 299:  /* *ashrti3_internal */
    case 298:  /* *ashlti3_internal */
    case 293:  /* *shladd_elim */
    case 289:  /* *rotrsi3_internal */
    case 224:  /* negti2 */
    case 223:  /* *umulditi3_internal */
    case 222:  /* *mulditi3_internal */
    case 221:  /* subti3 */
    case 220:  /* addti3 */
    case 213:  /* *madddi4_elim */
    case 163:  /* shift_mix4left */
    case 131:  /* *movtf_internal */
    case 122:  /* *load_tprel_ie */
    case 116:  /* *load_dtprel_gd */
    case 112:  /* load_dtpmod */
      extract_constrain_insn_cached (insn);
      if (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 51 /* 0x33 */;
        }
      else
        {
	  return 106 /* 0x6a */;
        }

    case 892:  /* *p *load_tprel64 */
    case 886:  /* *p *load_dtprel64 */
    case 880:  /* *p *gprel64_offset */
    case 120:  /* *load_tprel64 */
    case 114:  /* *load_dtprel64 */
    case 108:  /* *gprel64_offset */
      extract_constrain_insn_cached (insn);
      if (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 24 /* 0x18 */;
        }
      else
        {
	  return 79 /* 0x4f */;
        }

    case 1121:  /* *p *ptr_extend_plus_2 */
    case 1120:  /* *p ptr_extend_plus_imm */
    case 1119:  /* *p ptr_extend */
    case 1063:  /* *p *shladd */
    case 987:  /* *p negdi2 */
    case 981:  /* *p *subdi3_minus1 */
    case 980:  /* *p subdi3 */
    case 979:  /* *p *adddi3_plus1_alt */
    case 978:  /* *p *adddi3_plus1 */
    case 977:  /* *p adddi3 */
    case 976:  /* *p negsi2 */
    case 973:  /* *p *subsi3_minus1 */
    case 972:  /* *p subsi3 */
    case 971:  /* *p *addsi3_shladd */
    case 970:  /* *p *addsi3_plus1_alt */
    case 969:  /* *p *addsi3_plus1 */
    case 968:  /* *p addsi3 */
    case 932:  /* *p *shladdp4_internal */
    case 897:  /* *p *add_tprel22 */
    case 896:  /* *p *add_tprel14 */
    case 895:  /* *p *load_ltoff_tprel */
    case 893:  /* *p *load_tprel22 */
    case 891:  /* *p *add_dtprel22 */
    case 890:  /* *p *add_dtprel14 */
    case 889:  /* *p *load_ltoff_dtprel */
    case 887:  /* *p *load_dtprel22 */
    case 885:  /* *p *load_ltoff_dtpmod */
    case 882:  /* *p *load_symptr_high */
    case 881:  /* *p *movdi_ret_addr */
    case 879:  /* *p load_gprel */
    case 878:  /* *p *load_fptr_internal1 */
    case 376:  /* *ptr_extend_plus_2 */
    case 375:  /* ptr_extend_plus_imm */
    case 374:  /* ptr_extend */
    case 345:  /* epilogue_deallocate_stack_pr */
    case 344:  /* epilogue_deallocate_stack */
    case 343:  /* prologue_allocate_stack_pr */
    case 342:  /* prologue_allocate_stack */
    case 328:  /* *cond_opsi2_internal_b */
    case 327:  /* *cond_opsi2_internal */
    case 292:  /* *shladd */
    case 216:  /* negdi2 */
    case 210:  /* *subdi3_minus1 */
    case 209:  /* subdi3 */
    case 208:  /* *adddi3_plus1_alt */
    case 207:  /* *adddi3_plus1 */
    case 206:  /* adddi3 */
    case 205:  /* negsi2 */
    case 202:  /* *subsi3_minus1 */
    case 201:  /* subsi3 */
    case 200:  /* *addsi3_shladd */
    case 199:  /* *addsi3_plus1_alt */
    case 198:  /* *addsi3_plus1 */
    case 197:  /* addsi3 */
    case 161:  /* *shladdp4_internal */
    case 125:  /* *add_tprel22 */
    case 124:  /* *add_tprel14 */
    case 123:  /* *load_ltoff_tprel */
    case 121:  /* *load_tprel22 */
    case 119:  /* *add_dtprel22 */
    case 118:  /* *add_dtprel14 */
    case 117:  /* *load_ltoff_dtprel */
    case 115:  /* *load_dtprel22 */
    case 113:  /* *load_ltoff_dtpmod */
    case 110:  /* *load_symptr_high */
    case 109:  /* *movdi_ret_addr */
    case 107:  /* load_gprel */
    case 106:  /* *load_fptr_internal1 */
      extract_constrain_insn_cached (insn);
      if (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 17 /* 0x11 */;
        }
      else
        {
	  return 72 /* 0x48 */;
        }

    case 876:  /* *p speculation_check_xf */
    case 104:  /* speculation_check_xf */
      extract_constrain_insn_cached (insn);
      if (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 43 /* 0x2b */;
        }
      else
        {
	  return 98 /* 0x62 */;
        }

    case 875:  /* *p speculation_check_df */
    case 874:  /* *p speculation_check_sf */
    case 103:  /* speculation_check_df */
    case 102:  /* speculation_check_sf */
      extract_constrain_insn_cached (insn);
      if ((which_alternative == 1) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 42 /* 0x2a */;
        }
      else if ((which_alternative == 0) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 43 /* 0x2b */;
        }
      else if ((which_alternative == 1) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 97 /* 0x61 */;
        }
      else if ((which_alternative == 0) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 98 /* 0x62 */;
        }
      else
        {
	  return 111 /* 0x6f */;
        }

    case 873:  /* *p speculation_check_di */
    case 101:  /* speculation_check_di */
      extract_constrain_insn_cached (insn);
      if ((which_alternative == 0) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 42 /* 0x2a */;
        }
      else if ((which_alternative == 1) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 43 /* 0x2b */;
        }
      else if ((which_alternative == 0) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 97 /* 0x61 */;
        }
      else if ((which_alternative == 1) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 98 /* 0x62 */;
        }
      else
        {
	  return 111 /* 0x6f */;
        }

    case 1123:  /* *p probe_stack_address */
    case 1114:  /* *p *trap */
    case 877:  /* *p speculation_check_ti */
    case 872:  /* *p speculation_check_si */
    case 871:  /* *p speculation_check_hi */
    case 870:  /* *p speculation_check_qi */
    case 869:  /* *p speculation_check_bi */
    case 378:  /* probe_stack_address */
    case 366:  /* *conditional_trap */
    case 365:  /* *trap */
    case 105:  /* speculation_check_ti */
    case 100:  /* speculation_check_si */
    case 99:  /* speculation_check_hi */
    case 98:  /* speculation_check_qi */
    case 97:  /* speculation_check_bi */
      extract_constrain_insn_cached (insn);
      if (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 42 /* 0x2a */;
        }
      else
        {
	  return 97 /* 0x61 */;
        }

    case 868:  /* *p advanced_load_check_nc_ti */
    case 867:  /* *p advanced_load_check_nc_xf */
    case 866:  /* *p advanced_load_check_nc_df */
    case 865:  /* *p advanced_load_check_nc_sf */
    case 864:  /* *p advanced_load_check_nc_di */
    case 863:  /* *p advanced_load_check_nc_si */
    case 862:  /* *p advanced_load_check_nc_hi */
    case 861:  /* *p advanced_load_check_nc_qi */
    case 860:  /* *p advanced_load_check_nc_bi */
    case 859:  /* *p advanced_load_check_clr_ti */
    case 858:  /* *p advanced_load_check_clr_xf */
    case 857:  /* *p advanced_load_check_clr_df */
    case 856:  /* *p advanced_load_check_clr_sf */
    case 855:  /* *p advanced_load_check_clr_di */
    case 854:  /* *p advanced_load_check_clr_si */
    case 853:  /* *p advanced_load_check_clr_hi */
    case 852:  /* *p advanced_load_check_clr_qi */
    case 851:  /* *p advanced_load_check_clr_bi */
    case 96:  /* advanced_load_check_nc_ti */
    case 95:  /* advanced_load_check_nc_xf */
    case 94:  /* advanced_load_check_nc_df */
    case 93:  /* advanced_load_check_nc_sf */
    case 92:  /* advanced_load_check_nc_di */
    case 91:  /* advanced_load_check_nc_si */
    case 90:  /* advanced_load_check_nc_hi */
    case 89:  /* advanced_load_check_nc_qi */
    case 88:  /* advanced_load_check_nc_bi */
    case 87:  /* advanced_load_check_clr_ti */
    case 86:  /* advanced_load_check_clr_xf */
    case 85:  /* advanced_load_check_clr_df */
    case 84:  /* advanced_load_check_clr_sf */
    case 83:  /* advanced_load_check_clr_di */
    case 82:  /* advanced_load_check_clr_si */
    case 81:  /* advanced_load_check_clr_hi */
    case 80:  /* advanced_load_check_clr_qi */
    case 79:  /* advanced_load_check_clr_bi */
      extract_constrain_insn_cached (insn);
      if (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 44 /* 0x2c */;
        }
      else
        {
	  return 99 /* 0x63 */;
        }

    case 844:  /* *p movti_nc */
    case 835:  /* *p movti_clr */
    case 72:  /* movti_nc */
    case 63:  /* movti_clr */
      extract_constrain_insn_cached (insn);
      if (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 9;
        }
      else
        {
	  return 64 /* 0x40 */;
        }

    case 843:  /* *p movxf_nc */
    case 834:  /* *p movxf_clr */
    case 71:  /* movxf_nc */
    case 62:  /* movxf_clr */
      extract_constrain_insn_cached (insn);
      if (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 7;
        }
      else
        {
	  return 62 /* 0x3e */;
        }

    case 842:  /* *p movdf_nc */
    case 841:  /* *p movsf_nc */
    case 833:  /* *p movdf_clr */
    case 832:  /* *p movsf_clr */
    case 70:  /* movdf_nc */
    case 69:  /* movsf_nc */
    case 61:  /* movdf_clr */
    case 60:  /* movsf_clr */
      extract_constrain_insn_cached (insn);
      if ((which_alternative == 0) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 7;
        }
      else if (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 23 /* 0x17 */;
        }
      else if (which_alternative == 0)
        {
	  return 62 /* 0x3e */;
        }
      else if (which_alternative == 1)
        {
	  return 78 /* 0x4e */;
        }
      else
        {
	  return 111 /* 0x6f */;
        }

    case 840:  /* *p movdi_nc */
    case 831:  /* *p movdi_clr */
    case 68:  /* movdi_nc */
    case 59:  /* movdi_clr */
      extract_constrain_insn_cached (insn);
      if ((which_alternative == 1) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 7;
        }
      else if (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 23 /* 0x17 */;
        }
      else if (which_alternative == 1)
        {
	  return 62 /* 0x3e */;
        }
      else if (which_alternative == 0)
        {
	  return 78 /* 0x4e */;
        }
      else
        {
	  return 111 /* 0x6f */;
        }

    case 850:  /* *p zero_extendsidi2_nc */
    case 849:  /* *p zero_extendhidi2_nc */
    case 848:  /* *p zero_extendqidi2_nc */
    case 847:  /* *p zero_extendsidi2_clr */
    case 846:  /* *p zero_extendhidi2_clr */
    case 845:  /* *p zero_extendqidi2_clr */
    case 839:  /* *p movsi_nc */
    case 838:  /* *p movhi_nc */
    case 837:  /* *p movqi_nc */
    case 836:  /* *p movbi_nc */
    case 830:  /* *p movsi_clr */
    case 829:  /* *p movhi_clr */
    case 828:  /* *p movqi_clr */
    case 827:  /* *p movbi_clr */
    case 78:  /* zero_extendsidi2_nc */
    case 77:  /* zero_extendhidi2_nc */
    case 76:  /* zero_extendqidi2_nc */
    case 75:  /* zero_extendsidi2_clr */
    case 74:  /* zero_extendhidi2_clr */
    case 73:  /* zero_extendqidi2_clr */
    case 67:  /* movsi_nc */
    case 66:  /* movhi_nc */
    case 65:  /* movqi_nc */
    case 64:  /* movbi_nc */
    case 58:  /* movsi_clr */
    case 57:  /* movhi_clr */
    case 56:  /* movqi_clr */
    case 55:  /* movbi_clr */
      extract_constrain_insn_cached (insn);
      if (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 23 /* 0x17 */;
        }
      else
        {
	  return 78 /* 0x4e */;
        }

    case 1105:  /* *p fr_restore */
    case 798:  /* *p movxf_speculative */
    case 351:  /* fr_restore */
    case 26:  /* movxf_speculative */
      extract_constrain_insn_cached (insn);
      if (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 5;
        }
      else
        {
	  return 60 /* 0x3c */;
        }

    case 797:  /* *p movdf_speculative */
    case 796:  /* *p movsf_speculative */
    case 25:  /* movdf_speculative */
    case 24:  /* movsf_speculative */
      extract_constrain_insn_cached (insn);
      if ((which_alternative == 0) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 5;
        }
      else if ((which_alternative == 1) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 22 /* 0x16 */;
        }
      else if ((which_alternative == 0) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 60 /* 0x3c */;
        }
      else if ((which_alternative == 1) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 77 /* 0x4d */;
        }
      else
        {
	  return 111 /* 0x6f */;
        }

    case 795:  /* *p movdi_speculative */
    case 23:  /* movdi_speculative */
      extract_constrain_insn_cached (insn);
      if ((which_alternative == 1) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 5;
        }
      else if ((which_alternative == 0) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 22 /* 0x16 */;
        }
      else if ((which_alternative == 1) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 60 /* 0x3c */;
        }
      else if ((which_alternative == 0) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 77 /* 0x4d */;
        }
      else
        {
	  return 111 /* 0x6f */;
        }

    case 820:  /* *p movti_speculative_a */
    case 811:  /* *p movti_speculative_advanced */
    case 799:  /* *p movti_speculative */
    case 787:  /* *p movti_advanced */
    case 48:  /* movti_speculative_a */
    case 39:  /* movti_speculative_advanced */
    case 27:  /* movti_speculative */
    case 15:  /* movti_advanced */
      extract_constrain_insn_cached (insn);
      if (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 8;
        }
      else
        {
	  return 63 /* 0x3f */;
        }

    case 819:  /* *p movxf_speculative_a */
    case 810:  /* *p movxf_speculative_advanced */
    case 786:  /* *p movxf_advanced */
    case 47:  /* movxf_speculative_a */
    case 38:  /* movxf_speculative_advanced */
    case 14:  /* movxf_advanced */
      extract_constrain_insn_cached (insn);
      if (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 6;
        }
      else
        {
	  return 61 /* 0x3d */;
        }

    case 818:  /* *p movdf_speculative_a */
    case 817:  /* *p movsf_speculative_a */
    case 809:  /* *p movdf_speculative_advanced */
    case 808:  /* *p movsf_speculative_advanced */
    case 785:  /* *p movdf_advanced */
    case 784:  /* *p movsf_advanced */
    case 46:  /* movdf_speculative_a */
    case 45:  /* movsf_speculative_a */
    case 37:  /* movdf_speculative_advanced */
    case 36:  /* movsf_speculative_advanced */
    case 13:  /* movdf_advanced */
    case 12:  /* movsf_advanced */
      extract_constrain_insn_cached (insn);
      if ((which_alternative == 0) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 6;
        }
      else if ((which_alternative == 1) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 22 /* 0x16 */;
        }
      else if ((which_alternative == 0) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 61 /* 0x3d */;
        }
      else if ((which_alternative == 1) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 77 /* 0x4d */;
        }
      else
        {
	  return 111 /* 0x6f */;
        }

    case 816:  /* *p movdi_speculative_a */
    case 807:  /* *p movdi_speculative_advanced */
    case 783:  /* *p movdi_advanced */
    case 44:  /* movdi_speculative_a */
    case 35:  /* movdi_speculative_advanced */
    case 11:  /* movdi_advanced */
      extract_constrain_insn_cached (insn);
      if ((which_alternative == 1) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 6;
        }
      else if ((which_alternative == 0) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 22 /* 0x16 */;
        }
      else if ((which_alternative == 1) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 61 /* 0x3d */;
        }
      else if ((which_alternative == 0) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 77 /* 0x4d */;
        }
      else
        {
	  return 111 /* 0x6f */;
        }

    case 1103:  /* *p gr_restore_internal */
    case 883:  /* *p *load_symptr_low */
    case 826:  /* *p zero_extendsidi2_speculative_a */
    case 825:  /* *p zero_extendhidi2_speculative_a */
    case 824:  /* *p zero_extendqidi2_speculative_a */
    case 823:  /* *p zero_extendsidi2_speculative_advanced */
    case 822:  /* *p zero_extendhidi2_speculative_advanced */
    case 821:  /* *p zero_extendqidi2_speculative_advanced */
    case 815:  /* *p movsi_speculative_a */
    case 814:  /* *p movhi_speculative_a */
    case 813:  /* *p movqi_speculative_a */
    case 812:  /* *p movbi_speculative_a */
    case 806:  /* *p movsi_speculative_advanced */
    case 805:  /* *p movhi_speculative_advanced */
    case 804:  /* *p movqi_speculative_advanced */
    case 803:  /* *p movbi_speculative_advanced */
    case 802:  /* *p zero_extendsidi2_speculative */
    case 801:  /* *p zero_extendhidi2_speculative */
    case 800:  /* *p zero_extendqidi2_speculative */
    case 794:  /* *p movsi_speculative */
    case 793:  /* *p movhi_speculative */
    case 792:  /* *p movqi_speculative */
    case 791:  /* *p movbi_speculative */
    case 790:  /* *p zero_extendsidi2_advanced */
    case 789:  /* *p zero_extendhidi2_advanced */
    case 788:  /* *p zero_extendqidi2_advanced */
    case 782:  /* *p movsi_advanced */
    case 781:  /* *p movhi_advanced */
    case 780:  /* *p movqi_advanced */
    case 779:  /* *p movbi_advanced */
    case 349:  /* gr_restore_internal */
    case 111:  /* *load_symptr_low */
    case 54:  /* zero_extendsidi2_speculative_a */
    case 53:  /* zero_extendhidi2_speculative_a */
    case 52:  /* zero_extendqidi2_speculative_a */
    case 51:  /* zero_extendsidi2_speculative_advanced */
    case 50:  /* zero_extendhidi2_speculative_advanced */
    case 49:  /* zero_extendqidi2_speculative_advanced */
    case 43:  /* movsi_speculative_a */
    case 42:  /* movhi_speculative_a */
    case 41:  /* movqi_speculative_a */
    case 40:  /* movbi_speculative_a */
    case 34:  /* movsi_speculative_advanced */
    case 33:  /* movhi_speculative_advanced */
    case 32:  /* movqi_speculative_advanced */
    case 31:  /* movbi_speculative_advanced */
    case 30:  /* zero_extendsidi2_speculative */
    case 29:  /* zero_extendhidi2_speculative */
    case 28:  /* zero_extendqidi2_speculative */
    case 22:  /* movsi_speculative */
    case 21:  /* movhi_speculative */
    case 20:  /* movqi_speculative */
    case 19:  /* movbi_speculative */
    case 18:  /* zero_extendsidi2_advanced */
    case 17:  /* zero_extendhidi2_advanced */
    case 16:  /* zero_extendqidi2_advanced */
    case 10:  /* movsi_advanced */
    case 9:  /* movhi_advanced */
    case 8:  /* movqi_advanced */
    case 7:  /* movbi_advanced */
      extract_constrain_insn_cached (insn);
      if (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 22 /* 0x16 */;
        }
      else
        {
	  return 77 /* 0x4d */;
        }

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    case 1:  /* movcci */
    case 2:  /* movbi */
    case 3:  /* movqi_internal */
    case 4:  /* movhi_internal */
    case 5:  /* movsi_internal */
    case 6:  /* movdi_internal */
    case 127:  /* movsf_internal */
    case 128:  /* movdf_internal */
    case 129:  /* movxf_internal */
    case 130:  /* *movrf_internal */
    case 137:  /* zero_extendsidi2 */
    case 167:  /* andbi3 */
    case 168:  /* *andcmbi3 */
    case 169:  /* iorbi3 */
    case 171:  /* one_cmplbi2 */
    case 288:  /* *ashlsi3_internal */
    case 291:  /* ashldi3 */
    case 380:  /* *movv8qi_internal */
    case 381:  /* *movv4hi_internal */
    case 382:  /* *movv2si_internal */
    case 458:  /* *movv2sf_internal */
    case 774:  /* *p movbi */
    case 775:  /* *p movqi_internal */
    case 776:  /* *p movhi_internal */
    case 777:  /* *p movsi_internal */
    case 778:  /* *p movdi_internal */
    case 899:  /* *p movsf_internal */
    case 900:  /* *p movdf_internal */
    case 901:  /* *p movxf_internal */
    case 902:  /* *p *movrf_internal */
    case 908:  /* *p zero_extendsidi2 */
    case 938:  /* *p andbi3 */
    case 939:  /* *p *andcmbi3 */
    case 940:  /* *p iorbi3 */
    case 942:  /* *p one_cmplbi2 */
    case 1059:  /* *p *ashlsi3_internal */
    case 1062:  /* *p ashldi3 */
    case 1124:  /* *p *movv8qi_internal */
    case 1125:  /* *p *movv4hi_internal */
    case 1126:  /* *p *movv2si_internal */
    case 1202:  /* *p *movv2sf_internal */
      extract_constrain_insn_cached (insn);
      if (((cached_itanium_class = get_attr_itanium_class (insn)) == ITANIUM_CLASS_STOP_BIT) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 0;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_BR) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 1;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_SCALL) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 2;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_FCMP) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 3;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_FCVTFX) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 4;
        }
      else if ((((cached_itanium_class == ITANIUM_CLASS_FLD) && ((cached_data_speculative = get_attr_data_speculative (insn)) == DATA_SPECULATIVE_NO)) && ((cached_check_load = get_attr_check_load (insn)) == CHECK_LOAD_NO)) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 5;
        }
      else if (((cached_itanium_class == ITANIUM_CLASS_FLD) && ((cached_data_speculative = get_attr_data_speculative (insn)) == DATA_SPECULATIVE_YES)) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 6;
        }
      else if (((cached_itanium_class == ITANIUM_CLASS_FLD) && ((cached_check_load = get_attr_check_load (insn)) == CHECK_LOAD_YES)) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 7;
        }
      else if (((cached_itanium_class == ITANIUM_CLASS_FLDP) && ((cached_check_load = get_attr_check_load (insn)) == CHECK_LOAD_NO)) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 8;
        }
      else if (((cached_itanium_class == ITANIUM_CLASS_FLDP) && ((cached_check_load = get_attr_check_load (insn)) == CHECK_LOAD_YES)) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 9;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_FMAC) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 10 /* 0xa */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_FMISC) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 11 /* 0xb */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_FRAR_I) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 12 /* 0xc */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_FRAR_M) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 13 /* 0xd */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_FRBR) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 14 /* 0xe */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_FRFR) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 15 /* 0xf */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_FRPR) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 16 /* 0x10 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_IALU) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 17 /* 0x11 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_ICMP) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 18 /* 0x12 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_ILOG) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 19 /* 0x13 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_MMALUA) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 20 /* 0x14 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_ISHF) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 21 /* 0x15 */;
        }
      else if (((cached_itanium_class == ITANIUM_CLASS_LD) && ((cached_check_load = get_attr_check_load (insn)) == CHECK_LOAD_NO)) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 22 /* 0x16 */;
        }
      else if (((cached_check_load = get_attr_check_load (insn)) == CHECK_LOAD_YES) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 23 /* 0x17 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_LONG_I) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 24 /* 0x18 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_MMMUL) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 25 /* 0x19 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_MMSHF) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 26 /* 0x1a */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_MMSHFI) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 27 /* 0x1b */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_RSE_M) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 28 /* 0x1c */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_SEM) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 29 /* 0x1d */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_STF) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 30 /* 0x1e */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_ST) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 31 /* 0x1f */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_SYST_M0) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 32 /* 0x20 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_SYST_M) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 33 /* 0x21 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_TBIT) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 34 /* 0x22 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_TOAR_I) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 35 /* 0x23 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_TOAR_M) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 36 /* 0x24 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_TOBR) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 37 /* 0x25 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_TOFR) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 38 /* 0x26 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_TOPR) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 39 /* 0x27 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_XMPY) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 40 /* 0x28 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_XTD) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 41 /* 0x29 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_CHK_S_I) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 42 /* 0x2a */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_CHK_S_F) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 43 /* 0x2b */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_CHK_A) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 44 /* 0x2c */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_LFETCH) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 45 /* 0x2d */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_NOP_M) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 46 /* 0x2e */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_NOP_B) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 47 /* 0x2f */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_NOP_I) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 48 /* 0x30 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_NOP_F) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 49 /* 0x31 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_NOP_X) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 50 /* 0x32 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_UNKNOWN) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 51 /* 0x33 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_NOP) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 52 /* 0x34 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_IGNORE) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 53 /* 0x35 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_PRE_CYCLE) && (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p))))
        {
	  return 54 /* 0x36 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_STOP_BIT) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 55 /* 0x37 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_BR) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 56 /* 0x38 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_SCALL) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 57 /* 0x39 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_FCMP) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 58 /* 0x3a */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_FCVTFX) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 59 /* 0x3b */;
        }
      else if ((((cached_itanium_class == ITANIUM_CLASS_FLD) && ((cached_data_speculative = get_attr_data_speculative (insn)) == DATA_SPECULATIVE_NO)) && (cached_check_load == CHECK_LOAD_NO)) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 60 /* 0x3c */;
        }
      else if (((cached_itanium_class == ITANIUM_CLASS_FLD) && ((cached_data_speculative = get_attr_data_speculative (insn)) == DATA_SPECULATIVE_YES)) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 61 /* 0x3d */;
        }
      else if (((cached_itanium_class == ITANIUM_CLASS_FLD) && (cached_check_load == CHECK_LOAD_YES)) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 62 /* 0x3e */;
        }
      else if (((cached_itanium_class == ITANIUM_CLASS_FLDP) && (cached_check_load == CHECK_LOAD_NO)) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 63 /* 0x3f */;
        }
      else if (((cached_itanium_class == ITANIUM_CLASS_FLDP) && (cached_check_load == CHECK_LOAD_YES)) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 64 /* 0x40 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_FMAC) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 65 /* 0x41 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_FMISC) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 66 /* 0x42 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_FRAR_I) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 67 /* 0x43 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_FRAR_M) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 68 /* 0x44 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_FRBR) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 69 /* 0x45 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_FRFR) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 70 /* 0x46 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_FRPR) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 71 /* 0x47 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_IALU) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 72 /* 0x48 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_ICMP) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 73 /* 0x49 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_ILOG) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 74 /* 0x4a */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_MMALUA) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 75 /* 0x4b */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_ISHF) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 76 /* 0x4c */;
        }
      else if (((cached_itanium_class == ITANIUM_CLASS_LD) && (cached_check_load == CHECK_LOAD_NO)) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 77 /* 0x4d */;
        }
      else if (((cached_itanium_class == ITANIUM_CLASS_LD) && (cached_check_load == CHECK_LOAD_YES)) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 78 /* 0x4e */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_LONG_I) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 79 /* 0x4f */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_MMMUL) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 80 /* 0x50 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_MMSHF) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 81 /* 0x51 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_MMSHFI) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 82 /* 0x52 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_RSE_M) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 83 /* 0x53 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_SEM) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 84 /* 0x54 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_STF) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 85 /* 0x55 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_ST) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 86 /* 0x56 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_SYST_M0) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 87 /* 0x57 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_SYST_M) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 88 /* 0x58 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_TBIT) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 89 /* 0x59 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_TOAR_I) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 90 /* 0x5a */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_TOAR_M) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 91 /* 0x5b */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_TOBR) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 92 /* 0x5c */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_TOFR) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 93 /* 0x5d */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_TOPR) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 94 /* 0x5e */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_XMPY) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 95 /* 0x5f */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_XTD) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 96 /* 0x60 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_CHK_S_I) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 97 /* 0x61 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_CHK_S_F) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 98 /* 0x62 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_CHK_A) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 99 /* 0x63 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_LFETCH) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 100 /* 0x64 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_NOP_M) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 101 /* 0x65 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_NOP_B) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 102 /* 0x66 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_NOP_I) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 103 /* 0x67 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_NOP_F) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 104 /* 0x68 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_NOP_X) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 105 /* 0x69 */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_UNKNOWN) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 106 /* 0x6a */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_NOP) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 107 /* 0x6b */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_IGNORE) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 108 /* 0x6c */;
        }
      else if ((cached_itanium_class == ITANIUM_CLASS_PRE_CYCLE) && (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 109 /* 0x6d */;
        }
      else
        {
	  return 111 /* 0x6f */;
        }

    default:
      extract_constrain_insn_cached (insn);
      if (! (
#line 713 "../../gcc-9.2.1-20190827/gcc/config/ia64/itanium2.md"
(bundling_p)))
        {
	  return 10 /* 0xa */;
        }
      else
        {
	  return 65 /* 0x41 */;
        }

    }
}

