/* Generated automatically by the program `genattrtab'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "alias.h"
#include "options.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "insn-attr.h"
#include "memmodel.h"
#include "tm_p.h"
#include "insn-config.h"
#include "recog.h"
#include "regs.h"
#include "real.h"
#include "output.h"
#include "toplev.h"
#include "flags.h"
#include "emit-rtl.h"

#define operands recog_data.operand

int
internal_dfa_insn_code (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  enum attr_m32r_pipeline cached_m32r_pipeline ATTRIBUTE_UNUSED;
  enum attr_insn_size cached_insn_size ATTRIBUTE_UNUSED;
  enum attr_type cached_type ATTRIBUTE_UNUSED;
  enum attr_cpu cached_cpu ATTRIBUTE_UNUSED;

  switch (recog_memoized (insn))
    {
    case 41:  /* cmp_ltusi_insn */
    case 40:  /* cmp_ltsi_insn */
    case 32:  /* xorsi3 */
    case 31:  /* iorsi3 */
    case 30:  /* andsi3 */
      extract_constrain_insn_cached (insn);
      if ((get_attr_m32r_pipeline (insn) == M32R_PIPELINE_EITHER) && (which_alternative == 0))
        {
	  return 2;
        }
      else if ((which_alternative == 1) && (! (
#line 71 "../../gcc-9.2.1-20190827/gcc/config/m32r/m32r.md"
(TARGET_M32RX))) && (! (
#line 73 "../../gcc-9.2.1-20190827/gcc/config/m32r/m32r.md"
(TARGET_M32R2))))
        {
	  return 3;
        }
      else if (which_alternative == 1)
        {
	  return 4;
        }
      else
        {
	  return 10 /* 0xa */;
        }

    case 25:  /* mulsi3 */
      extract_constrain_insn_cached (insn);
      if ((
#line 71 "../../gcc-9.2.1-20190827/gcc/config/m32r/m32r.md"
(TARGET_M32RX)) || (
#line 73 "../../gcc-9.2.1-20190827/gcc/config/m32r/m32r.md"
(TARGET_M32R2)))
        {
	  return 1;
        }
      else
        {
	  return 2;
        }

    case 68:  /* nop */
    case 34:  /* one_cmplsi2 */
    case 33:  /* negsi2 */
    case 23:  /* *sub_carry */
    case 21:  /* subsi3 */
    case 20:  /* *add_carry */
    case 19:  /* *clear_c */
      return 2;

    case 17:  /* addsi3 */
      extract_constrain_insn_cached (insn);
      if ((get_attr_m32r_pipeline (insn) == M32R_PIPELINE_EITHER) && (((1ULL << which_alternative) & 0x3ULL)))
        {
	  return 2;
        }
      else if ((which_alternative == 2) && (! (
#line 71 "../../gcc-9.2.1-20190827/gcc/config/m32r/m32r.md"
(TARGET_M32RX))) && (! (
#line 73 "../../gcc-9.2.1-20190827/gcc/config/m32r/m32r.md"
(TARGET_M32R2))))
        {
	  return 3;
        }
      else if (which_alternative == 2)
        {
	  return 4;
        }
      else
        {
	  return 10 /* 0xa */;
        }

    case 10:  /* *movdf_insn */
      extract_constrain_insn_cached (insn);
      if (((! (
#line 71 "../../gcc-9.2.1-20190827/gcc/config/m32r/m32r.md"
(TARGET_M32RX))) && (! (
#line 73 "../../gcc-9.2.1-20190827/gcc/config/m32r/m32r.md"
(TARGET_M32R2)))) && (which_alternative != 2))
        {
	  return 3;
        }
      else if (which_alternative != 2)
        {
	  return 4;
        }
      else if ((! (
#line 71 "../../gcc-9.2.1-20190827/gcc/config/m32r/m32r.md"
(TARGET_M32RX))) && (! (
#line 73 "../../gcc-9.2.1-20190827/gcc/config/m32r/m32r.md"
(TARGET_M32R2))))
        {
	  return 7;
        }
      else
        {
	  return 8;
        }

    case 8:  /* *movdi_insn */
      extract_constrain_insn_cached (insn);
      if (((! (
#line 71 "../../gcc-9.2.1-20190827/gcc/config/m32r/m32r.md"
(TARGET_M32RX))) && (! (
#line 73 "../../gcc-9.2.1-20190827/gcc/config/m32r/m32r.md"
(TARGET_M32R2)))) && (which_alternative != 3))
        {
	  return 3;
        }
      else if (which_alternative != 3)
        {
	  return 4;
        }
      else if ((! (
#line 71 "../../gcc-9.2.1-20190827/gcc/config/m32r/m32r.md"
(TARGET_M32RX))) && (! (
#line 73 "../../gcc-9.2.1-20190827/gcc/config/m32r/m32r.md"
(TARGET_M32R2))))
        {
	  return 7;
        }
      else
        {
	  return 8;
        }

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    case 1:  /* *movqi_insn */
    case 2:  /* *movhi_insn */
    case 3:  /* *movsi_insn */
    case 9:  /* *movsf_insn */
    case 11:  /* zero_extendqihi2 */
    case 12:  /* zero_extendqisi2 */
    case 13:  /* zero_extendhisi2 */
    case 14:  /* extendqihi2 */
    case 15:  /* extendqisi2 */
    case 16:  /* extendhisi2 */
    case 35:  /* ashlsi3 */
    case 36:  /* ashrsi3 */
    case 37:  /* lshrsi3 */
      if (((cached_m32r_pipeline = get_attr_m32r_pipeline (insn)) == M32R_PIPELINE_O) && ((cached_insn_size = get_attr_insn_size (insn)) == INSN_SIZE_SHORT) && (! ((cached_type = get_attr_type (insn)) == TYPE_LOAD2)))
        {
	  return 0;
        }
      else if ((cached_m32r_pipeline == M32R_PIPELINE_S) && ((cached_insn_size = get_attr_insn_size (insn)) == INSN_SIZE_SHORT) && (! ((cached_type = get_attr_type (insn)) == TYPE_LOAD2)))
        {
	  return 1;
        }
      else if ((cached_m32r_pipeline == M32R_PIPELINE_EITHER) && ((cached_insn_size = get_attr_insn_size (insn)) == INSN_SIZE_SHORT) && (! ((cached_type = get_attr_type (insn)) == TYPE_LOAD2)))
        {
	  return 2;
        }
      else if (((cached_cpu = get_attr_cpu (insn)) == CPU_M32R) && ((cached_insn_size = get_attr_insn_size (insn)) == INSN_SIZE_LONG) && (! (((cached_type = get_attr_type (insn)) == TYPE_LOAD4) || (cached_type == TYPE_LOAD8))))
        {
	  return 3;
        }
      else if ((cached_m32r_pipeline == M32R_PIPELINE_LONG) && ((cached_insn_size = get_attr_insn_size (insn)) == INSN_SIZE_LONG) && (! (((cached_type = get_attr_type (insn)) == TYPE_LOAD4) || (cached_type == TYPE_LOAD8))))
        {
	  return 4;
        }
      else if ((cached_m32r_pipeline == M32R_PIPELINE_O) && ((cached_insn_size = get_attr_insn_size (insn)) == INSN_SIZE_SHORT) && ((cached_type = get_attr_type (insn)) == TYPE_LOAD2))
        {
	  return 5;
        }
      else if ((cached_m32r_pipeline == M32R_PIPELINE_EITHER) && ((cached_insn_size = get_attr_insn_size (insn)) == INSN_SIZE_SHORT) && ((cached_type = get_attr_type (insn)) == TYPE_LOAD2))
        {
	  return 6;
        }
      else if ((cached_cpu == CPU_M32R) && ((cached_insn_size = get_attr_insn_size (insn)) == INSN_SIZE_LONG) && (((cached_type = get_attr_type (insn)) == TYPE_LOAD4) || (cached_type == TYPE_LOAD8)))
        {
	  return 7;
        }
      else if ((cached_m32r_pipeline == M32R_PIPELINE_LONG) && (((cached_type = get_attr_type (insn)) == TYPE_LOAD4) || (cached_type == TYPE_LOAD8)))
        {
	  return 8;
        }
      else
        {
	  return 10 /* 0xa */;
        }

    default:
      extract_constrain_insn_cached (insn);
      if ((! (
#line 71 "../../gcc-9.2.1-20190827/gcc/config/m32r/m32r.md"
(TARGET_M32RX))) && (! (
#line 73 "../../gcc-9.2.1-20190827/gcc/config/m32r/m32r.md"
(TARGET_M32R2))))
        {
	  return 3;
        }
      else
        {
	  return 4;
        }

    }
}

