/* Generated automatically by the program `genattrtab'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "alias.h"
#include "options.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "insn-attr.h"
#include "memmodel.h"
#include "tm_p.h"
#include "insn-config.h"
#include "recog.h"
#include "regs.h"
#include "real.h"
#include "output.h"
#include "toplev.h"
#include "flags.h"
#include "emit-rtl.h"

#define operands recog_data.operand

int
internal_dfa_insn_code (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  enum attr_tune_arc700 cached_tune_arc700 ATTRIBUTE_UNUSED;
  enum attr_type cached_type ATTRIBUTE_UNUSED;

  switch (recog_memoized (insn))
    {
    case 424:  /* vld32_insn */
    case 423:  /* vld64_insn */
    case 422:  /* vld64w_insn */
    case 421:  /* vld32wl_insn */
    case 420:  /* vld32wh_insn */
    case 396:  /* vmovw_insn */
    case 394:  /* vd6tapf_insn */
    case 392:  /* vmvw_insn */
      return 66 /* 0x42 */;

    case 411:  /* vupsbw_insn */
    case 409:  /* vupbw_insn */
    case 407:  /* vexch4_insn */
    case 406:  /* vexch2_insn */
    case 405:  /* vexch1_insn */
    case 398:  /* vsr8_insn */
    case 390:  /* vsr8i_insn */
    case 388:  /* vasrrpwbi_insn */
    case 387:  /* vasrpwbi_insn */
    case 385:  /* vasrsrwi_insn */
    case 384:  /* vasrrwi_insn */
    case 381:  /* vbmulw_insn */
    case 380:  /* vbmulfw_insn */
    case 370:  /* vmrb_insn */
    case 369:  /* vmr7w_insn */
    case 367:  /* vmr6w_insn */
    case 365:  /* vmr5w_insn */
    case 363:  /* vmr4w_insn */
    case 361:  /* vmr3w_insn */
    case 359:  /* vmr2w_insn */
    case 357:  /* vmr1w_insn */
    case 344:  /* vsummw_insn */
    case 341:  /* vmulw_insn */
    case 340:  /* vmulfw_insn */
      return 64 /* 0x40 */;

    case 404:  /* vsignw_insn */
    case 403:  /* vaddsuw_insn */
    case 402:  /* vabsw_insn */
    case 399:  /* vasrw_insn */
    case 397:  /* vmovzw_insn */
    case 393:  /* vmvzw_insn */
    case 386:  /* vasrwi_insn */
    case 383:  /* vbsubw_insn */
    case 382:  /* vbrsubw_insn */
    case 378:  /* vbminw_insn */
    case 377:  /* vbmaxw_insn */
    case 376:  /* vbaddw_insn */
    case 355:  /* vnew_insn */
    case 354:  /* vltw_insn */
    case 353:  /* vlew_insn */
    case 352:  /* veqw_insn */
    case 350:  /* vxor_insn */
    case 349:  /* vor_insn */
    case 347:  /* vbic_insn */
    case 345:  /* vand_insn */
    case 343:  /* vsubw_insn */
    case 337:  /* vminw_insn */
    case 335:  /* vmaxw_insn */
    case 333:  /* vdifw_insn */
    case 331:  /* vavrb_insn */
    case 330:  /* vavb_insn */
    case 329:  /* vaddw_insn */
      return 63 /* 0x3f */;

    case 327:  /* movti_insn */
    case 326:  /* movv8hi_insn */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 1)
        {
	  return 62 /* 0x3e */;
        }
      else if (!((1ULL << which_alternative) & 0x3ULL))
        {
	  return 63 /* 0x3f */;
        }
      else
        {
	  return 65 /* 0x41 */;
        }

    case 427:  /* vinti_insn */
    case 426:  /* vst32_n_insn */
    case 425:  /* vst16_n_insn */
    case 419:  /* vendrec_insn */
    case 418:  /* vrecrun_insn */
    case 417:  /* vrun_insn */
    case 416:  /* vrec_insn */
    case 415:  /* vdowr_insn */
    case 414:  /* vdiwr_insn */
    case 413:  /* vdorun_insn */
    case 412:  /* vdirun_insn */
    case 325:  /* vst64_insn */
    case 324:  /* vst128_insn */
      return 62 /* 0x3e */;

    case 410:  /* vupsbaw_insn */
    case 408:  /* vupbaw_insn */
    case 401:  /* vabsaw_insn */
    case 400:  /* vsr8aw_insn */
    case 395:  /* vmovaw_insn */
    case 391:  /* vmvaw_insn */
    case 389:  /* vsr8awi_insn */
    case 379:  /* vbmulaw_insn */
    case 375:  /* vvc1ft_insn */
    case 374:  /* vvc1f_insn */
    case 373:  /* vh264fw_insn */
    case 372:  /* vh264ft_insn */
    case 371:  /* vh264f_insn */
    case 368:  /* vmr7aw_insn */
    case 366:  /* vmr6aw_insn */
    case 364:  /* vmr5aw_insn */
    case 362:  /* vmr4aw_insn */
    case 360:  /* vmr3aw_insn */
    case 358:  /* vmr2aw_insn */
    case 356:  /* vmr1aw_insn */
    case 351:  /* vxoraw_insn */
    case 348:  /* vbicaw_insn */
    case 346:  /* vandaw_insn */
    case 342:  /* vsubaw_insn */
    case 339:  /* vmulfaw_insn */
    case 338:  /* vmulaw_insn */
    case 336:  /* vminaw_insn */
    case 334:  /* vmaxaw_insn */
    case 332:  /* vdifaw_insn */
    case 328:  /* vaddaw_insn */
    case 323:  /* vld128_insn */
      return 65 /* 0x41 */;

    case 701:  /* *p divdf3 */
    case 302:  /* sqrtdf2 */
    case 301:  /* divdf3 */
      extract_constrain_insn_cached (insn);
      if ((
#line 27 "../../gcc-9.2.1-20190827/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 623 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 625 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 627 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 629 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 631 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (
#line 633 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X)))) || (((! (
#line 623 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 625 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 627 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 629 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 631 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (! (
#line 633 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X))) && ((
#line 635 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD)) || (
#line 636 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD_SLOW)))))))
        {
	  return 55 /* 0x37 */;
        }
      else
        {
	  return 68 /* 0x44 */;
        }

    case 696:  /* *p *divsf3_fpu */
    case 295:  /* sqrtsf2_fpu */
    case 294:  /* *divsf3_fpu */
      extract_constrain_insn_cached (insn);
      if ((
#line 27 "../../gcc-9.2.1-20190827/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 623 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 625 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 627 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 629 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 631 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (
#line 633 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X)))) || (((! (
#line 623 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 625 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 627 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 629 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 631 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (! (
#line 633 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X))) && ((
#line 635 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD)) || (
#line 636 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD_SLOW)))))))
        {
	  return 54 /* 0x36 */;
        }
      else
        {
	  return 68 /* 0x44 */;
        }

    case 695:  /* *p fnmadf4_fpu */
    case 694:  /* *p fmadf4_fpu */
    case 693:  /* *p fnmasf4_fpu */
    case 692:  /* *p fmasf4_fpu */
    case 293:  /* fnmadf4_fpu */
    case 292:  /* fmadf4_fpu */
    case 289:  /* fnmasf4_fpu */
    case 288:  /* fmasf4_fpu */
      extract_constrain_insn_cached (insn);
      if ((
#line 27 "../../gcc-9.2.1-20190827/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 623 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 625 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 627 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 629 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 631 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (
#line 633 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X)))) || (((! (
#line 623 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 625 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 627 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 629 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 631 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (! (
#line 633 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X))) && ((
#line 635 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD)) || (
#line 636 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD_SLOW)))))))
        {
	  return 53 /* 0x35 */;
        }
      else
        {
	  return 68 /* 0x44 */;
        }

    case 720:  /* *p fix_truncdfsi2 */
    case 719:  /* *p fixuns_truncdfsi2 */
    case 718:  /* *p floatunsdisf2 */
    case 717:  /* *p floatdisf2 */
    case 716:  /* *p truncdfsf2 */
    case 715:  /* *p fix_truncdfdi2 */
    case 714:  /* *p fixuns_truncdfdi2 */
    case 713:  /* *p floatunsdidf2 */
    case 712:  /* *p floatdidf2 */
    case 711:  /* *p fix_truncsfsi2_fpu */
    case 710:  /* *p fixuns_truncsfsi2 */
    case 709:  /* *p floatunssisf2 */
    case 708:  /* *p floatsisf2_fpu */
    case 707:  /* *p fix_truncsfdi2 */
    case 706:  /* *p fixuns_truncsfdi2 */
    case 705:  /* *p floatunssidf2 */
    case 704:  /* *p floatsidf2 */
    case 703:  /* *p extendsfdf2 */
    case 702:  /* *p *cmpdf_fpu */
    case 700:  /* *p *muldf3_fpu */
    case 699:  /* *p *subdf3_fpu */
    case 698:  /* *p *adddf3_fpu */
    case 697:  /* *p *cmpsf_fpu */
    case 691:  /* *p *mulsf3_fpu */
    case 690:  /* *p *subsf3_fpu */
    case 689:  /* *p *addsf3_fpu */
    case 322:  /* fix_truncdfsi2 */
    case 321:  /* fixuns_truncdfsi2 */
    case 320:  /* floatunsdisf2 */
    case 319:  /* floatdisf2 */
    case 318:  /* truncdfsf2 */
    case 317:  /* fix_truncdfdi2 */
    case 316:  /* fixuns_truncdfdi2 */
    case 315:  /* floatunsdidf2 */
    case 314:  /* floatdidf2 */
    case 313:  /* fix_truncsfsi2_fpu */
    case 312:  /* fixuns_truncsfsi2 */
    case 311:  /* floatunssisf2 */
    case 310:  /* floatsisf2_fpu */
    case 309:  /* fix_truncsfdi2 */
    case 308:  /* fixuns_truncsfdi2 */
    case 307:  /* floatunssidf2 */
    case 306:  /* floatsidf2 */
    case 305:  /* extendsfdf2 */
    case 304:  /* *cmpdf_fpu_uneq */
    case 303:  /* *cmpdf_fpu */
    case 300:  /* *muldf3_fpu */
    case 299:  /* *subdf3_fpu */
    case 298:  /* *adddf3_fpu */
    case 297:  /* *cmpsf_fpu_uneq */
    case 296:  /* *cmpsf_fpu */
    case 287:  /* *mulsf3_fpu */
    case 286:  /* *subsf3_fpu */
    case 285:  /* *addsf3_fpu */
      extract_constrain_insn_cached (insn);
      if ((
#line 27 "../../gcc-9.2.1-20190827/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 623 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 625 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 627 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 629 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 631 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (
#line 633 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X)))) || (((! (
#line 623 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 625 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 627 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 629 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 631 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (! (
#line 633 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X))) && ((
#line 635 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD)) || (
#line 636 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD_SLOW)))))))
        {
	  return 52 /* 0x34 */;
        }
      else
        {
	  return 68 /* 0x44 */;
        }

    case 274:  /* *dmulh_peep2_insn */
    case 271:  /* muldf3_insn */
      extract_constrain_insn_cached (insn);
      if (
#line 37 "../../gcc-9.2.1-20190827/gcc/config/arc/fpx.md"
(TARGET_DPFP_COMPACT_SET))
        {
	  return 59 /* 0x3b */;
        }
      else if (
#line 47 "../../gcc-9.2.1-20190827/gcc/config/arc/fpx.md"
(TARGET_DPFP_FAST_SET))
        {
	  return 61 /* 0x3d */;
        }
      else
        {
	  return 68 /* 0x44 */;
        }

    case 275:  /* *dsubh_peep2_insn */
    case 273:  /* *daddh_peep2_insn */
    case 272:  /* subdf3_insn */
    case 270:  /* adddf3_insn */
    case 262:  /* cmpdfpx_raw */
      extract_constrain_insn_cached (insn);
      if (
#line 37 "../../gcc-9.2.1-20190827/gcc/config/arc/fpx.md"
(TARGET_DPFP_COMPACT_SET))
        {
	  return 60 /* 0x3c */;
        }
      else if (
#line 47 "../../gcc-9.2.1-20190827/gcc/config/arc/fpx.md"
(TARGET_DPFP_FAST_SET))
        {
	  return 61 /* 0x3d */;
        }
      else
        {
	  return 68 /* 0x44 */;
        }

    case 261:  /* cmpsfpx_raw */
    case 260:  /* *mulsf3_fpx */
    case 259:  /* *subsf3_fpx */
    case 258:  /* *addsf3_fpx */
      extract_constrain_insn_cached (insn);
      if (
#line 27 "../../gcc-9.2.1-20190827/gcc/config/arc/fpx.md"
(TARGET_SPFP_COMPACT_SET))
        {
	  return 57 /* 0x39 */;
        }
      else if (
#line 32 "../../gcc-9.2.1-20190827/gcc/config/arc/fpx.md"
(TARGET_SPFP_FAST_SET))
        {
	  return 58 /* 0x3a */;
        }
      else
        {
	  return 68 /* 0x44 */;
        }

    case 173:  /* simple_return */
      extract_constrain_insn_cached (insn);
      if ((
#line 27 "../../gcc-9.2.1-20190827/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 623 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 625 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 627 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 629 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 631 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (
#line 633 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X)))) || (((! (
#line 623 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 625 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 627 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 629 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 631 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (! (
#line 633 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X))) && ((
#line 635 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD)) || (
#line 636 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD_SLOW)))))) && (
#line 4795 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(ARC_INTERRUPT_P (arc_compute_function_type (cfun)))) && (
#line 289 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(TARGET_V2)))
        {
	  return 42 /* 0x2a */;
        }
      else
        {
	  return 68 /* 0x44 */;
        }

    case 158:  /* divaw */
      if (get_attr_tune_arc700 (insn) == TUNE_ARC700_TRUE)
        {
	  return 13 /* 0xd */;
        }
      else
        {
	  return 68 /* 0x44 */;
        }

    case 181:  /* dbnz */
    case 179:  /* loop_end */
    case 178:  /* arc_lp */
    case 174:  /* p_return_i */
    case 150:  /* blockage */
      return 68 /* 0x44 */;

    case 658:  /* *p *cmpdf_ord */
    case 657:  /* *p *cmpdf_uneq */
    case 656:  /* *p *cmpdf_ge */
    case 655:  /* *p *cmpdf_gt */
    case 654:  /* *p *cmpdf_eq */
    case 653:  /* *p *cmpsf_ord */
    case 652:  /* *p *cmpsf_uneq */
    case 651:  /* *p *cmpsf_ge */
    case 650:  /* *p *cmpsf_gt */
    case 649:  /* *p *cmpsf_eq */
    case 647:  /* *p *sibcall_value_insn */
    case 646:  /* *p *sibcall_insn */
    case 644:  /* *p *call_value_i */
    case 643:  /* *p *call_i */
    case 256:  /* *pop_multi_fp_blink_ret */
    case 255:  /* *pop_multi_fp_ret */
    case 254:  /* *pop_multi_fp_blink */
    case 253:  /* *pop_multi_fp */
    case 252:  /* *push_multi_fp_blink */
    case 251:  /* *push_multi_fp */
    case 196:  /* *millicode_sibthunk_ld */
    case 195:  /* *millicode_thunk_ld */
    case 194:  /* *millicode_thunk_st */
    case 191:  /* *cmpdf_ord */
    case 190:  /* *cmpdf_uneq */
    case 189:  /* *cmpdf_ge */
    case 188:  /* *cmpdf_gt */
    case 187:  /* *cmpdf_eq */
    case 186:  /* *cmpsf_ord */
    case 185:  /* *cmpsf_uneq */
    case 184:  /* *cmpsf_ge */
    case 183:  /* *cmpsf_gt */
    case 182:  /* *cmpsf_eq */
    case 176:  /* *bbit */
    case 175:  /* cbranchsi4_scratch */
    case 172:  /* *sibcall_value_insn */
    case 171:  /* *sibcall_insn */
    case 146:  /* *call_value_i */
    case 145:  /* *call_i */
    case 144:  /* casesi_jump */
    case 142:  /* casesi_dispatch */
    case 141:  /* indirect_jump */
    case 140:  /* jump_i */
    case 139:  /* *rev_branch_insn */
    case 138:  /* *branch_insn */
      extract_constrain_insn_cached (insn);
      if ((
#line 27 "../../gcc-9.2.1-20190827/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 623 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 625 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 627 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 629 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 631 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (
#line 633 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X)))) || (((! (
#line 623 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 625 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 627 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 629 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 631 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (! (
#line 633 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X))) && ((
#line 635 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD)) || (
#line 636 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD_SLOW)))))))
        {
	  return 42 /* 0x2a */;
        }
      else
        {
	  return 68 /* 0x44 */;
        }

    case 619:  /* *p umac64_600 */
    case 615:  /* *p mac64_600 */
    case 614:  /* *p mul64_600 */
    case 608:  /* *p mac_600 */
    case 91:  /* umac64_600 */
    case 90:  /* umul64_600 */
    case 84:  /* mac64_600 */
    case 83:  /* mul64_600 */
    case 73:  /* mac_600 */
    case 72:  /* umul_600 */
      if ((
#line 623 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600)))
        {
	  return 5;
        }
      else
        {
	  return 68 /* 0x44 */;
        }

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      extract_constrain_insn_cached (insn);
      if (((
#line 623 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && ((cached_type = get_attr_type (insn)) == TYPE_COMPARE))
        {
	  return 0;
        }
      else if (((
#line 623 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && ((cached_type = get_attr_type (insn)) == TYPE_LOAD) && (GET_MODE (operands[0]) == DImode))
        {
	  return 1;
        }
      else if (((
#line 623 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && ((cached_type = get_attr_type (insn)) == TYPE_LOAD) && (! (GET_MODE (operands[0]) == DImode)))
        {
	  return 2;
        }
      else if (((
#line 623 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (
#line 48 "../../gcc-9.2.1-20190827/gcc/config/arc/arc600.md"
(arc_multcost < COSTS_N_INSNS (7))) && (((cached_type = get_attr_type (insn)) == TYPE_MULTI) || (cached_type == TYPE_UMULTI)))
        {
	  return 3;
        }
      else if (((
#line 623 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (
#line 54 "../../gcc-9.2.1-20190827/gcc/config/arc/arc600.md"
(arc_multcost >= COSTS_N_INSNS (7))) && (((cached_type = get_attr_type (insn)) == TYPE_MULTI) || (cached_type == TYPE_UMULTI)))
        {
	  return 4;
        }
      else if (((
#line 623 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && ((cached_type = get_attr_type (insn)) == TYPE_MULMAC_600))
        {
	  return 5;
        }
      else if (((cached_tune_arc700 = get_attr_tune_arc700 (insn)) == TUNE_ARC700_TRUE) && (((cached_type = get_attr_type (insn)) == TYPE_UNARY) || (cached_type == TYPE_MOVE) || (cached_type == TYPE_CMOVE) || (cached_type == TYPE_BINARY)) && (GET_MODE (operands[0]) == DImode))
        {
	  return 6;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && ((cached_type = get_attr_type (insn)) == TYPE_LR))
        {
	  return 7;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && ((cached_type = get_attr_type (insn)) == TYPE_SR))
        {
	  return 8;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && (((cached_type = get_attr_type (insn)) == TYPE_UNARY) || (cached_type == TYPE_MOVE) || (cached_type == TYPE_BINARY)))
        {
	  return 9;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && ((cached_type = get_attr_type (insn)) == TYPE_CMOVE))
        {
	  return 10 /* 0xa */;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && ((cached_type = get_attr_type (insn)) == TYPE_CC_ARITH))
        {
	  return 11 /* 0xb */;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && ((cached_type = get_attr_type (insn)) == TYPE_TWO_CYCLE_CORE))
        {
	  return 12 /* 0xc */;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && ((cached_type = get_attr_type (insn)) == TYPE_DIVAW))
        {
	  return 13 /* 0xd */;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && ((cached_type = get_attr_type (insn)) == TYPE_SHIFT))
        {
	  return 14 /* 0xe */;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && ((cached_type = get_attr_type (insn)) == TYPE_COMPARE))
        {
	  return 15 /* 0xf */;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && ((cached_type = get_attr_type (insn)) == TYPE_COMPARE))
        {
	  return 16 /* 0x10 */;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && ((cached_type = get_attr_type (insn)) == TYPE_MULTI) && (GET_MODE (operands[0]) == DImode))
        {
	  return 17 /* 0x11 */;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && ((cached_type = get_attr_type (insn)) == TYPE_UMULTI) && (GET_MODE (operands[0]) == DImode))
        {
	  return 18 /* 0x12 */;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && ((cached_type = get_attr_type (insn)) == TYPE_UMULTI))
        {
	  return 19 /* 0x13 */;
        }
      else if ((((! (
#line 623 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 625 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 627 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (
#line 629 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC)))) && ((cached_type = get_attr_type (insn)) == TYPE_MULTI))
        {
	  return 21 /* 0x15 */;
        }
      else if ((((! (
#line 623 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 625 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (
#line 627 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD)))) && ((cached_type = get_attr_type (insn)) == TYPE_MULTI))
        {
	  return 22 /* 0x16 */;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && ((cached_type = get_attr_type (insn)) == TYPE_LOAD))
        {
	  return 23 /* 0x17 */;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && ((cached_type = get_attr_type (insn)) == TYPE_STORE))
        {
	  return 24 /* 0x18 */;
        }
      else if ((
#line 27 "../../gcc-9.2.1-20190827/gcc/config/arc/arcEM.md"
(TARGET_EM)) && ((cached_type = get_attr_type (insn)) == TYPE_LOAD))
        {
	  return 25 /* 0x19 */;
        }
      else if ((
#line 27 "../../gcc-9.2.1-20190827/gcc/config/arc/arcEM.md"
(TARGET_EM)) && ((cached_type = get_attr_type (insn)) == TYPE_STORE))
        {
	  return 26 /* 0x1a */;
        }
      else if ((
#line 27 "../../gcc-9.2.1-20190827/gcc/config/arc/arcEM.md"
(TARGET_EM)) && (
#line 39 "../../gcc-9.2.1-20190827/gcc/config/arc/arcEM.md"
(arc_mpy_option > 0)) && (
#line 40 "../../gcc-9.2.1-20190827/gcc/config/arc/arcEM.md"
(arc_mpy_option <= 2)) && ((cached_type = get_attr_type (insn)) == TYPE_MUL16_EM))
        {
	  return 27 /* 0x1b */;
        }
      else if ((
#line 27 "../../gcc-9.2.1-20190827/gcc/config/arc/arcEM.md"
(TARGET_EM)) && (
#line 46 "../../gcc-9.2.1-20190827/gcc/config/arc/arcEM.md"
(arc_mpy_option > 2)) && (
#line 47 "../../gcc-9.2.1-20190827/gcc/config/arc/arcEM.md"
(arc_mpy_option <= 5)) && ((cached_type = get_attr_type (insn)) == TYPE_MUL16_EM))
        {
	  return 28 /* 0x1c */;
        }
      else if ((
#line 27 "../../gcc-9.2.1-20190827/gcc/config/arc/arcEM.md"
(TARGET_EM)) && (
#line 53 "../../gcc-9.2.1-20190827/gcc/config/arc/arcEM.md"
(arc_mpy_option == 6)) && ((cached_type = get_attr_type (insn)) == TYPE_MUL16_EM))
        {
	  return 29 /* 0x1d */;
        }
      else if ((
#line 27 "../../gcc-9.2.1-20190827/gcc/config/arc/arcEM.md"
(TARGET_EM)) && (
#line 59 "../../gcc-9.2.1-20190827/gcc/config/arc/arcEM.md"
(arc_mpy_option == 2)) && (((cached_type = get_attr_type (insn)) == TYPE_MULTI) || (cached_type == TYPE_UMULTI)))
        {
	  return 30 /* 0x1e */;
        }
      else if ((
#line 27 "../../gcc-9.2.1-20190827/gcc/config/arc/arcEM.md"
(TARGET_EM)) && (
#line 65 "../../gcc-9.2.1-20190827/gcc/config/arc/arcEM.md"
(arc_mpy_option == 3)) && (((cached_type = get_attr_type (insn)) == TYPE_MULTI) || (cached_type == TYPE_UMULTI)))
        {
	  return 31 /* 0x1f */;
        }
      else if ((
#line 27 "../../gcc-9.2.1-20190827/gcc/config/arc/arcEM.md"
(TARGET_EM)) && (
#line 71 "../../gcc-9.2.1-20190827/gcc/config/arc/arcEM.md"
(arc_mpy_option == 4)) && (((cached_type = get_attr_type (insn)) == TYPE_MULTI) || (cached_type == TYPE_UMULTI)))
        {
	  return 32 /* 0x20 */;
        }
      else if ((
#line 27 "../../gcc-9.2.1-20190827/gcc/config/arc/arcEM.md"
(TARGET_EM)) && (
#line 78 "../../gcc-9.2.1-20190827/gcc/config/arc/arcEM.md"
(arc_mpy_option == 5)) && (((cached_type = get_attr_type (insn)) == TYPE_MULTI) || (cached_type == TYPE_UMULTI)))
        {
	  return 33 /* 0x21 */;
        }
      else if ((
#line 27 "../../gcc-9.2.1-20190827/gcc/config/arc/arcEM.md"
(TARGET_EM)) && (
#line 53 "../../gcc-9.2.1-20190827/gcc/config/arc/arcEM.md"
(arc_mpy_option == 6)) && (((cached_type = get_attr_type (insn)) == TYPE_MULTI) || (cached_type == TYPE_UMULTI)))
        {
	  return 34 /* 0x22 */;
        }
      else if ((
#line 27 "../../gcc-9.2.1-20190827/gcc/config/arc/arcEM.md"
(TARGET_EM)) && (
#line 91 "../../gcc-9.2.1-20190827/gcc/config/arc/arcEM.md"
(TARGET_DIVREM)) && ((cached_type = get_attr_type (insn)) == TYPE_DIV_REM))
        {
	  return 35 /* 0x23 */;
        }
      else if ((
#line 27 "../../gcc-9.2.1-20190827/gcc/config/arc/arcHS.md"
(TARGET_HS)) && (((! (
#line 623 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 625 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 627 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 629 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 631 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (! (
#line 633 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X))) && (! (
#line 635 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD))) && (! (
#line 636 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD_SLOW))))) && ((cached_type = get_attr_type (insn)) == TYPE_LOAD))
        {
	  return 36 /* 0x24 */;
        }
      else if ((
#line 27 "../../gcc-9.2.1-20190827/gcc/config/arc/arcHS.md"
(TARGET_HS)) && (((! (
#line 623 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 625 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 627 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 629 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 631 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (! (
#line 633 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X))) && (! (
#line 635 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD))) && (! (
#line 636 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD_SLOW))))) && ((cached_type = get_attr_type (insn)) == TYPE_STORE))
        {
	  return 37 /* 0x25 */;
        }
      else if ((
#line 27 "../../gcc-9.2.1-20190827/gcc/config/arc/arcHS.md"
(TARGET_HS)) && (((! (
#line 623 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 625 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 627 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 629 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 631 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (! (
#line 633 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X))) && (! (
#line 635 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD))) && (! (
#line 636 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD_SLOW))))) && (((cached_type = get_attr_type (insn)) == TYPE_CC_ARITH) || (cached_type == TYPE_TWO_CYCLE_CORE) || (cached_type == TYPE_SHIFT) || (cached_type == TYPE_LR) || (cached_type == TYPE_SR)))
        {
	  return 38 /* 0x26 */;
        }
      else if ((
#line 27 "../../gcc-9.2.1-20190827/gcc/config/arc/arcHS.md"
(TARGET_HS)) && (((! (
#line 623 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 625 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 627 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 629 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 631 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (! (
#line 633 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X))) && (! (
#line 635 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD))) && (! (
#line 636 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD_SLOW))))) && (((cached_type = get_attr_type (insn)) == TYPE_MOVE) || (cached_type == TYPE_CMOVE) || (cached_type == TYPE_UNARY) || (cached_type == TYPE_BINARY) || (cached_type == TYPE_COMPARE) || (cached_type == TYPE_MISC)))
        {
	  return 39 /* 0x27 */;
        }
      else if ((
#line 27 "../../gcc-9.2.1-20190827/gcc/config/arc/arcHS.md"
(TARGET_HS)) && (
#line 91 "../../gcc-9.2.1-20190827/gcc/config/arc/arcEM.md"
(TARGET_DIVREM)) && (((! (
#line 623 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 625 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 627 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 629 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 631 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (! (
#line 633 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X))) && (! (
#line 635 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD))) && (! (
#line 636 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD_SLOW))))) && ((cached_type = get_attr_type (insn)) == TYPE_DIV_REM))
        {
	  return 40 /* 0x28 */;
        }
      else if ((
#line 27 "../../gcc-9.2.1-20190827/gcc/config/arc/arcHS.md"
(TARGET_HS)) && (((! (
#line 623 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 625 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 627 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 629 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 631 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (! (
#line 633 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X))) && (! (
#line 635 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD))) && (! (
#line 636 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD_SLOW))))) && (((cached_type = get_attr_type (insn)) == TYPE_MUL16_EM) || (cached_type == TYPE_MULTI) || (cached_type == TYPE_UMULTI)))
        {
	  return 41 /* 0x29 */;
        }
      else if ((
#line 27 "../../gcc-9.2.1-20190827/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 623 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 625 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 627 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 629 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 631 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (
#line 633 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X)))) || (((! (
#line 623 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 625 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 627 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 629 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 631 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (! (
#line 633 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X))) && ((
#line 635 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD)) || (
#line 636 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD_SLOW)))))) && (((cached_type = get_attr_type (insn)) == TYPE_CALL) || (cached_type == TYPE_CALL_NO_DELAY_SLOT) || (cached_type == TYPE_UNCOND_BRANCH) || (cached_type == TYPE_JUMP) || (cached_type == TYPE_BRANCH) || (cached_type == TYPE_BRCC) || (cached_type == TYPE_BRCC_NO_DELAY_SLOT) || (cached_type == TYPE_SFUNC)))
        {
	  return 42 /* 0x2a */;
        }
      else if ((
#line 27 "../../gcc-9.2.1-20190827/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 623 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 625 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 627 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 629 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 631 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (
#line 633 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X)))) || (((! (
#line 623 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 625 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 627 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 629 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 631 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (! (
#line 633 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X))) && ((
#line 635 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD)) || (
#line 636 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD_SLOW)))))) && ((cached_type = get_attr_type (insn)) == TYPE_LOAD))
        {
	  return 43 /* 0x2b */;
        }
      else if ((
#line 27 "../../gcc-9.2.1-20190827/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 623 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 625 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 627 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 629 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 631 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (
#line 633 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X)))) || (((! (
#line 623 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 625 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 627 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 629 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 631 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (! (
#line 633 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X))) && ((
#line 635 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD)) || (
#line 636 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD_SLOW)))))) && ((cached_type = get_attr_type (insn)) == TYPE_STORE))
        {
	  return 44 /* 0x2c */;
        }
      else if ((
#line 27 "../../gcc-9.2.1-20190827/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 623 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 625 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 627 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 629 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 631 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (
#line 633 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X)))) || (((! (
#line 623 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 625 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 627 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 629 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 631 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (! (
#line 633 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X))) && ((
#line 635 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD)) || (
#line 636 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD_SLOW)))))) && (((cached_type = get_attr_type (insn)) == TYPE_CC_ARITH) || (cached_type == TYPE_TWO_CYCLE_CORE) || (cached_type == TYPE_SHIFT) || (cached_type == TYPE_LR) || (cached_type == TYPE_SR)))
        {
	  return 45 /* 0x2d */;
        }
      else if ((
#line 27 "../../gcc-9.2.1-20190827/gcc/config/arc/arcHS.md"
(TARGET_HS)) && (((! (
#line 623 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 625 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 627 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 629 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 631 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (! (
#line 633 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X))) && ((
#line 635 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD)) || (
#line 636 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD_SLOW))))) && (((cached_type = get_attr_type (insn)) == TYPE_CC_ARITH) || (cached_type == TYPE_TWO_CYCLE_CORE) || (cached_type == TYPE_SHIFT) || (cached_type == TYPE_LR) || (cached_type == TYPE_SR)))
        {
	  return 46 /* 0x2e */;
        }
      else if ((
#line 27 "../../gcc-9.2.1-20190827/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 623 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 625 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 627 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 629 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 631 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (
#line 633 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X)))) || (((! (
#line 623 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 625 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 627 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 629 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 631 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (! (
#line 633 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X))) && ((
#line 635 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD)) || (
#line 636 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD_SLOW)))))) && (((cached_type = get_attr_type (insn)) == TYPE_MOVE) || (cached_type == TYPE_CMOVE) || (cached_type == TYPE_UNARY) || (cached_type == TYPE_BINARY) || (cached_type == TYPE_COMPARE) || (cached_type == TYPE_MISC)))
        {
	  return 47 /* 0x2f */;
        }
      else if ((
#line 27 "../../gcc-9.2.1-20190827/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 623 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 625 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 627 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 629 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 631 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (
#line 633 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X)))) || (((! (
#line 623 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 625 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 627 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 629 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 631 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (! (
#line 633 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X))) && ((
#line 635 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD)) || (
#line 636 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD_SLOW)))))) && (((cached_type = get_attr_type (insn)) == TYPE_MOVE) || (cached_type == TYPE_CMOVE) || (cached_type == TYPE_UNARY) || (cached_type == TYPE_BINARY) || (cached_type == TYPE_COMPARE) || (cached_type == TYPE_MISC)))
        {
	  return 48 /* 0x30 */;
        }
      else if ((
#line 27 "../../gcc-9.2.1-20190827/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 623 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 625 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 627 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 629 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 631 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (
#line 633 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X)))) || (((! (
#line 623 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 625 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 627 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 629 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 631 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (! (
#line 633 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X))) && ((
#line 635 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD)) || (
#line 636 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD_SLOW)))))) && ((cached_type = get_attr_type (insn)) == TYPE_DIV_REM))
        {
	  return 49 /* 0x31 */;
        }
      else if ((
#line 27 "../../gcc-9.2.1-20190827/gcc/config/arc/arcHS.md"
(TARGET_HS)) && (((
#line 633 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X)) || (
#line 635 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD)))) && (((cached_type = get_attr_type (insn)) == TYPE_MUL16_EM) || (cached_type == TYPE_MULTI) || (cached_type == TYPE_UMULTI)))
        {
	  return 50 /* 0x32 */;
        }
      else if ((
#line 27 "../../gcc-9.2.1-20190827/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 633 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X))) && (! (
#line 635 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD)))) && (
#line 636 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD_SLOW)))) && (((cached_type = get_attr_type (insn)) == TYPE_MUL16_EM) || (cached_type == TYPE_MULTI) || (cached_type == TYPE_UMULTI)))
        {
	  return 51 /* 0x33 */;
        }
      else if ((
#line 27 "../../gcc-9.2.1-20190827/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 623 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 625 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 627 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 629 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 631 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (
#line 633 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X)))) || (((! (
#line 623 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 625 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 627 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 629 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 631 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (! (
#line 633 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X))) && ((
#line 635 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD)) || (
#line 636 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD_SLOW)))))) && ((cached_type = get_attr_type (insn)) == TYPE_FPU))
        {
	  return 52 /* 0x34 */;
        }
      else if ((
#line 27 "../../gcc-9.2.1-20190827/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 623 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 625 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 627 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 629 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 631 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (
#line 633 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X)))) || (((! (
#line 623 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 625 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 627 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 629 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 631 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (! (
#line 633 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X))) && ((
#line 635 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD)) || (
#line 636 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD_SLOW)))))) && ((cached_type = get_attr_type (insn)) == TYPE_FPU_FUSE))
        {
	  return 53 /* 0x35 */;
        }
      else if ((
#line 27 "../../gcc-9.2.1-20190827/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 623 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 625 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 627 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 629 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 631 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (
#line 633 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X)))) || (((! (
#line 623 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 625 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 627 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 629 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 631 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (! (
#line 633 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X))) && ((
#line 635 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD)) || (
#line 636 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD_SLOW)))))) && ((cached_type = get_attr_type (insn)) == TYPE_FPU_SDIV))
        {
	  return 54 /* 0x36 */;
        }
      else if ((
#line 27 "../../gcc-9.2.1-20190827/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 623 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 625 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 627 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 629 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 631 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (
#line 633 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X)))) || (((! (
#line 623 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 625 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 627 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 629 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 631 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (! (
#line 633 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X))) && ((
#line 635 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD)) || (
#line 636 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD_SLOW)))))) && ((cached_type = get_attr_type (insn)) == TYPE_FPU_DDIV))
        {
	  return 55 /* 0x37 */;
        }
      else if ((
#line 27 "../../gcc-9.2.1-20190827/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 623 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 625 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 627 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 629 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 631 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (
#line 633 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X)))) || (((! (
#line 623 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 625 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 627 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 629 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 631 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (! (
#line 633 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X))) && ((
#line 635 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD)) || (
#line 636 "../../gcc-9.2.1-20190827/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD_SLOW)))))) && ((cached_type = get_attr_type (insn)) == TYPE_FPU_CVT))
        {
	  return 56 /* 0x38 */;
        }
      else if ((
#line 27 "../../gcc-9.2.1-20190827/gcc/config/arc/fpx.md"
(TARGET_SPFP_COMPACT_SET)) && ((cached_type = get_attr_type (insn)) == TYPE_SPFP))
        {
	  return 57 /* 0x39 */;
        }
      else if ((
#line 32 "../../gcc-9.2.1-20190827/gcc/config/arc/fpx.md"
(TARGET_SPFP_FAST_SET)) && ((cached_type = get_attr_type (insn)) == TYPE_SPFP))
        {
	  return 58 /* 0x3a */;
        }
      else if ((
#line 37 "../../gcc-9.2.1-20190827/gcc/config/arc/fpx.md"
(TARGET_DPFP_COMPACT_SET)) && ((cached_type = get_attr_type (insn)) == TYPE_DPFP_MULT))
        {
	  return 59 /* 0x3b */;
        }
      else if ((
#line 37 "../../gcc-9.2.1-20190827/gcc/config/arc/fpx.md"
(TARGET_DPFP_COMPACT_SET)) && ((cached_type = get_attr_type (insn)) == TYPE_DPFP_ADDSUB))
        {
	  return 60 /* 0x3c */;
        }
      else if ((
#line 47 "../../gcc-9.2.1-20190827/gcc/config/arc/fpx.md"
(TARGET_DPFP_FAST_SET)) && (((cached_type = get_attr_type (insn)) == TYPE_DPFP_MULT) || (cached_type == TYPE_DPFP_ADDSUB)))
        {
	  return 61 /* 0x3d */;
        }
      else if (((cached_type = get_attr_type (insn)) == TYPE_SIMD_DMA) || (cached_type == TYPE_SIMD_VSTORE) || (cached_type == TYPE_SIMD_VCONTROL))
        {
	  return 62 /* 0x3e */;
        }
      else if ((cached_type == TYPE_SIMD_VCOMPARE) || (cached_type == TYPE_SIMD_VLOGIC) || (cached_type == TYPE_SIMD_VMOVE_ELSE_ZERO) || (cached_type == TYPE_SIMD_VARITH_1CYCLE))
        {
	  return 63 /* 0x3f */;
        }
      else if ((cached_type == TYPE_SIMD_VALIGN) || (cached_type == TYPE_SIMD_VPERMUTE) || (cached_type == TYPE_SIMD_VPACK) || (cached_type == TYPE_SIMD_VARITH_2CYCLE))
        {
	  return 64 /* 0x40 */;
        }
      else if ((cached_type == TYPE_SIMD_VALIGN_WITH_ACC) || (cached_type == TYPE_SIMD_VPACK_WITH_ACC) || (cached_type == TYPE_SIMD_VLOGIC_WITH_ACC) || (cached_type == TYPE_SIMD_VLOAD128) || (cached_type == TYPE_SIMD_VMOVE_WITH_ACC) || (cached_type == TYPE_SIMD_VSPECIAL_3CYCLE) || (cached_type == TYPE_SIMD_VARITH_WITH_ACC))
        {
	  return 65 /* 0x41 */;
        }
      else if ((cached_type == TYPE_SIMD_VLOAD) || (cached_type == TYPE_SIMD_VMOVE) || (cached_type == TYPE_SIMD_VSPECIAL_4CYCLE))
        {
	  return 66 /* 0x42 */;
        }
      else
        {
	  return 68 /* 0x44 */;
        }

    }
}

