/* Generated automatically by the program 'build/genpreds'
   from the machine description file '../../gcc-9.2.1-20190827/gcc/config/arc/arc.md'.  */

#ifndef GCC_TM_CONSTRS_H
#define GCC_TM_CONSTRS_H

static inline bool
satisfies_constraint_m (rtx op)
{
  return (GET_CODE (op) == MEM) && (
#line 26 "../../gcc-9.2.1-20190827/gcc/common.md"
(memory_address_addr_space_p (GET_MODE (op), XEXP (op, 0),
						 MEM_ADDR_SPACE (op))));
}
static inline bool
satisfies_constraint_o (rtx op)
{
  return (GET_CODE (op) == MEM) && (
#line 32 "../../gcc-9.2.1-20190827/gcc/common.md"
(offsettable_nonstrict_memref_p (op)));
}
static inline bool
satisfies_constraint_V (rtx op)
{
  return (GET_CODE (op) == MEM) && ((
#line 41 "../../gcc-9.2.1-20190827/gcc/common.md"
(memory_address_addr_space_p (GET_MODE (op), XEXP (op, 0),
						 MEM_ADDR_SPACE (op)))) && (!(
#line 43 "../../gcc-9.2.1-20190827/gcc/common.md"
(offsettable_nonstrict_memref_p (op)))));
}
static inline bool
satisfies_constraint__l (rtx op)
{
  return (GET_CODE (op) == MEM) && ((
#line 50 "../../gcc-9.2.1-20190827/gcc/common.md"
(GET_CODE (XEXP (op, 0)) == PRE_DEC)) || (
#line 51 "../../gcc-9.2.1-20190827/gcc/common.md"
(GET_CODE (XEXP (op, 0)) == POST_DEC)));
}
static inline bool
satisfies_constraint__g (rtx op)
{
  return (GET_CODE (op) == MEM) && ((
#line 57 "../../gcc-9.2.1-20190827/gcc/common.md"
(GET_CODE (XEXP (op, 0)) == PRE_INC)) || (
#line 58 "../../gcc-9.2.1-20190827/gcc/common.md"
(GET_CODE (XEXP (op, 0)) == POST_INC)));
}
static inline bool
satisfies_constraint_p (rtx ARG_UNUSED (op))
{
  return 
#line 62 "../../gcc-9.2.1-20190827/gcc/common.md"
(address_operand (op, VOIDmode));
}
static inline bool
satisfies_constraint_i (rtx op)
{
  return (
#line 66 "../../gcc-9.2.1-20190827/gcc/common.md"
(CONSTANT_P (op))) && (
#line 67 "../../gcc-9.2.1-20190827/gcc/common.md"
(!flag_pic || LEGITIMATE_PIC_OPERAND_P (op)));
}
static inline bool
satisfies_constraint_s (rtx op)
{
  return (
#line 71 "../../gcc-9.2.1-20190827/gcc/common.md"
(CONSTANT_P (op))) && ((
#line 72 "../../gcc-9.2.1-20190827/gcc/common.md"
(!CONST_SCALAR_INT_P (op))) && (
#line 73 "../../gcc-9.2.1-20190827/gcc/common.md"
(!flag_pic || LEGITIMATE_PIC_OPERAND_P (op))));
}
static inline bool
satisfies_constraint_n (rtx op)
{
  return (
#line 77 "../../gcc-9.2.1-20190827/gcc/common.md"
(CONST_SCALAR_INT_P (op))) && (
#line 78 "../../gcc-9.2.1-20190827/gcc/common.md"
(!flag_pic || LEGITIMATE_PIC_OPERAND_P (op)));
}
static inline bool
satisfies_constraint_E (rtx op)
{
  return (
#line 82 "../../gcc-9.2.1-20190827/gcc/common.md"
(CONST_DOUBLE_AS_FLOAT_P (op))) || (
#line 83 "../../gcc-9.2.1-20190827/gcc/common.md"
(GET_CODE (op) == CONST_VECTOR
		    && GET_MODE_CLASS (GET_MODE (op)) == MODE_VECTOR_FLOAT));
}
static inline bool
satisfies_constraint_F (rtx op)
{
  return (
#line 89 "../../gcc-9.2.1-20190827/gcc/common.md"
(CONST_DOUBLE_AS_FLOAT_P (op))) || (
#line 90 "../../gcc-9.2.1-20190827/gcc/common.md"
(GET_CODE (op) == CONST_VECTOR
		    && GET_MODE_CLASS (GET_MODE (op)) == MODE_VECTOR_FLOAT));
}
static inline bool
satisfies_constraint_X (rtx ARG_UNUSED (op))
{
  return 
#line 95 "../../gcc-9.2.1-20190827/gcc/common.md"
(true);
}
static inline bool
satisfies_constraint_l (rtx op)
{
  return (GET_CODE (op) == REG) && (
#line 51 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(REGNO (op) == LP_COUNT));
}
static inline bool
satisfies_constraint_I (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 95 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(SIGNED_INT12 (ival)));
}
static inline bool
satisfies_constraint_K (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 101 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(UNSIGNED_INT3 (ival)));
}
static inline bool
satisfies_constraint_L (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 107 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(UNSIGNED_INT6 (ival)));
}
static inline bool
satisfies_constraint_CnL (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 113 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(UNSIGNED_INT6 (~ival)));
}
static inline bool
satisfies_constraint_CmL (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 119 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(UNSIGNED_INT6 (-ival)));
}
static inline bool
satisfies_constraint_C16 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 125 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(SIGNED_INT16 (ival)));
}
static inline bool
satisfies_constraint_M (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 131 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(UNSIGNED_INT5 (ival)));
}
static inline bool
satisfies_constraint_N (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 137 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(IS_ONE (ival)));
}
static inline bool
satisfies_constraint_O (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 143 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(UNSIGNED_INT7 (ival)));
}
static inline bool
satisfies_constraint_P (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 149 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(UNSIGNED_INT8 (ival)));
}
static inline bool
satisfies_constraint_C__0 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 155 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(ival == 0));
}
static inline bool
satisfies_constraint_Cn0 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 161 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(ival <= 0));
}
static inline bool
satisfies_constraint_Cca (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 167 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(ival == (HOST_WIDE_INT)(HOST_WIDE_INT_M1U << 31)
		    || (ival >= -0x1f8 && ival <= 0x1f8
			&& ((ival >= 0 ? ival : -ival)
			    <= 0x3f * (ival & -ival)))));
}
static inline bool
satisfies_constraint_CL2 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 177 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(!(ival & ~126)));
}
static inline bool
satisfies_constraint_CM4 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 183 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(!(ival & ~124)));
}
static inline bool
satisfies_constraint_Csp (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 189 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(!(ival & ~124) || !(-ival & ~124)));
}
static inline bool
satisfies_constraint_C2a (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 195 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(ival == (HOST_WIDE_INT) (HOST_WIDE_INT_M1U << 31)
		    || (ival >= -0x4000 && ival <= 0x4000
			&& ((ival >= 0 ? ival : -ival)
			    <= 0x7ff * (ival & -ival)))));
}
static inline bool
satisfies_constraint_C0p (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 204 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(IS_POWEROF2_P (ival)));
}
static inline bool
satisfies_constraint_C1p (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 210 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(ival && IS_POWEROF2_P (ival + 1)));
}
static inline bool
satisfies_constraint_C2p (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 216 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(TARGET_V2
		    && (ival < -1)
		    && IS_POWEROF2_P ((~ival) + 1)));
}
static inline bool
satisfies_constraint_C3p (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 224 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(((ival == 1) || (ival == 2))));
}
static inline bool
satisfies_constraint_Ccp (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 230 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(IS_POWEROF2_P (~ival)));
}
static inline bool
satisfies_constraint_Cux (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 236 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(ival == 0xff || ival == 0xffff));
}
static inline bool
satisfies_constraint_Chs (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && ((
#line 242 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(IS_POWEROF2_P (-ival))) && (
#line 243 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(TARGET_BARREL_SHIFTER)));
}
static inline bool
satisfies_constraint_Clo (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && ((
#line 249 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(TARGET_NPS_BITOPS)) && (
#line 250 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
((ival & ~0xffffU) == 0)));
}
static inline bool
satisfies_constraint_Chi (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && ((
#line 256 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(TARGET_NPS_BITOPS)) && (
#line 257 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(trunc_int_for_mode (ival >> 16, HImode) << 16 == ival)));
}
static inline bool
satisfies_constraint_Cbf (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && ((
#line 263 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(TARGET_NPS_BITOPS)) && (
#line 264 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(IS_POWEROF2_OR_0_P (ival + (ival & -ival)))));
}
static inline bool
satisfies_constraint_Cbn (rtx op)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 270 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(TARGET_NPS_BITOPS));
}
static inline bool
satisfies_constraint_C18 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 276 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(ival == 1 || ival == 2 || ival == 4 || ival == 8));
}
static inline bool
satisfies_constraint_Crr (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 282 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
((ival & ~0x8000001f) == 0 && !arc_ccfsm_cond_exec_p ()));
}
static inline bool
satisfies_constraint_Cbi (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && ((
#line 288 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(TARGET_NPS_BITOPS)) && (
#line 289 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(!ival
		    || ((ival & 0xffffffffUL) >> exact_log2 (ival & -ival)
			<= 0xff))));
}
static inline bool
satisfies_constraint_G (rtx op)
{
  return (GET_CODE (op) == CONST_DOUBLE) && (
#line 299 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(arc_double_limm_p (op)));
}
static inline bool
satisfies_constraint_H (rtx op)
{
  return (GET_CODE (op) == CONST_DOUBLE) && (
#line 305 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(1));
}
static inline bool
satisfies_constraint_CfZ (rtx op)
{
  return (GET_CODE (op) == CONST_DOUBLE) && (
#line 311 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(op == CONST0_RTX (SFmode)));
}
static inline bool
satisfies_constraint_T (rtx op)
{
  machine_mode mode = GET_MODE (op);
  return (GET_CODE (op) == MEM) && (
#line 318 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(compact_memory_operand_p (op, mode, false, false)));
}
static inline bool
satisfies_constraint_Uts (rtx op)
{
  machine_mode mode = GET_MODE (op);
  return (GET_CODE (op) == MEM) && (
#line 324 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(compact_memory_operand_p (op, mode, false, TARGET_CODE_DENSITY)));
}
static inline bool
satisfies_constraint_S (rtx op)
{
  return (GET_CODE (op) == MEM) && (
#line 330 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(compact_store_memory_operand (op, VOIDmode)));
}
static inline bool
satisfies_constraint_Uex (rtx op)
{
  machine_mode mode = GET_MODE (op);
  return (GET_CODE (op) == MEM) && ((
#line 336 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(!cmem_address (XEXP (op, 0), SImode))) && (!(long_immediate_loadstore_operand (op, mode))));
}
static inline bool
satisfies_constraint_Usd (rtx op)
{
  return (GET_CODE (op) == MEM) && (
#line 343 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(compact_sda_memory_operand (op, VOIDmode, true)));
}
static inline bool
satisfies_constraint_Usc (rtx op)
{
  return (GET_CODE (op) == MEM) && (
#line 351 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(!CONSTANT_P (XEXP (op,0))));
}
static inline bool
satisfies_constraint_Us_l (rtx op)
{
  return (GET_CODE (op) == MEM) && ((
#line 357 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(GET_CODE (XEXP (op, 0)) == PRE_DEC)) && ((
#line 358 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(REG_P (XEXP (XEXP (op, 0), 0)))) && (
#line 359 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(REGNO (XEXP (XEXP (op, 0), 0)) == SP_REG))));
}
static inline bool
satisfies_constraint_Us_g (rtx op)
{
  return (GET_CODE (op) == MEM) && ((
#line 365 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(GET_CODE (XEXP (op, 0)) == POST_INC)) && ((
#line 366 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(REG_P (XEXP (XEXP (op, 0), 0)))) && (
#line 367 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(REGNO (XEXP (XEXP (op, 0), 0)) == SP_REG))));
}
static inline bool
satisfies_constraint_Ucm (rtx op)
{
  return (GET_CODE (op) == MEM) && (
#line 373 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(TARGET_NPS_CMEM && cmem_address (XEXP (op, 0), VOIDmode)));
}
static inline bool
satisfies_constraint_Cbr (rtx op)
{
  return ((GET_CODE (op) == SYMBOL_REF) && (
#line 380 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(!arc_is_longcall_p (op)))) || (GET_CODE (op) == LABEL_REF);
}
static inline bool
satisfies_constraint_Cbp (rtx op)
{
  return ((GET_CODE (op) == SYMBOL_REF) && (
#line 386 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(arc_is_shortcall_p (op)))) || (GET_CODE (op) == LABEL_REF);
}
static inline bool
satisfies_constraint_Cji (rtx op)
{
  return (GET_CODE (op) == SYMBOL_REF) && ((
#line 392 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(TARGET_CODE_DENSITY)) && (
#line 393 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(arc_is_jli_call_p (op))));
}
static inline bool
satisfies_constraint_Csc (rtx op)
{
  return (GET_CODE (op) == SYMBOL_REF) && ((
#line 398 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(TARGET_CODE_DENSITY)) && ((
#line 399 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(TARGET_EM)) && (
#line 400 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(arc_is_secure_call_p (op)))));
}
static inline bool
satisfies_constraint_Cpc (rtx op)
{
  return 
#line 404 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(arc_legitimate_pic_addr_p (op));
}
static inline bool
satisfies_constraint_Clb (rtx op)
{
  return (GET_CODE (op) == LABEL_REF) && (
#line 409 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(arc_text_label (as_a <rtx_insn *> (XEXP (op, 0)))));
}
static inline bool
satisfies_constraint_Cal (rtx ARG_UNUSED (op))
{
  return 
#line 413 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(immediate_operand (op, VOIDmode) && !arc_legitimate_pic_addr_p (op));
}
static inline bool
satisfies_constraint_C32 (rtx ARG_UNUSED (op))
{
  return 
#line 417 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(immediate_operand (op, VOIDmode)
	       && !arc_legitimate_pic_addr_p (op)
	       && !satisfies_constraint_I (op));
}
static inline bool
satisfies_constraint_Csz (rtx ARG_UNUSED (op))
{
  return 
#line 423 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(immediate_operand (op, VOIDmode)
	       && !arc_legitimate_pic_addr_p (op)
	       && !(satisfies_constraint_I (op) && optimize_size));
}
static inline bool
satisfies_constraint_Rcq (rtx op)
{
  return (GET_CODE (op) == REG) && (
#line 443 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(TARGET_Rcq
		    && !arc_ccfsm_cond_exec_p ()
		    && IN_RANGE (REGNO (op) ^ 4, 4, 11)));
}
static inline bool
satisfies_constraint_Rcw (rtx op)
{
  return (GET_CODE (op) == REG) && (
#line 456 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(TARGET_Rcw
	 && REGNO (op) < FIRST_PSEUDO_REGISTER
	 && TEST_HARD_REG_BIT (reg_class_contents[GENERAL_REGS],
			       REGNO (op))));
}
static inline bool
satisfies_constraint_Rcr (rtx op)
{
  return (GET_CODE (op) == REG) && (
#line 466 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(TARGET_Rcw
	 && REGNO (op) < FIRST_PSEUDO_REGISTER
	 && TEST_HARD_REG_BIT (reg_class_contents[GENERAL_REGS],
			       REGNO (op))));
}
static inline bool
satisfies_constraint_Rcb (rtx op)
{
  return (GET_CODE (op) == REG) && (
#line 475 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(REGNO (op) == 28));
}
static inline bool
satisfies_constraint_Rck (rtx op)
{
  return (GET_CODE (op) == REG) && (
#line 481 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(REGNO (op) == 31));
}
static inline bool
satisfies_constraint_Rcc (rtx op)
{
  return (GET_CODE (op) == REG) && (
#line 486 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(cc_register (op, VOIDmode)));
}
static inline bool
satisfies_constraint_Q (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 493 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(IS_ZERO (ival)));
}
static inline bool
satisfies_constraint_Cm1 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && ((
#line 499 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
((ival >= -1) && (ival <=6))) && (
#line 500 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(TARGET_V2)));
}
static inline bool
satisfies_constraint_Cm2 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 506 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
((ival >= -256) && (ival <=255)));
}
static inline bool
satisfies_constraint_Cm3 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && ((
#line 512 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
((ival >= -32) && (ival <=31))) && (
#line 513 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(TARGET_V2)));
}
static inline bool
satisfies_constraint_C62 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 519 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(UNSIGNED_INT6 (ival - 1)));
}
static inline bool
satisfies_constraint_ATO (rtx op)
{
  machine_mode mode = GET_MODE (op);
  return mem_noofs_operand (op, mode);
}
static inline bool
satisfies_constraint_J12 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 530 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(UNSIGNED_INT12 (ival)));
}
static inline bool
satisfies_constraint_J16 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 536 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(UNSIGNED_INT16 (ival)));
}
static inline bool
satisfies_constraint_Ucd (rtx op)
{
  machine_mode mode = GET_MODE (op);
  return (GET_CODE (op) == MEM) && ((
#line 543 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(compact_memory_operand_p (op, mode, true, false))) && (
#line 544 "../../gcc-9.2.1-20190827/gcc/config/arc/constraints.md"
(TARGET_V2)));
}
#endif /* tm-constrs.h */
