/* Generated automatically by the program `genopinit'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "alias.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "memmodel.h"
#include "tm_p.h"
#include "flags.h"
#include "insn-config.h"
#include "expmed.h"
#include "dojump.h"
#include "explow.h"
#include "emit-rtl.h"
#include "stmt.h"
#include "expr.h"
#include "insn-codes.h"
#include "optabs.h"

struct optab_pat {
  unsigned scode;
  enum insn_code icode;
};

static const struct optab_pat pats[NUM_OPTAB_PATTERNS] = {
  { 0x010809, CODE_FOR_extendqihi2 },
  { 0x01080a, CODE_FOR_extendqisi2 },
  { 0x01080b, CODE_FOR_extendqidi2 },
  { 0x01090a, CODE_FOR_extendhisi2 },
  { 0x01090b, CODE_FOR_extendhidi2 },
  { 0x010a0b, CODE_FOR_extendsidi2 },
  { 0x011f20, CODE_FOR_extendsfdf2 },
  { 0x020b08, CODE_FOR_truncdiqi2 },
  { 0x020b09, CODE_FOR_truncdihi2 },
  { 0x020b0a, CODE_FOR_truncdisi2 },
  { 0x02201f, CODE_FOR_truncdfsf2 },
  { 0x030809, CODE_FOR_zero_extendqihi2 },
  { 0x03080a, CODE_FOR_zero_extendqisi2 },
  { 0x03080b, CODE_FOR_zero_extendqidi2 },
  { 0x03090a, CODE_FOR_zero_extendhisi2 },
  { 0x03090b, CODE_FOR_zero_extendhidi2 },
  { 0x030a0b, CODE_FOR_zero_extendsidi2 },
  { 0x060a1f, CODE_FOR_floatsisf2 },
  { 0x060a20, CODE_FOR_floatsidf2 },
  { 0x060b1f, CODE_FOR_floatdisf2 },
  { 0x060b20, CODE_FOR_floatdidf2 },
  { 0x063441, CODE_FOR_floatv4siv4sf2 },
  { 0x063542, CODE_FOR_floatv2div2df2 },
  { 0x073441, CODE_FOR_floatunsv4siv4sf2 },
  { 0x073542, CODE_FOR_floatunsv2div2df2 },
  { 0x101f0a, CODE_FOR_fix_truncsfsi2 },
  { 0x101f0b, CODE_FOR_fix_truncsfdi2 },
  { 0x10200a, CODE_FOR_fix_truncdfsi2 },
  { 0x10200b, CODE_FOR_fix_truncdfdi2 },
  { 0x104134, CODE_FOR_fix_truncv4sfv4si2 },
  { 0x104235, CODE_FOR_fix_truncv2dfv2di2 },
  { 0x111f0a, CODE_FOR_fixuns_truncsfsi2 },
  { 0x111f0b, CODE_FOR_fixuns_truncsfdi2 },
  { 0x11200a, CODE_FOR_fixuns_truncdfsi2 },
  { 0x11200b, CODE_FOR_fixuns_truncdfdi2 },
  { 0x114134, CODE_FOR_fixuns_truncv4sfv4si2 },
  { 0x114235, CODE_FOR_fixuns_truncv2dfv2di2 },
  { 0x120a0b, CODE_FOR_mulsidi3 },
  { 0x120b0c, CODE_FOR_mulditi3 },
  { 0x130a0b, CODE_FOR_umulsidi3 },
  { 0x130b0c, CODE_FOR_umulditi3 },
  { 0x150a0b, CODE_FOR_maddsidi4 },
  { 0x160a0b, CODE_FOR_umaddsidi4 },
  { 0x170f10, CODE_FOR_ssmaddsqdq4 },
  { 0x190a0b, CODE_FOR_msubsidi4 },
  { 0x1a0a0b, CODE_FOR_umsubsidi4 },
  { 0x1b0f10, CODE_FOR_ssmsubsqdq4 },
  { 0x213232, CODE_FOR_vcondv16qiv16qi },
  { 0x213233, CODE_FOR_vcondv8hiv16qi },
  { 0x213234, CODE_FOR_vcondv4siv16qi },
  { 0x213235, CODE_FOR_vcondv2div16qi },
  { 0x213241, CODE_FOR_vcondv4sfv16qi },
  { 0x213242, CODE_FOR_vcondv2dfv16qi },
  { 0x213332, CODE_FOR_vcondv16qiv8hi },
  { 0x213333, CODE_FOR_vcondv8hiv8hi },
  { 0x213334, CODE_FOR_vcondv4siv8hi },
  { 0x213335, CODE_FOR_vcondv2div8hi },
  { 0x213341, CODE_FOR_vcondv4sfv8hi },
  { 0x213342, CODE_FOR_vcondv2dfv8hi },
  { 0x213432, CODE_FOR_vcondv16qiv4si },
  { 0x213433, CODE_FOR_vcondv8hiv4si },
  { 0x213434, CODE_FOR_vcondv4siv4si },
  { 0x213435, CODE_FOR_vcondv2div4si },
  { 0x213441, CODE_FOR_vcondv4sfv4si },
  { 0x213442, CODE_FOR_vcondv2dfv4si },
  { 0x213532, CODE_FOR_vcondv16qiv2di },
  { 0x213533, CODE_FOR_vcondv8hiv2di },
  { 0x213534, CODE_FOR_vcondv4siv2di },
  { 0x213535, CODE_FOR_vcondv2div2di },
  { 0x213541, CODE_FOR_vcondv4sfv2di },
  { 0x213542, CODE_FOR_vcondv2dfv2di },
  { 0x214040, CODE_FOR_vcondv2sfv2sf },
  { 0x214132, CODE_FOR_vcondv16qiv4sf },
  { 0x214133, CODE_FOR_vcondv8hiv4sf },
  { 0x214134, CODE_FOR_vcondv4siv4sf },
  { 0x214135, CODE_FOR_vcondv2div4sf },
  { 0x214141, CODE_FOR_vcondv4sfv4sf },
  { 0x214142, CODE_FOR_vcondv2dfv4sf },
  { 0x214232, CODE_FOR_vcondv16qiv2df },
  { 0x214233, CODE_FOR_vcondv8hiv2df },
  { 0x214234, CODE_FOR_vcondv4siv2df },
  { 0x214235, CODE_FOR_vcondv2div2df },
  { 0x214241, CODE_FOR_vcondv4sfv2df },
  { 0x214242, CODE_FOR_vcondv2dfv2df },
  { 0x223232, CODE_FOR_vconduv16qiv16qi },
  { 0x223233, CODE_FOR_vconduv8hiv16qi },
  { 0x223234, CODE_FOR_vconduv4siv16qi },
  { 0x223235, CODE_FOR_vconduv2div16qi },
  { 0x223241, CODE_FOR_vconduv4sfv16qi },
  { 0x223242, CODE_FOR_vconduv2dfv16qi },
  { 0x223332, CODE_FOR_vconduv16qiv8hi },
  { 0x223333, CODE_FOR_vconduv8hiv8hi },
  { 0x223334, CODE_FOR_vconduv4siv8hi },
  { 0x223335, CODE_FOR_vconduv2div8hi },
  { 0x223341, CODE_FOR_vconduv4sfv8hi },
  { 0x223342, CODE_FOR_vconduv2dfv8hi },
  { 0x223432, CODE_FOR_vconduv16qiv4si },
  { 0x223433, CODE_FOR_vconduv8hiv4si },
  { 0x223434, CODE_FOR_vconduv4siv4si },
  { 0x223435, CODE_FOR_vconduv2div4si },
  { 0x223441, CODE_FOR_vconduv4sfv4si },
  { 0x223442, CODE_FOR_vconduv2dfv4si },
  { 0x223532, CODE_FOR_vconduv16qiv2di },
  { 0x223533, CODE_FOR_vconduv8hiv2di },
  { 0x223534, CODE_FOR_vconduv4siv2di },
  { 0x223535, CODE_FOR_vconduv2div2di },
  { 0x223541, CODE_FOR_vconduv4sfv2di },
  { 0x223542, CODE_FOR_vconduv2dfv2di },
  { 0x2a0832, CODE_FOR_vec_extractv16qiqi },
  { 0x2a0933, CODE_FOR_vec_extractv8hihi },
  { 0x2a0a34, CODE_FOR_vec_extractv4sisi },
  { 0x2a0b35, CODE_FOR_vec_extractv2didi },
  { 0x2a1f40, CODE_FOR_vec_extractv2sfsf },
  { 0x2a1f41, CODE_FOR_vec_extractv4sfsf },
  { 0x2a2042, CODE_FOR_vec_extractv2dfdf },
  { 0x2b082f, CODE_FOR_vec_initv8qiqi },
  { 0x2b0832, CODE_FOR_vec_initv16qiqi },
  { 0x2b0930, CODE_FOR_vec_initv4hihi },
  { 0x2b0933, CODE_FOR_vec_initv8hihi },
  { 0x2b0a31, CODE_FOR_vec_initv2sisi },
  { 0x2b0a34, CODE_FOR_vec_initv4sisi },
  { 0x2b0b35, CODE_FOR_vec_initv2didi },
  { 0x2b1f40, CODE_FOR_vec_initv2sfsf },
  { 0x2b1f41, CODE_FOR_vec_initv4sfsf },
  { 0x2b2042, CODE_FOR_vec_initv2dfdf },
  { 0x2d000a, CODE_FOR_addsi3 },
  { 0x2d000b, CODE_FOR_adddi3 },
  { 0x2d000d, CODE_FOR_addqq3 },
  { 0x2d000e, CODE_FOR_addhq3 },
  { 0x2d000f, CODE_FOR_addsq3 },
  { 0x2d0010, CODE_FOR_adddq3 },
  { 0x2d0012, CODE_FOR_adduqq3 },
  { 0x2d0013, CODE_FOR_adduhq3 },
  { 0x2d0014, CODE_FOR_addusq3 },
  { 0x2d0015, CODE_FOR_addudq3 },
  { 0x2d0017, CODE_FOR_addha3 },
  { 0x2d0018, CODE_FOR_addsa3 },
  { 0x2d0019, CODE_FOR_addda3 },
  { 0x2d001b, CODE_FOR_adduha3 },
  { 0x2d001c, CODE_FOR_addusa3 },
  { 0x2d001d, CODE_FOR_adduda3 },
  { 0x2d001f, CODE_FOR_addsf3 },
  { 0x2d0020, CODE_FOR_adddf3 },
  { 0x2d002d, CODE_FOR_addv4qi3 },
  { 0x2d002e, CODE_FOR_addv2hi3 },
  { 0x2d002f, CODE_FOR_addv8qi3 },
  { 0x2d0030, CODE_FOR_addv4hi3 },
  { 0x2d0031, CODE_FOR_addv2si3 },
  { 0x2d0032, CODE_FOR_addv16qi3 },
  { 0x2d0033, CODE_FOR_addv8hi3 },
  { 0x2d0034, CODE_FOR_addv4si3 },
  { 0x2d0035, CODE_FOR_addv2di3 },
  { 0x2d0040, CODE_FOR_addv2sf3 },
  { 0x2d0041, CODE_FOR_addv4sf3 },
  { 0x2d0042, CODE_FOR_addv2df3 },
  { 0x2f000e, CODE_FOR_ssaddhq3 },
  { 0x2f000f, CODE_FOR_ssaddsq3 },
  { 0x2f0017, CODE_FOR_ssaddha3 },
  { 0x2f0018, CODE_FOR_ssaddsa3 },
  { 0x2f003b, CODE_FOR_ssaddv2hq3 },
  { 0x2f003e, CODE_FOR_ssaddv2ha3 },
  { 0x300012, CODE_FOR_usadduqq3 },
  { 0x300013, CODE_FOR_usadduhq3 },
  { 0x30001b, CODE_FOR_usadduha3 },
  { 0x30003c, CODE_FOR_usaddv4uqq3 },
  { 0x30003d, CODE_FOR_usaddv2uhq3 },
  { 0x30003f, CODE_FOR_usaddv2uha3 },
  { 0x31000a, CODE_FOR_subsi3 },
  { 0x31000b, CODE_FOR_subdi3 },
  { 0x31000d, CODE_FOR_subqq3 },
  { 0x31000e, CODE_FOR_subhq3 },
  { 0x31000f, CODE_FOR_subsq3 },
  { 0x310010, CODE_FOR_subdq3 },
  { 0x310012, CODE_FOR_subuqq3 },
  { 0x310013, CODE_FOR_subuhq3 },
  { 0x310014, CODE_FOR_subusq3 },
  { 0x310015, CODE_FOR_subudq3 },
  { 0x310017, CODE_FOR_subha3 },
  { 0x310018, CODE_FOR_subsa3 },
  { 0x310019, CODE_FOR_subda3 },
  { 0x31001b, CODE_FOR_subuha3 },
  { 0x31001c, CODE_FOR_subusa3 },
  { 0x31001d, CODE_FOR_subuda3 },
  { 0x31001f, CODE_FOR_subsf3 },
  { 0x310020, CODE_FOR_subdf3 },
  { 0x31002d, CODE_FOR_subv4qi3 },
  { 0x31002e, CODE_FOR_subv2hi3 },
  { 0x31002f, CODE_FOR_subv8qi3 },
  { 0x310030, CODE_FOR_subv4hi3 },
  { 0x310031, CODE_FOR_subv2si3 },
  { 0x310032, CODE_FOR_subv16qi3 },
  { 0x310033, CODE_FOR_subv8hi3 },
  { 0x310034, CODE_FOR_subv4si3 },
  { 0x310035, CODE_FOR_subv2di3 },
  { 0x310040, CODE_FOR_subv2sf3 },
  { 0x310041, CODE_FOR_subv4sf3 },
  { 0x310042, CODE_FOR_subv2df3 },
  { 0x33000e, CODE_FOR_sssubhq3 },
  { 0x33000f, CODE_FOR_sssubsq3 },
  { 0x330017, CODE_FOR_sssubha3 },
  { 0x330018, CODE_FOR_sssubsa3 },
  { 0x33003b, CODE_FOR_sssubv2hq3 },
  { 0x33003e, CODE_FOR_sssubv2ha3 },
  { 0x340012, CODE_FOR_ussubuqq3 },
  { 0x340013, CODE_FOR_ussubuhq3 },
  { 0x34001b, CODE_FOR_ussubuha3 },
  { 0x34003c, CODE_FOR_ussubv4uqq3 },
  { 0x34003d, CODE_FOR_ussubv2uhq3 },
  { 0x34003f, CODE_FOR_ussubv2uha3 },
  { 0x35000a, CODE_FOR_mulsi3 },
  { 0x35000b, CODE_FOR_muldi3 },
  { 0x35001f, CODE_FOR_mulsf3 },
  { 0x350020, CODE_FOR_muldf3 },
  { 0x35002e, CODE_FOR_mulv2hi3 },
  { 0x350030, CODE_FOR_mulv4hi3 },
  { 0x350032, CODE_FOR_mulv16qi3 },
  { 0x350033, CODE_FOR_mulv8hi3 },
  { 0x350034, CODE_FOR_mulv4si3 },
  { 0x350035, CODE_FOR_mulv2di3 },
  { 0x350040, CODE_FOR_mulv2sf3 },
  { 0x350041, CODE_FOR_mulv4sf3 },
  { 0x350042, CODE_FOR_mulv2df3 },
  { 0x37000e, CODE_FOR_ssmulhq3 },
  { 0x37000f, CODE_FOR_ssmulsq3 },
  { 0x37003b, CODE_FOR_ssmulv2hq3 },
  { 0x39000a, CODE_FOR_divsi3 },
  { 0x39000b, CODE_FOR_divdi3 },
  { 0x39001f, CODE_FOR_divsf3 },
  { 0x390020, CODE_FOR_divdf3 },
  { 0x390032, CODE_FOR_divv16qi3 },
  { 0x390033, CODE_FOR_divv8hi3 },
  { 0x390034, CODE_FOR_divv4si3 },
  { 0x390035, CODE_FOR_divv2di3 },
  { 0x390040, CODE_FOR_divv2sf3 },
  { 0x390041, CODE_FOR_divv4sf3 },
  { 0x390042, CODE_FOR_divv2df3 },
  { 0x3c000a, CODE_FOR_udivsi3 },
  { 0x3c000b, CODE_FOR_udivdi3 },
  { 0x3c0032, CODE_FOR_udivv16qi3 },
  { 0x3c0033, CODE_FOR_udivv8hi3 },
  { 0x3c0034, CODE_FOR_udivv4si3 },
  { 0x3c0035, CODE_FOR_udivv2di3 },
  { 0x3e000a, CODE_FOR_divmodsi4 },
  { 0x3e000b, CODE_FOR_divmoddi4 },
  { 0x3f000a, CODE_FOR_udivmodsi4 },
  { 0x3f000b, CODE_FOR_udivmoddi4 },
  { 0x40000a, CODE_FOR_modsi3 },
  { 0x40000b, CODE_FOR_moddi3 },
  { 0x400032, CODE_FOR_modv16qi3 },
  { 0x400033, CODE_FOR_modv8hi3 },
  { 0x400034, CODE_FOR_modv4si3 },
  { 0x400035, CODE_FOR_modv2di3 },
  { 0x41000a, CODE_FOR_umodsi3 },
  { 0x41000b, CODE_FOR_umoddi3 },
  { 0x410032, CODE_FOR_umodv16qi3 },
  { 0x410033, CODE_FOR_umodv8hi3 },
  { 0x410034, CODE_FOR_umodv4si3 },
  { 0x410035, CODE_FOR_umodv2di3 },
  { 0x43000a, CODE_FOR_andsi3 },
  { 0x43000b, CODE_FOR_anddi3 },
  { 0x43002f, CODE_FOR_andv8qi3 },
  { 0x430030, CODE_FOR_andv4hi3 },
  { 0x430031, CODE_FOR_andv2si3 },
  { 0x430032, CODE_FOR_andv16qi3 },
  { 0x430033, CODE_FOR_andv8hi3 },
  { 0x430034, CODE_FOR_andv4si3 },
  { 0x430035, CODE_FOR_andv2di3 },
  { 0x44000a, CODE_FOR_iorsi3 },
  { 0x44000b, CODE_FOR_iordi3 },
  { 0x44002f, CODE_FOR_iorv8qi3 },
  { 0x440030, CODE_FOR_iorv4hi3 },
  { 0x440031, CODE_FOR_iorv2si3 },
  { 0x440032, CODE_FOR_iorv16qi3 },
  { 0x440033, CODE_FOR_iorv8hi3 },
  { 0x440034, CODE_FOR_iorv4si3 },
  { 0x440035, CODE_FOR_iorv2di3 },
  { 0x45000a, CODE_FOR_xorsi3 },
  { 0x45000b, CODE_FOR_xordi3 },
  { 0x45002f, CODE_FOR_xorv8qi3 },
  { 0x450030, CODE_FOR_xorv4hi3 },
  { 0x450031, CODE_FOR_xorv2si3 },
  { 0x450032, CODE_FOR_xorv16qi3 },
  { 0x450033, CODE_FOR_xorv8hi3 },
  { 0x450034, CODE_FOR_xorv4si3 },
  { 0x450035, CODE_FOR_xorv2di3 },
  { 0x46000a, CODE_FOR_ashlsi3 },
  { 0x46000b, CODE_FOR_ashldi3 },
  { 0x460030, CODE_FOR_ashlv4hi3 },
  { 0x460031, CODE_FOR_ashlv2si3 },
  { 0x49000a, CODE_FOR_ashrsi3 },
  { 0x49000b, CODE_FOR_ashrdi3 },
  { 0x490030, CODE_FOR_ashrv4hi3 },
  { 0x490031, CODE_FOR_ashrv2si3 },
  { 0x4a000a, CODE_FOR_lshrsi3 },
  { 0x4a000b, CODE_FOR_lshrdi3 },
  { 0x4a0030, CODE_FOR_lshrv4hi3 },
  { 0x4a0031, CODE_FOR_lshrv2si3 },
  { 0x4c000a, CODE_FOR_rotrsi3 },
  { 0x4c000b, CODE_FOR_rotrdi3 },
  { 0x4d0032, CODE_FOR_vashlv16qi3 },
  { 0x4d0033, CODE_FOR_vashlv8hi3 },
  { 0x4d0034, CODE_FOR_vashlv4si3 },
  { 0x4d0035, CODE_FOR_vashlv2di3 },
  { 0x4e0032, CODE_FOR_vashrv16qi3 },
  { 0x4e0033, CODE_FOR_vashrv8hi3 },
  { 0x4e0034, CODE_FOR_vashrv4si3 },
  { 0x4e0035, CODE_FOR_vashrv2di3 },
  { 0x4f0032, CODE_FOR_vlshrv16qi3 },
  { 0x4f0033, CODE_FOR_vlshrv8hi3 },
  { 0x4f0034, CODE_FOR_vlshrv4si3 },
  { 0x4f0035, CODE_FOR_vlshrv2di3 },
  { 0x52002f, CODE_FOR_sminv8qi3 },
  { 0x520030, CODE_FOR_sminv4hi3 },
  { 0x520031, CODE_FOR_sminv2si3 },
  { 0x520032, CODE_FOR_sminv16qi3 },
  { 0x520033, CODE_FOR_sminv8hi3 },
  { 0x520034, CODE_FOR_sminv4si3 },
  { 0x520035, CODE_FOR_sminv2di3 },
  { 0x520040, CODE_FOR_sminv2sf3 },
  { 0x520041, CODE_FOR_sminv4sf3 },
  { 0x520042, CODE_FOR_sminv2df3 },
  { 0x53002f, CODE_FOR_smaxv8qi3 },
  { 0x530030, CODE_FOR_smaxv4hi3 },
  { 0x530031, CODE_FOR_smaxv2si3 },
  { 0x530032, CODE_FOR_smaxv16qi3 },
  { 0x530033, CODE_FOR_smaxv8hi3 },
  { 0x530034, CODE_FOR_smaxv4si3 },
  { 0x530035, CODE_FOR_smaxv2di3 },
  { 0x530040, CODE_FOR_smaxv2sf3 },
  { 0x530041, CODE_FOR_smaxv4sf3 },
  { 0x530042, CODE_FOR_smaxv2df3 },
  { 0x54002f, CODE_FOR_uminv8qi3 },
  { 0x540032, CODE_FOR_uminv16qi3 },
  { 0x540033, CODE_FOR_uminv8hi3 },
  { 0x540034, CODE_FOR_uminv4si3 },
  { 0x540035, CODE_FOR_uminv2di3 },
  { 0x55002f, CODE_FOR_umaxv8qi3 },
  { 0x550032, CODE_FOR_umaxv16qi3 },
  { 0x550033, CODE_FOR_umaxv8hi3 },
  { 0x550034, CODE_FOR_umaxv4si3 },
  { 0x550035, CODE_FOR_umaxv2di3 },
  { 0x56000a, CODE_FOR_negsi2 },
  { 0x56000b, CODE_FOR_negdi2 },
  { 0x56001f, CODE_FOR_negsf2 },
  { 0x560020, CODE_FOR_negdf2 },
  { 0x560032, CODE_FOR_negv16qi2 },
  { 0x560033, CODE_FOR_negv8hi2 },
  { 0x560034, CODE_FOR_negv4si2 },
  { 0x560035, CODE_FOR_negv2di2 },
  { 0x560040, CODE_FOR_negv2sf2 },
  { 0x560041, CODE_FOR_negv4sf2 },
  { 0x560042, CODE_FOR_negv2df2 },
  { 0x5a001f, CODE_FOR_abssf2 },
  { 0x5a0020, CODE_FOR_absdf2 },
  { 0x5a0032, CODE_FOR_absv16qi2 },
  { 0x5a0033, CODE_FOR_absv8hi2 },
  { 0x5a0034, CODE_FOR_absv4si2 },
  { 0x5a0035, CODE_FOR_absv2di2 },
  { 0x5a0040, CODE_FOR_absv2sf2 },
  { 0x5c000a, CODE_FOR_one_cmplsi2 },
  { 0x5c000b, CODE_FOR_one_cmpldi2 },
  { 0x5c002f, CODE_FOR_one_cmplv8qi2 },
  { 0x5c0030, CODE_FOR_one_cmplv4hi2 },
  { 0x5c0031, CODE_FOR_one_cmplv2si2 },
  { 0x5c0032, CODE_FOR_one_cmplv16qi2 },
  { 0x5c0033, CODE_FOR_one_cmplv8hi2 },
  { 0x5c0034, CODE_FOR_one_cmplv4si2 },
  { 0x5c0035, CODE_FOR_one_cmplv2di2 },
  { 0x5d0009, CODE_FOR_bswaphi2 },
  { 0x5d000a, CODE_FOR_bswapsi2 },
  { 0x5d000b, CODE_FOR_bswapdi2 },
  { 0x5f000a, CODE_FOR_clzsi2 },
  { 0x5f000b, CODE_FOR_clzdi2 },
  { 0x5f0032, CODE_FOR_clzv16qi2 },
  { 0x5f0033, CODE_FOR_clzv8hi2 },
  { 0x5f0034, CODE_FOR_clzv4si2 },
  { 0x5f0035, CODE_FOR_clzv2di2 },
  { 0x60000a, CODE_FOR_ctzsi2 },
  { 0x60000b, CODE_FOR_ctzdi2 },
  { 0x62000a, CODE_FOR_popcountsi2 },
  { 0x62000b, CODE_FOR_popcountdi2 },
  { 0x620032, CODE_FOR_popcountv16qi2 },
  { 0x620033, CODE_FOR_popcountv8hi2 },
  { 0x620034, CODE_FOR_popcountv4si2 },
  { 0x620035, CODE_FOR_popcountv2di2 },
  { 0x6e001f, CODE_FOR_sqrtsf2 },
  { 0x6e0020, CODE_FOR_sqrtdf2 },
  { 0x6e0040, CODE_FOR_sqrtv2sf2 },
  { 0x6e0041, CODE_FOR_sqrtv4sf2 },
  { 0x6e0042, CODE_FOR_sqrtv2df2 },
  { 0x6f0008, CODE_FOR_sync_old_addqi },
  { 0x6f0009, CODE_FOR_sync_old_addhi },
  { 0x6f000a, CODE_FOR_sync_old_addsi },
  { 0x6f000b, CODE_FOR_sync_old_adddi },
  { 0x700008, CODE_FOR_sync_old_subqi },
  { 0x700009, CODE_FOR_sync_old_subhi },
  { 0x70000a, CODE_FOR_sync_old_subsi },
  { 0x70000b, CODE_FOR_sync_old_subdi },
  { 0x710008, CODE_FOR_sync_old_iorqi },
  { 0x710009, CODE_FOR_sync_old_iorhi },
  { 0x71000a, CODE_FOR_sync_old_iorsi },
  { 0x71000b, CODE_FOR_sync_old_iordi },
  { 0x720008, CODE_FOR_sync_old_andqi },
  { 0x720009, CODE_FOR_sync_old_andhi },
  { 0x72000a, CODE_FOR_sync_old_andsi },
  { 0x72000b, CODE_FOR_sync_old_anddi },
  { 0x730008, CODE_FOR_sync_old_xorqi },
  { 0x730009, CODE_FOR_sync_old_xorhi },
  { 0x73000a, CODE_FOR_sync_old_xorsi },
  { 0x73000b, CODE_FOR_sync_old_xordi },
  { 0x740008, CODE_FOR_sync_old_nandqi },
  { 0x740009, CODE_FOR_sync_old_nandhi },
  { 0x74000a, CODE_FOR_sync_old_nandsi },
  { 0x74000b, CODE_FOR_sync_old_nanddi },
  { 0x750008, CODE_FOR_sync_new_addqi },
  { 0x750009, CODE_FOR_sync_new_addhi },
  { 0x75000a, CODE_FOR_sync_new_addsi },
  { 0x75000b, CODE_FOR_sync_new_adddi },
  { 0x760008, CODE_FOR_sync_new_subqi },
  { 0x760009, CODE_FOR_sync_new_subhi },
  { 0x76000a, CODE_FOR_sync_new_subsi },
  { 0x76000b, CODE_FOR_sync_new_subdi },
  { 0x770008, CODE_FOR_sync_new_iorqi },
  { 0x770009, CODE_FOR_sync_new_iorhi },
  { 0x77000a, CODE_FOR_sync_new_iorsi },
  { 0x77000b, CODE_FOR_sync_new_iordi },
  { 0x780008, CODE_FOR_sync_new_andqi },
  { 0x780009, CODE_FOR_sync_new_andhi },
  { 0x78000a, CODE_FOR_sync_new_andsi },
  { 0x78000b, CODE_FOR_sync_new_anddi },
  { 0x790008, CODE_FOR_sync_new_xorqi },
  { 0x790009, CODE_FOR_sync_new_xorhi },
  { 0x79000a, CODE_FOR_sync_new_xorsi },
  { 0x79000b, CODE_FOR_sync_new_xordi },
  { 0x7a0008, CODE_FOR_sync_new_nandqi },
  { 0x7a0009, CODE_FOR_sync_new_nandhi },
  { 0x7a000a, CODE_FOR_sync_new_nandsi },
  { 0x7a000b, CODE_FOR_sync_new_nanddi },
  { 0x7b0008, CODE_FOR_sync_compare_and_swapqi },
  { 0x7b0009, CODE_FOR_sync_compare_and_swaphi },
  { 0x7b000a, CODE_FOR_sync_compare_and_swapsi },
  { 0x7b000b, CODE_FOR_sync_compare_and_swapdi },
  { 0x7c0008, CODE_FOR_sync_lock_test_and_setqi },
  { 0x7c0009, CODE_FOR_sync_lock_test_and_sethi },
  { 0x7c000a, CODE_FOR_sync_lock_test_and_setsi },
  { 0x7c000b, CODE_FOR_sync_lock_test_and_setdi },
  { 0x7d0006, CODE_FOR_movccf },
  { 0x7d0008, CODE_FOR_movqi },
  { 0x7d0009, CODE_FOR_movhi },
  { 0x7d000a, CODE_FOR_movsi },
  { 0x7d000b, CODE_FOR_movdi },
  { 0x7d000c, CODE_FOR_movti },
  { 0x7d001f, CODE_FOR_movsf },
  { 0x7d0020, CODE_FOR_movdf },
  { 0x7d0021, CODE_FOR_movtf },
  { 0x7d002d, CODE_FOR_movv4qi },
  { 0x7d002e, CODE_FOR_movv2hi },
  { 0x7d002f, CODE_FOR_movv8qi },
  { 0x7d0030, CODE_FOR_movv4hi },
  { 0x7d0031, CODE_FOR_movv2si },
  { 0x7d0032, CODE_FOR_movv16qi },
  { 0x7d0033, CODE_FOR_movv8hi },
  { 0x7d0034, CODE_FOR_movv4si },
  { 0x7d0035, CODE_FOR_movv2di },
  { 0x7d003a, CODE_FOR_movv4qq },
  { 0x7d003b, CODE_FOR_movv2hq },
  { 0x7d003c, CODE_FOR_movv4uqq },
  { 0x7d003d, CODE_FOR_movv2uhq },
  { 0x7d003e, CODE_FOR_movv2ha },
  { 0x7d003f, CODE_FOR_movv2uha },
  { 0x7d0040, CODE_FOR_movv2sf },
  { 0x7d0041, CODE_FOR_movv4sf },
  { 0x7d0042, CODE_FOR_movv2df },
  { 0x7f0032, CODE_FOR_movmisalignv16qi },
  { 0x7f0033, CODE_FOR_movmisalignv8hi },
  { 0x7f0034, CODE_FOR_movmisalignv4si },
  { 0x7f0035, CODE_FOR_movmisalignv2di },
  { 0x7f0041, CODE_FOR_movmisalignv4sf },
  { 0x7f0042, CODE_FOR_movmisalignv2df },
  { 0x81000a, CODE_FOR_insvsi },
  { 0x81000b, CODE_FOR_insvdi },
  { 0x82000a, CODE_FOR_extvsi },
  { 0x82000b, CODE_FOR_extvdi },
  { 0x83000a, CODE_FOR_extzvsi },
  { 0x83000b, CODE_FOR_extzvdi },
  { 0x84000a, CODE_FOR_insvmisalignsi },
  { 0x84000b, CODE_FOR_insvmisaligndi },
  { 0x85000a, CODE_FOR_extvmisalignsi },
  { 0x85000b, CODE_FOR_extvmisaligndi },
  { 0x86000a, CODE_FOR_extzvmisalignsi },
  { 0x86000b, CODE_FOR_extzvmisaligndi },
  { 0x8a000a, CODE_FOR_cbranchsi4 },
  { 0x8a000b, CODE_FOR_cbranchdi4 },
  { 0x8a001f, CODE_FOR_cbranchsf4 },
  { 0x8a0020, CODE_FOR_cbranchdf4 },
  { 0x8e000a, CODE_FOR_movsicc },
  { 0x8e000b, CODE_FOR_movdicc },
  { 0x8e001f, CODE_FOR_movsfcc },
  { 0x8e0020, CODE_FOR_movdfcc },
  { 0x8e0040, CODE_FOR_movv2sfcc },
  { 0xa2000a, CODE_FOR_cstoresi4 },
  { 0xa2000b, CODE_FOR_cstoredi4 },
  { 0xa3000a, CODE_FOR_ctrapsi4 },
  { 0xa3000b, CODE_FOR_ctrapdi4 },
  { 0xac000a, CODE_FOR_smulsi3_highpart },
  { 0xac000b, CODE_FOR_smuldi3_highpart },
  { 0xac0030, CODE_FOR_smulv4hi3_highpart },
  { 0xad000a, CODE_FOR_umulsi3_highpart },
  { 0xad000b, CODE_FOR_umuldi3_highpart },
  { 0xad0030, CODE_FOR_umulv4hi3_highpart },
  { 0xb1000a, CODE_FOR_movmemsi },
  { 0xb4001f, CODE_FOR_fmasf4 },
  { 0xb40020, CODE_FOR_fmadf4 },
  { 0xb40040, CODE_FOR_fmav2sf4 },
  { 0xb40041, CODE_FOR_fmav4sf4 },
  { 0xb40042, CODE_FOR_fmav2df4 },
  { 0xb5001f, CODE_FOR_fmssf4 },
  { 0xb50020, CODE_FOR_fmsdf4 },
  { 0xb50040, CODE_FOR_fmsv2sf4 },
  { 0xb6001f, CODE_FOR_fnmasf4 },
  { 0xb60020, CODE_FOR_fnmadf4 },
  { 0xb60040, CODE_FOR_fnmav2sf4 },
  { 0xb60041, CODE_FOR_fnmav4sf4 },
  { 0xb60042, CODE_FOR_fnmav2df4 },
  { 0xb7001f, CODE_FOR_fnmssf4 },
  { 0xb70020, CODE_FOR_fnmsdf4 },
  { 0xb70040, CODE_FOR_fnmsv2sf4 },
  { 0xe4002f, CODE_FOR_reduc_smax_scal_v8qi },
  { 0xe40030, CODE_FOR_reduc_smax_scal_v4hi },
  { 0xe40031, CODE_FOR_reduc_smax_scal_v2si },
  { 0xe40040, CODE_FOR_reduc_smax_scal_v2sf },
  { 0xe5002f, CODE_FOR_reduc_smin_scal_v8qi },
  { 0xe50030, CODE_FOR_reduc_smin_scal_v4hi },
  { 0xe50031, CODE_FOR_reduc_smin_scal_v2si },
  { 0xe50040, CODE_FOR_reduc_smin_scal_v2sf },
  { 0xe6002f, CODE_FOR_reduc_plus_scal_v8qi },
  { 0xe60030, CODE_FOR_reduc_plus_scal_v4hi },
  { 0xe60031, CODE_FOR_reduc_plus_scal_v2si },
  { 0xe60040, CODE_FOR_reduc_plus_scal_v2sf },
  { 0xe7002f, CODE_FOR_reduc_umax_scal_v8qi },
  { 0xe8002f, CODE_FOR_reduc_umin_scal_v8qi },
  { 0xf30030, CODE_FOR_sdot_prodv4hi },
  { 0xfa0030, CODE_FOR_vec_pack_ssat_v4hi },
  { 0xfa0031, CODE_FOR_vec_pack_ssat_v2si },
  { 0xfb0033, CODE_FOR_vec_pack_trunc_v8hi },
  { 0xfb0034, CODE_FOR_vec_pack_trunc_v4si },
  { 0xfb0035, CODE_FOR_vec_pack_trunc_v2di },
  { 0xfb0042, CODE_FOR_vec_pack_trunc_v2df },
  { 0xfe0030, CODE_FOR_vec_pack_usat_v4hi },
  { 0x1010032, CODE_FOR_vec_permv16qi },
  { 0x1010033, CODE_FOR_vec_permv8hi },
  { 0x1010034, CODE_FOR_vec_permv4si },
  { 0x1010035, CODE_FOR_vec_permv2di },
  { 0x1010041, CODE_FOR_vec_permv4sf },
  { 0x1010042, CODE_FOR_vec_permv2df },
  { 0x1030030, CODE_FOR_vec_setv4hi },
  { 0x1030032, CODE_FOR_vec_setv16qi },
  { 0x1030033, CODE_FOR_vec_setv8hi },
  { 0x1030034, CODE_FOR_vec_setv4si },
  { 0x1030035, CODE_FOR_vec_setv2di },
  { 0x1030040, CODE_FOR_vec_setv2sf },
  { 0x1030041, CODE_FOR_vec_setv4sf },
  { 0x1030042, CODE_FOR_vec_setv2df },
  { 0x104000b, CODE_FOR_vec_shr_di },
  { 0x104002f, CODE_FOR_vec_shr_v8qi },
  { 0x1040030, CODE_FOR_vec_shr_v4hi },
  { 0x1040031, CODE_FOR_vec_shr_v2si },
  { 0x10b002f, CODE_FOR_vec_unpacks_hi_v8qi },
  { 0x10b0030, CODE_FOR_vec_unpacks_hi_v4hi },
  { 0x10b0032, CODE_FOR_vec_unpacks_hi_v16qi },
  { 0x10b0033, CODE_FOR_vec_unpacks_hi_v8hi },
  { 0x10b0034, CODE_FOR_vec_unpacks_hi_v4si },
  { 0x10b0041, CODE_FOR_vec_unpacks_hi_v4sf },
  { 0x10c002f, CODE_FOR_vec_unpacks_lo_v8qi },
  { 0x10c0030, CODE_FOR_vec_unpacks_lo_v4hi },
  { 0x10c0032, CODE_FOR_vec_unpacks_lo_v16qi },
  { 0x10c0033, CODE_FOR_vec_unpacks_lo_v8hi },
  { 0x10c0034, CODE_FOR_vec_unpacks_lo_v4si },
  { 0x10c0041, CODE_FOR_vec_unpacks_lo_v4sf },
  { 0x111002f, CODE_FOR_vec_unpacku_hi_v8qi },
  { 0x1110030, CODE_FOR_vec_unpacku_hi_v4hi },
  { 0x1110032, CODE_FOR_vec_unpacku_hi_v16qi },
  { 0x1110033, CODE_FOR_vec_unpacku_hi_v8hi },
  { 0x1110034, CODE_FOR_vec_unpacku_hi_v4si },
  { 0x112002f, CODE_FOR_vec_unpacku_lo_v8qi },
  { 0x1120030, CODE_FOR_vec_unpacku_lo_v4hi },
  { 0x1120032, CODE_FOR_vec_unpacku_lo_v16qi },
  { 0x1120033, CODE_FOR_vec_unpacku_lo_v8hi },
  { 0x1120034, CODE_FOR_vec_unpacku_lo_v4si },
  { 0x11f0008, CODE_FOR_sync_addqi },
  { 0x11f0009, CODE_FOR_sync_addhi },
  { 0x11f000a, CODE_FOR_sync_addsi },
  { 0x11f000b, CODE_FOR_sync_adddi },
  { 0x1200008, CODE_FOR_sync_andqi },
  { 0x1200009, CODE_FOR_sync_andhi },
  { 0x120000a, CODE_FOR_sync_andsi },
  { 0x120000b, CODE_FOR_sync_anddi },
  { 0x1210008, CODE_FOR_sync_iorqi },
  { 0x1210009, CODE_FOR_sync_iorhi },
  { 0x121000a, CODE_FOR_sync_iorsi },
  { 0x121000b, CODE_FOR_sync_iordi },
  { 0x1230008, CODE_FOR_sync_nandqi },
  { 0x1230009, CODE_FOR_sync_nandhi },
  { 0x123000a, CODE_FOR_sync_nandsi },
  { 0x123000b, CODE_FOR_sync_nanddi },
  { 0x1240008, CODE_FOR_sync_subqi },
  { 0x1240009, CODE_FOR_sync_subhi },
  { 0x124000a, CODE_FOR_sync_subsi },
  { 0x124000b, CODE_FOR_sync_subdi },
  { 0x1250008, CODE_FOR_sync_xorqi },
  { 0x1250009, CODE_FOR_sync_xorhi },
  { 0x125000a, CODE_FOR_sync_xorsi },
  { 0x125000b, CODE_FOR_sync_xordi },
  { 0x12d000a, CODE_FOR_atomic_compare_and_swapsi },
  { 0x12d000b, CODE_FOR_atomic_compare_and_swapdi },
  { 0x12e000a, CODE_FOR_atomic_exchangesi },
  { 0x12e000b, CODE_FOR_atomic_exchangedi },
  { 0x12f000a, CODE_FOR_atomic_fetch_addsi },
  { 0x12f000b, CODE_FOR_atomic_fetch_adddi },
  { 0x13f000a, CODE_FOR_get_thread_pointersi },
  { 0x13f000b, CODE_FOR_get_thread_pointerdi },
};

void
init_all_optabs (struct target_optabs *optabs)
{
  bool *ena = optabs->pat_enable;
  ena[0] = HAVE_extendqihi2;
  ena[1] = HAVE_extendqisi2;
  ena[2] = HAVE_extendqidi2;
  ena[3] = HAVE_extendhisi2;
  ena[4] = HAVE_extendhidi2;
  ena[5] = HAVE_extendsidi2;
  ena[6] = HAVE_extendsfdf2;
  ena[7] = HAVE_truncdiqi2;
  ena[8] = HAVE_truncdihi2;
  ena[9] = HAVE_truncdisi2;
  ena[10] = HAVE_truncdfsf2;
  ena[11] = HAVE_zero_extendqihi2;
  ena[12] = HAVE_zero_extendqisi2;
  ena[13] = HAVE_zero_extendqidi2;
  ena[14] = HAVE_zero_extendhisi2;
  ena[15] = HAVE_zero_extendhidi2;
  ena[16] = HAVE_zero_extendsidi2;
  ena[17] = HAVE_floatsisf2;
  ena[18] = HAVE_floatsidf2;
  ena[19] = HAVE_floatdisf2;
  ena[20] = HAVE_floatdidf2;
  ena[21] = HAVE_floatv4siv4sf2;
  ena[22] = HAVE_floatv2div2df2;
  ena[23] = HAVE_floatunsv4siv4sf2;
  ena[24] = HAVE_floatunsv2div2df2;
  ena[25] = HAVE_fix_truncsfsi2;
  ena[26] = HAVE_fix_truncsfdi2;
  ena[27] = HAVE_fix_truncdfsi2;
  ena[28] = HAVE_fix_truncdfdi2;
  ena[29] = HAVE_fix_truncv4sfv4si2;
  ena[30] = HAVE_fix_truncv2dfv2di2;
  ena[31] = HAVE_fixuns_truncsfsi2;
  ena[32] = HAVE_fixuns_truncsfdi2;
  ena[33] = HAVE_fixuns_truncdfsi2;
  ena[34] = HAVE_fixuns_truncdfdi2;
  ena[35] = HAVE_fixuns_truncv4sfv4si2;
  ena[36] = HAVE_fixuns_truncv2dfv2di2;
  ena[37] = HAVE_mulsidi3;
  ena[38] = HAVE_mulditi3;
  ena[39] = HAVE_umulsidi3;
  ena[40] = HAVE_umulditi3;
  ena[41] = HAVE_maddsidi4;
  ena[42] = HAVE_umaddsidi4;
  ena[43] = HAVE_ssmaddsqdq4;
  ena[44] = HAVE_msubsidi4;
  ena[45] = HAVE_umsubsidi4;
  ena[46] = HAVE_ssmsubsqdq4;
  ena[47] = HAVE_vcondv16qiv16qi;
  ena[48] = HAVE_vcondv8hiv16qi;
  ena[49] = HAVE_vcondv4siv16qi;
  ena[50] = HAVE_vcondv2div16qi;
  ena[51] = HAVE_vcondv4sfv16qi;
  ena[52] = HAVE_vcondv2dfv16qi;
  ena[53] = HAVE_vcondv16qiv8hi;
  ena[54] = HAVE_vcondv8hiv8hi;
  ena[55] = HAVE_vcondv4siv8hi;
  ena[56] = HAVE_vcondv2div8hi;
  ena[57] = HAVE_vcondv4sfv8hi;
  ena[58] = HAVE_vcondv2dfv8hi;
  ena[59] = HAVE_vcondv16qiv4si;
  ena[60] = HAVE_vcondv8hiv4si;
  ena[61] = HAVE_vcondv4siv4si;
  ena[62] = HAVE_vcondv2div4si;
  ena[63] = HAVE_vcondv4sfv4si;
  ena[64] = HAVE_vcondv2dfv4si;
  ena[65] = HAVE_vcondv16qiv2di;
  ena[66] = HAVE_vcondv8hiv2di;
  ena[67] = HAVE_vcondv4siv2di;
  ena[68] = HAVE_vcondv2div2di;
  ena[69] = HAVE_vcondv4sfv2di;
  ena[70] = HAVE_vcondv2dfv2di;
  ena[71] = HAVE_vcondv2sfv2sf;
  ena[72] = HAVE_vcondv16qiv4sf;
  ena[73] = HAVE_vcondv8hiv4sf;
  ena[74] = HAVE_vcondv4siv4sf;
  ena[75] = HAVE_vcondv2div4sf;
  ena[76] = HAVE_vcondv4sfv4sf;
  ena[77] = HAVE_vcondv2dfv4sf;
  ena[78] = HAVE_vcondv16qiv2df;
  ena[79] = HAVE_vcondv8hiv2df;
  ena[80] = HAVE_vcondv4siv2df;
  ena[81] = HAVE_vcondv2div2df;
  ena[82] = HAVE_vcondv4sfv2df;
  ena[83] = HAVE_vcondv2dfv2df;
  ena[84] = HAVE_vconduv16qiv16qi;
  ena[85] = HAVE_vconduv8hiv16qi;
  ena[86] = HAVE_vconduv4siv16qi;
  ena[87] = HAVE_vconduv2div16qi;
  ena[88] = HAVE_vconduv4sfv16qi;
  ena[89] = HAVE_vconduv2dfv16qi;
  ena[90] = HAVE_vconduv16qiv8hi;
  ena[91] = HAVE_vconduv8hiv8hi;
  ena[92] = HAVE_vconduv4siv8hi;
  ena[93] = HAVE_vconduv2div8hi;
  ena[94] = HAVE_vconduv4sfv8hi;
  ena[95] = HAVE_vconduv2dfv8hi;
  ena[96] = HAVE_vconduv16qiv4si;
  ena[97] = HAVE_vconduv8hiv4si;
  ena[98] = HAVE_vconduv4siv4si;
  ena[99] = HAVE_vconduv2div4si;
  ena[100] = HAVE_vconduv4sfv4si;
  ena[101] = HAVE_vconduv2dfv4si;
  ena[102] = HAVE_vconduv16qiv2di;
  ena[103] = HAVE_vconduv8hiv2di;
  ena[104] = HAVE_vconduv4siv2di;
  ena[105] = HAVE_vconduv2div2di;
  ena[106] = HAVE_vconduv4sfv2di;
  ena[107] = HAVE_vconduv2dfv2di;
  ena[108] = HAVE_vec_extractv16qiqi;
  ena[109] = HAVE_vec_extractv8hihi;
  ena[110] = HAVE_vec_extractv4sisi;
  ena[111] = HAVE_vec_extractv2didi;
  ena[112] = HAVE_vec_extractv2sfsf;
  ena[113] = HAVE_vec_extractv4sfsf;
  ena[114] = HAVE_vec_extractv2dfdf;
  ena[115] = HAVE_vec_initv8qiqi;
  ena[116] = HAVE_vec_initv16qiqi;
  ena[117] = HAVE_vec_initv4hihi;
  ena[118] = HAVE_vec_initv8hihi;
  ena[119] = HAVE_vec_initv2sisi;
  ena[120] = HAVE_vec_initv4sisi;
  ena[121] = HAVE_vec_initv2didi;
  ena[122] = HAVE_vec_initv2sfsf;
  ena[123] = HAVE_vec_initv4sfsf;
  ena[124] = HAVE_vec_initv2dfdf;
  ena[125] = HAVE_addsi3;
  ena[126] = HAVE_adddi3;
  ena[127] = HAVE_addqq3;
  ena[128] = HAVE_addhq3;
  ena[129] = HAVE_addsq3;
  ena[130] = HAVE_adddq3;
  ena[131] = HAVE_adduqq3;
  ena[132] = HAVE_adduhq3;
  ena[133] = HAVE_addusq3;
  ena[134] = HAVE_addudq3;
  ena[135] = HAVE_addha3;
  ena[136] = HAVE_addsa3;
  ena[137] = HAVE_addda3;
  ena[138] = HAVE_adduha3;
  ena[139] = HAVE_addusa3;
  ena[140] = HAVE_adduda3;
  ena[141] = HAVE_addsf3;
  ena[142] = HAVE_adddf3;
  ena[143] = HAVE_addv4qi3;
  ena[144] = HAVE_addv2hi3;
  ena[145] = HAVE_addv8qi3;
  ena[146] = HAVE_addv4hi3;
  ena[147] = HAVE_addv2si3;
  ena[148] = HAVE_addv16qi3;
  ena[149] = HAVE_addv8hi3;
  ena[150] = HAVE_addv4si3;
  ena[151] = HAVE_addv2di3;
  ena[152] = HAVE_addv2sf3;
  ena[153] = HAVE_addv4sf3;
  ena[154] = HAVE_addv2df3;
  ena[155] = HAVE_ssaddhq3;
  ena[156] = HAVE_ssaddsq3;
  ena[157] = HAVE_ssaddha3;
  ena[158] = HAVE_ssaddsa3;
  ena[159] = HAVE_ssaddv2hq3;
  ena[160] = HAVE_ssaddv2ha3;
  ena[161] = HAVE_usadduqq3;
  ena[162] = HAVE_usadduhq3;
  ena[163] = HAVE_usadduha3;
  ena[164] = HAVE_usaddv4uqq3;
  ena[165] = HAVE_usaddv2uhq3;
  ena[166] = HAVE_usaddv2uha3;
  ena[167] = HAVE_subsi3;
  ena[168] = HAVE_subdi3;
  ena[169] = HAVE_subqq3;
  ena[170] = HAVE_subhq3;
  ena[171] = HAVE_subsq3;
  ena[172] = HAVE_subdq3;
  ena[173] = HAVE_subuqq3;
  ena[174] = HAVE_subuhq3;
  ena[175] = HAVE_subusq3;
  ena[176] = HAVE_subudq3;
  ena[177] = HAVE_subha3;
  ena[178] = HAVE_subsa3;
  ena[179] = HAVE_subda3;
  ena[180] = HAVE_subuha3;
  ena[181] = HAVE_subusa3;
  ena[182] = HAVE_subuda3;
  ena[183] = HAVE_subsf3;
  ena[184] = HAVE_subdf3;
  ena[185] = HAVE_subv4qi3;
  ena[186] = HAVE_subv2hi3;
  ena[187] = HAVE_subv8qi3;
  ena[188] = HAVE_subv4hi3;
  ena[189] = HAVE_subv2si3;
  ena[190] = HAVE_subv16qi3;
  ena[191] = HAVE_subv8hi3;
  ena[192] = HAVE_subv4si3;
  ena[193] = HAVE_subv2di3;
  ena[194] = HAVE_subv2sf3;
  ena[195] = HAVE_subv4sf3;
  ena[196] = HAVE_subv2df3;
  ena[197] = HAVE_sssubhq3;
  ena[198] = HAVE_sssubsq3;
  ena[199] = HAVE_sssubha3;
  ena[200] = HAVE_sssubsa3;
  ena[201] = HAVE_sssubv2hq3;
  ena[202] = HAVE_sssubv2ha3;
  ena[203] = HAVE_ussubuqq3;
  ena[204] = HAVE_ussubuhq3;
  ena[205] = HAVE_ussubuha3;
  ena[206] = HAVE_ussubv4uqq3;
  ena[207] = HAVE_ussubv2uhq3;
  ena[208] = HAVE_ussubv2uha3;
  ena[209] = HAVE_mulsi3;
  ena[210] = HAVE_muldi3;
  ena[211] = HAVE_mulsf3;
  ena[212] = HAVE_muldf3;
  ena[213] = HAVE_mulv2hi3;
  ena[214] = HAVE_mulv4hi3;
  ena[215] = HAVE_mulv16qi3;
  ena[216] = HAVE_mulv8hi3;
  ena[217] = HAVE_mulv4si3;
  ena[218] = HAVE_mulv2di3;
  ena[219] = HAVE_mulv2sf3;
  ena[220] = HAVE_mulv4sf3;
  ena[221] = HAVE_mulv2df3;
  ena[222] = HAVE_ssmulhq3;
  ena[223] = HAVE_ssmulsq3;
  ena[224] = HAVE_ssmulv2hq3;
  ena[225] = HAVE_divsi3;
  ena[226] = HAVE_divdi3;
  ena[227] = HAVE_divsf3;
  ena[228] = HAVE_divdf3;
  ena[229] = HAVE_divv16qi3;
  ena[230] = HAVE_divv8hi3;
  ena[231] = HAVE_divv4si3;
  ena[232] = HAVE_divv2di3;
  ena[233] = HAVE_divv2sf3;
  ena[234] = HAVE_divv4sf3;
  ena[235] = HAVE_divv2df3;
  ena[236] = HAVE_udivsi3;
  ena[237] = HAVE_udivdi3;
  ena[238] = HAVE_udivv16qi3;
  ena[239] = HAVE_udivv8hi3;
  ena[240] = HAVE_udivv4si3;
  ena[241] = HAVE_udivv2di3;
  ena[242] = HAVE_divmodsi4;
  ena[243] = HAVE_divmoddi4;
  ena[244] = HAVE_udivmodsi4;
  ena[245] = HAVE_udivmoddi4;
  ena[246] = HAVE_modsi3;
  ena[247] = HAVE_moddi3;
  ena[248] = HAVE_modv16qi3;
  ena[249] = HAVE_modv8hi3;
  ena[250] = HAVE_modv4si3;
  ena[251] = HAVE_modv2di3;
  ena[252] = HAVE_umodsi3;
  ena[253] = HAVE_umoddi3;
  ena[254] = HAVE_umodv16qi3;
  ena[255] = HAVE_umodv8hi3;
  ena[256] = HAVE_umodv4si3;
  ena[257] = HAVE_umodv2di3;
  ena[258] = HAVE_andsi3;
  ena[259] = HAVE_anddi3;
  ena[260] = HAVE_andv8qi3;
  ena[261] = HAVE_andv4hi3;
  ena[262] = HAVE_andv2si3;
  ena[263] = HAVE_andv16qi3;
  ena[264] = HAVE_andv8hi3;
  ena[265] = HAVE_andv4si3;
  ena[266] = HAVE_andv2di3;
  ena[267] = HAVE_iorsi3;
  ena[268] = HAVE_iordi3;
  ena[269] = HAVE_iorv8qi3;
  ena[270] = HAVE_iorv4hi3;
  ena[271] = HAVE_iorv2si3;
  ena[272] = HAVE_iorv16qi3;
  ena[273] = HAVE_iorv8hi3;
  ena[274] = HAVE_iorv4si3;
  ena[275] = HAVE_iorv2di3;
  ena[276] = HAVE_xorsi3;
  ena[277] = HAVE_xordi3;
  ena[278] = HAVE_xorv8qi3;
  ena[279] = HAVE_xorv4hi3;
  ena[280] = HAVE_xorv2si3;
  ena[281] = HAVE_xorv16qi3;
  ena[282] = HAVE_xorv8hi3;
  ena[283] = HAVE_xorv4si3;
  ena[284] = HAVE_xorv2di3;
  ena[285] = HAVE_ashlsi3;
  ena[286] = HAVE_ashldi3;
  ena[287] = HAVE_ashlv4hi3;
  ena[288] = HAVE_ashlv2si3;
  ena[289] = HAVE_ashrsi3;
  ena[290] = HAVE_ashrdi3;
  ena[291] = HAVE_ashrv4hi3;
  ena[292] = HAVE_ashrv2si3;
  ena[293] = HAVE_lshrsi3;
  ena[294] = HAVE_lshrdi3;
  ena[295] = HAVE_lshrv4hi3;
  ena[296] = HAVE_lshrv2si3;
  ena[297] = HAVE_rotrsi3;
  ena[298] = HAVE_rotrdi3;
  ena[299] = HAVE_vashlv16qi3;
  ena[300] = HAVE_vashlv8hi3;
  ena[301] = HAVE_vashlv4si3;
  ena[302] = HAVE_vashlv2di3;
  ena[303] = HAVE_vashrv16qi3;
  ena[304] = HAVE_vashrv8hi3;
  ena[305] = HAVE_vashrv4si3;
  ena[306] = HAVE_vashrv2di3;
  ena[307] = HAVE_vlshrv16qi3;
  ena[308] = HAVE_vlshrv8hi3;
  ena[309] = HAVE_vlshrv4si3;
  ena[310] = HAVE_vlshrv2di3;
  ena[311] = HAVE_sminv8qi3;
  ena[312] = HAVE_sminv4hi3;
  ena[313] = HAVE_sminv2si3;
  ena[314] = HAVE_sminv16qi3;
  ena[315] = HAVE_sminv8hi3;
  ena[316] = HAVE_sminv4si3;
  ena[317] = HAVE_sminv2di3;
  ena[318] = HAVE_sminv2sf3;
  ena[319] = HAVE_sminv4sf3;
  ena[320] = HAVE_sminv2df3;
  ena[321] = HAVE_smaxv8qi3;
  ena[322] = HAVE_smaxv4hi3;
  ena[323] = HAVE_smaxv2si3;
  ena[324] = HAVE_smaxv16qi3;
  ena[325] = HAVE_smaxv8hi3;
  ena[326] = HAVE_smaxv4si3;
  ena[327] = HAVE_smaxv2di3;
  ena[328] = HAVE_smaxv2sf3;
  ena[329] = HAVE_smaxv4sf3;
  ena[330] = HAVE_smaxv2df3;
  ena[331] = HAVE_uminv8qi3;
  ena[332] = HAVE_uminv16qi3;
  ena[333] = HAVE_uminv8hi3;
  ena[334] = HAVE_uminv4si3;
  ena[335] = HAVE_uminv2di3;
  ena[336] = HAVE_umaxv8qi3;
  ena[337] = HAVE_umaxv16qi3;
  ena[338] = HAVE_umaxv8hi3;
  ena[339] = HAVE_umaxv4si3;
  ena[340] = HAVE_umaxv2di3;
  ena[341] = HAVE_negsi2;
  ena[342] = HAVE_negdi2;
  ena[343] = HAVE_negsf2;
  ena[344] = HAVE_negdf2;
  ena[345] = HAVE_negv16qi2;
  ena[346] = HAVE_negv8hi2;
  ena[347] = HAVE_negv4si2;
  ena[348] = HAVE_negv2di2;
  ena[349] = HAVE_negv2sf2;
  ena[350] = HAVE_negv4sf2;
  ena[351] = HAVE_negv2df2;
  ena[352] = HAVE_abssf2;
  ena[353] = HAVE_absdf2;
  ena[354] = HAVE_absv16qi2;
  ena[355] = HAVE_absv8hi2;
  ena[356] = HAVE_absv4si2;
  ena[357] = HAVE_absv2di2;
  ena[358] = HAVE_absv2sf2;
  ena[359] = HAVE_one_cmplsi2;
  ena[360] = HAVE_one_cmpldi2;
  ena[361] = HAVE_one_cmplv8qi2;
  ena[362] = HAVE_one_cmplv4hi2;
  ena[363] = HAVE_one_cmplv2si2;
  ena[364] = HAVE_one_cmplv16qi2;
  ena[365] = HAVE_one_cmplv8hi2;
  ena[366] = HAVE_one_cmplv4si2;
  ena[367] = HAVE_one_cmplv2di2;
  ena[368] = HAVE_bswaphi2;
  ena[369] = HAVE_bswapsi2;
  ena[370] = HAVE_bswapdi2;
  ena[371] = HAVE_clzsi2;
  ena[372] = HAVE_clzdi2;
  ena[373] = HAVE_clzv16qi2;
  ena[374] = HAVE_clzv8hi2;
  ena[375] = HAVE_clzv4si2;
  ena[376] = HAVE_clzv2di2;
  ena[377] = HAVE_ctzsi2;
  ena[378] = HAVE_ctzdi2;
  ena[379] = HAVE_popcountsi2;
  ena[380] = HAVE_popcountdi2;
  ena[381] = HAVE_popcountv16qi2;
  ena[382] = HAVE_popcountv8hi2;
  ena[383] = HAVE_popcountv4si2;
  ena[384] = HAVE_popcountv2di2;
  ena[385] = HAVE_sqrtsf2;
  ena[386] = HAVE_sqrtdf2;
  ena[387] = HAVE_sqrtv2sf2;
  ena[388] = HAVE_sqrtv4sf2;
  ena[389] = HAVE_sqrtv2df2;
  ena[390] = HAVE_sync_old_addqi;
  ena[391] = HAVE_sync_old_addhi;
  ena[392] = HAVE_sync_old_addsi;
  ena[393] = HAVE_sync_old_adddi;
  ena[394] = HAVE_sync_old_subqi;
  ena[395] = HAVE_sync_old_subhi;
  ena[396] = HAVE_sync_old_subsi;
  ena[397] = HAVE_sync_old_subdi;
  ena[398] = HAVE_sync_old_iorqi;
  ena[399] = HAVE_sync_old_iorhi;
  ena[400] = HAVE_sync_old_iorsi;
  ena[401] = HAVE_sync_old_iordi;
  ena[402] = HAVE_sync_old_andqi;
  ena[403] = HAVE_sync_old_andhi;
  ena[404] = HAVE_sync_old_andsi;
  ena[405] = HAVE_sync_old_anddi;
  ena[406] = HAVE_sync_old_xorqi;
  ena[407] = HAVE_sync_old_xorhi;
  ena[408] = HAVE_sync_old_xorsi;
  ena[409] = HAVE_sync_old_xordi;
  ena[410] = HAVE_sync_old_nandqi;
  ena[411] = HAVE_sync_old_nandhi;
  ena[412] = HAVE_sync_old_nandsi;
  ena[413] = HAVE_sync_old_nanddi;
  ena[414] = HAVE_sync_new_addqi;
  ena[415] = HAVE_sync_new_addhi;
  ena[416] = HAVE_sync_new_addsi;
  ena[417] = HAVE_sync_new_adddi;
  ena[418] = HAVE_sync_new_subqi;
  ena[419] = HAVE_sync_new_subhi;
  ena[420] = HAVE_sync_new_subsi;
  ena[421] = HAVE_sync_new_subdi;
  ena[422] = HAVE_sync_new_iorqi;
  ena[423] = HAVE_sync_new_iorhi;
  ena[424] = HAVE_sync_new_iorsi;
  ena[425] = HAVE_sync_new_iordi;
  ena[426] = HAVE_sync_new_andqi;
  ena[427] = HAVE_sync_new_andhi;
  ena[428] = HAVE_sync_new_andsi;
  ena[429] = HAVE_sync_new_anddi;
  ena[430] = HAVE_sync_new_xorqi;
  ena[431] = HAVE_sync_new_xorhi;
  ena[432] = HAVE_sync_new_xorsi;
  ena[433] = HAVE_sync_new_xordi;
  ena[434] = HAVE_sync_new_nandqi;
  ena[435] = HAVE_sync_new_nandhi;
  ena[436] = HAVE_sync_new_nandsi;
  ena[437] = HAVE_sync_new_nanddi;
  ena[438] = HAVE_sync_compare_and_swapqi;
  ena[439] = HAVE_sync_compare_and_swaphi;
  ena[440] = HAVE_sync_compare_and_swapsi;
  ena[441] = HAVE_sync_compare_and_swapdi;
  ena[442] = HAVE_sync_lock_test_and_setqi;
  ena[443] = HAVE_sync_lock_test_and_sethi;
  ena[444] = HAVE_sync_lock_test_and_setsi;
  ena[445] = HAVE_sync_lock_test_and_setdi;
  ena[446] = HAVE_movccf;
  ena[447] = HAVE_movqi;
  ena[448] = HAVE_movhi;
  ena[449] = HAVE_movsi;
  ena[450] = HAVE_movdi;
  ena[451] = HAVE_movti;
  ena[452] = HAVE_movsf;
  ena[453] = HAVE_movdf;
  ena[454] = HAVE_movtf;
  ena[455] = HAVE_movv4qi;
  ena[456] = HAVE_movv2hi;
  ena[457] = HAVE_movv8qi;
  ena[458] = HAVE_movv4hi;
  ena[459] = HAVE_movv2si;
  ena[460] = HAVE_movv16qi;
  ena[461] = HAVE_movv8hi;
  ena[462] = HAVE_movv4si;
  ena[463] = HAVE_movv2di;
  ena[464] = HAVE_movv4qq;
  ena[465] = HAVE_movv2hq;
  ena[466] = HAVE_movv4uqq;
  ena[467] = HAVE_movv2uhq;
  ena[468] = HAVE_movv2ha;
  ena[469] = HAVE_movv2uha;
  ena[470] = HAVE_movv2sf;
  ena[471] = HAVE_movv4sf;
  ena[472] = HAVE_movv2df;
  ena[473] = HAVE_movmisalignv16qi;
  ena[474] = HAVE_movmisalignv8hi;
  ena[475] = HAVE_movmisalignv4si;
  ena[476] = HAVE_movmisalignv2di;
  ena[477] = HAVE_movmisalignv4sf;
  ena[478] = HAVE_movmisalignv2df;
  ena[479] = HAVE_insvsi;
  ena[480] = HAVE_insvdi;
  ena[481] = HAVE_extvsi;
  ena[482] = HAVE_extvdi;
  ena[483] = HAVE_extzvsi;
  ena[484] = HAVE_extzvdi;
  ena[485] = HAVE_insvmisalignsi;
  ena[486] = HAVE_insvmisaligndi;
  ena[487] = HAVE_extvmisalignsi;
  ena[488] = HAVE_extvmisaligndi;
  ena[489] = HAVE_extzvmisalignsi;
  ena[490] = HAVE_extzvmisaligndi;
  ena[491] = HAVE_cbranchsi4;
  ena[492] = HAVE_cbranchdi4;
  ena[493] = HAVE_cbranchsf4;
  ena[494] = HAVE_cbranchdf4;
  ena[495] = HAVE_movsicc;
  ena[496] = HAVE_movdicc;
  ena[497] = HAVE_movsfcc;
  ena[498] = HAVE_movdfcc;
  ena[499] = HAVE_movv2sfcc;
  ena[500] = HAVE_cstoresi4;
  ena[501] = HAVE_cstoredi4;
  ena[502] = HAVE_ctrapsi4;
  ena[503] = HAVE_ctrapdi4;
  ena[504] = HAVE_smulsi3_highpart;
  ena[505] = HAVE_smuldi3_highpart;
  ena[506] = HAVE_smulv4hi3_highpart;
  ena[507] = HAVE_umulsi3_highpart;
  ena[508] = HAVE_umuldi3_highpart;
  ena[509] = HAVE_umulv4hi3_highpart;
  ena[510] = HAVE_movmemsi;
  ena[511] = HAVE_fmasf4;
  ena[512] = HAVE_fmadf4;
  ena[513] = HAVE_fmav2sf4;
  ena[514] = HAVE_fmav4sf4;
  ena[515] = HAVE_fmav2df4;
  ena[516] = HAVE_fmssf4;
  ena[517] = HAVE_fmsdf4;
  ena[518] = HAVE_fmsv2sf4;
  ena[519] = HAVE_fnmasf4;
  ena[520] = HAVE_fnmadf4;
  ena[521] = HAVE_fnmav2sf4;
  ena[522] = HAVE_fnmav4sf4;
  ena[523] = HAVE_fnmav2df4;
  ena[524] = HAVE_fnmssf4;
  ena[525] = HAVE_fnmsdf4;
  ena[526] = HAVE_fnmsv2sf4;
  ena[527] = HAVE_reduc_smax_scal_v8qi;
  ena[528] = HAVE_reduc_smax_scal_v4hi;
  ena[529] = HAVE_reduc_smax_scal_v2si;
  ena[530] = HAVE_reduc_smax_scal_v2sf;
  ena[531] = HAVE_reduc_smin_scal_v8qi;
  ena[532] = HAVE_reduc_smin_scal_v4hi;
  ena[533] = HAVE_reduc_smin_scal_v2si;
  ena[534] = HAVE_reduc_smin_scal_v2sf;
  ena[535] = HAVE_reduc_plus_scal_v8qi;
  ena[536] = HAVE_reduc_plus_scal_v4hi;
  ena[537] = HAVE_reduc_plus_scal_v2si;
  ena[538] = HAVE_reduc_plus_scal_v2sf;
  ena[539] = HAVE_reduc_umax_scal_v8qi;
  ena[540] = HAVE_reduc_umin_scal_v8qi;
  ena[541] = HAVE_sdot_prodv4hi;
  ena[542] = HAVE_vec_pack_ssat_v4hi;
  ena[543] = HAVE_vec_pack_ssat_v2si;
  ena[544] = HAVE_vec_pack_trunc_v8hi;
  ena[545] = HAVE_vec_pack_trunc_v4si;
  ena[546] = HAVE_vec_pack_trunc_v2di;
  ena[547] = HAVE_vec_pack_trunc_v2df;
  ena[548] = HAVE_vec_pack_usat_v4hi;
  ena[549] = HAVE_vec_permv16qi;
  ena[550] = HAVE_vec_permv8hi;
  ena[551] = HAVE_vec_permv4si;
  ena[552] = HAVE_vec_permv2di;
  ena[553] = HAVE_vec_permv4sf;
  ena[554] = HAVE_vec_permv2df;
  ena[555] = HAVE_vec_setv4hi;
  ena[556] = HAVE_vec_setv16qi;
  ena[557] = HAVE_vec_setv8hi;
  ena[558] = HAVE_vec_setv4si;
  ena[559] = HAVE_vec_setv2di;
  ena[560] = HAVE_vec_setv2sf;
  ena[561] = HAVE_vec_setv4sf;
  ena[562] = HAVE_vec_setv2df;
  ena[563] = HAVE_vec_shr_di;
  ena[564] = HAVE_vec_shr_v8qi;
  ena[565] = HAVE_vec_shr_v4hi;
  ena[566] = HAVE_vec_shr_v2si;
  ena[567] = HAVE_vec_unpacks_hi_v8qi;
  ena[568] = HAVE_vec_unpacks_hi_v4hi;
  ena[569] = HAVE_vec_unpacks_hi_v16qi;
  ena[570] = HAVE_vec_unpacks_hi_v8hi;
  ena[571] = HAVE_vec_unpacks_hi_v4si;
  ena[572] = HAVE_vec_unpacks_hi_v4sf;
  ena[573] = HAVE_vec_unpacks_lo_v8qi;
  ena[574] = HAVE_vec_unpacks_lo_v4hi;
  ena[575] = HAVE_vec_unpacks_lo_v16qi;
  ena[576] = HAVE_vec_unpacks_lo_v8hi;
  ena[577] = HAVE_vec_unpacks_lo_v4si;
  ena[578] = HAVE_vec_unpacks_lo_v4sf;
  ena[579] = HAVE_vec_unpacku_hi_v8qi;
  ena[580] = HAVE_vec_unpacku_hi_v4hi;
  ena[581] = HAVE_vec_unpacku_hi_v16qi;
  ena[582] = HAVE_vec_unpacku_hi_v8hi;
  ena[583] = HAVE_vec_unpacku_hi_v4si;
  ena[584] = HAVE_vec_unpacku_lo_v8qi;
  ena[585] = HAVE_vec_unpacku_lo_v4hi;
  ena[586] = HAVE_vec_unpacku_lo_v16qi;
  ena[587] = HAVE_vec_unpacku_lo_v8hi;
  ena[588] = HAVE_vec_unpacku_lo_v4si;
  ena[589] = HAVE_sync_addqi;
  ena[590] = HAVE_sync_addhi;
  ena[591] = HAVE_sync_addsi;
  ena[592] = HAVE_sync_adddi;
  ena[593] = HAVE_sync_andqi;
  ena[594] = HAVE_sync_andhi;
  ena[595] = HAVE_sync_andsi;
  ena[596] = HAVE_sync_anddi;
  ena[597] = HAVE_sync_iorqi;
  ena[598] = HAVE_sync_iorhi;
  ena[599] = HAVE_sync_iorsi;
  ena[600] = HAVE_sync_iordi;
  ena[601] = HAVE_sync_nandqi;
  ena[602] = HAVE_sync_nandhi;
  ena[603] = HAVE_sync_nandsi;
  ena[604] = HAVE_sync_nanddi;
  ena[605] = HAVE_sync_subqi;
  ena[606] = HAVE_sync_subhi;
  ena[607] = HAVE_sync_subsi;
  ena[608] = HAVE_sync_subdi;
  ena[609] = HAVE_sync_xorqi;
  ena[610] = HAVE_sync_xorhi;
  ena[611] = HAVE_sync_xorsi;
  ena[612] = HAVE_sync_xordi;
  ena[613] = HAVE_atomic_compare_and_swapsi;
  ena[614] = HAVE_atomic_compare_and_swapdi;
  ena[615] = HAVE_atomic_exchangesi;
  ena[616] = HAVE_atomic_exchangedi;
  ena[617] = HAVE_atomic_fetch_addsi;
  ena[618] = HAVE_atomic_fetch_adddi;
  ena[619] = HAVE_get_thread_pointersi;
  ena[620] = HAVE_get_thread_pointerdi;
}

static int
lookup_handler (unsigned scode)
{
  int l = 0, h = ARRAY_SIZE (pats), m;
  while (h > l)
    {
      m = (h + l) / 2;
      if (scode == pats[m].scode)
        return m;
      else if (scode < pats[m].scode)
        h = m;
      else
        l = m + 1;
    }
  return -1;
}

enum insn_code
raw_optab_handler (unsigned scode)
{
  int i = lookup_handler (scode);
  return (i >= 0 && this_fn_optabs->pat_enable[i]
          ? pats[i].icode : CODE_FOR_nothing);
}

bool
swap_optab_enable (optab op, machine_mode m, bool set)
{
  unsigned scode = (op << 16) | m;
  int i = lookup_handler (scode);
  if (i >= 0)
    {
      bool ret = this_fn_optabs->pat_enable[i];
      this_fn_optabs->pat_enable[i] = set;
      return ret;
    }
  else
    {
      gcc_assert (!set);
      return false;
    }
}

const struct convert_optab_libcall_d convlib_def[NUM_CONVLIB_OPTABS] = {
  { "extend", gen_extend_conv_libfunc },
  { "trunc", gen_trunc_conv_libfunc },
  { NULL, NULL },
  { "fix", gen_fp_to_int_conv_libfunc },
  { "fixuns", gen_fp_to_int_conv_libfunc },
  { "float", gen_int_to_fp_conv_libfunc },
  { NULL, gen_ufloat_conv_libfunc },
  { "lrint", gen_int_to_fp_nondecimal_conv_libfunc },
  { "lround", gen_int_to_fp_nondecimal_conv_libfunc },
  { "lfloor", gen_int_to_fp_nondecimal_conv_libfunc },
  { "lceil", gen_int_to_fp_nondecimal_conv_libfunc },
  { "fract", gen_fract_conv_libfunc },
  { "fractuns", gen_fractuns_conv_libfunc },
  { "satfract", gen_satfract_conv_libfunc },
  { "satfractuns", gen_satfractuns_conv_libfunc },
};

const struct optab_libcall_d normlib_def[NUM_NORMLIB_OPTABS] = {
  { '3', "add", gen_int_fp_fixed_libfunc },
  { '3', "add", gen_intv_fp_libfunc },
  { '3', "ssadd", gen_signed_fixed_libfunc },
  { '3', "usadd", gen_unsigned_fixed_libfunc },
  { '3', "sub", gen_int_fp_fixed_libfunc },
  { '3', "sub", gen_intv_fp_libfunc },
  { '3', "sssub", gen_signed_fixed_libfunc },
  { '3', "ussub", gen_unsigned_fixed_libfunc },
  { '3', "mul", gen_int_fp_fixed_libfunc },
  { '3', "mul", gen_intv_fp_libfunc },
  { '3', "ssmul", gen_signed_fixed_libfunc },
  { '3', "usmul", gen_unsigned_fixed_libfunc },
  { '3', "div", gen_int_fp_signed_fixed_libfunc },
  { '3', "divv", gen_int_libfunc },
  { '3', "ssdiv", gen_signed_fixed_libfunc },
  { '3', "udiv", gen_int_unsigned_fixed_libfunc },
  { '3', "usdiv", gen_unsigned_fixed_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '3', "mod", gen_int_libfunc },
  { '3', "umod", gen_int_libfunc },
  { '2', "ftrunc", gen_fp_libfunc },
  { '3', "and", gen_int_libfunc },
  { '3', "ior", gen_int_libfunc },
  { '3', "xor", gen_int_libfunc },
  { '3', "ashl", gen_int_fixed_libfunc },
  { '3', "ssashl", gen_signed_fixed_libfunc },
  { '3', "usashl", gen_unsigned_fixed_libfunc },
  { '3', "ashr", gen_int_signed_fixed_libfunc },
  { '3', "lshr", gen_int_unsigned_fixed_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '3', "min", gen_int_fp_libfunc },
  { '3', "max", gen_int_fp_libfunc },
  { '3', "umin", gen_int_libfunc },
  { '3', "umax", gen_int_libfunc },
  { '2', "neg", gen_int_fp_fixed_libfunc },
  { '2', "neg", gen_intv_fp_libfunc },
  { '2', "ssneg", gen_signed_fixed_libfunc },
  { '2', "usneg", gen_unsigned_fixed_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '2', "one_cmpl", gen_int_libfunc },
  { '\0', NULL, NULL },
  { '2', "ffs", gen_int_libfunc },
  { '2', "clz", gen_int_libfunc },
  { '2', "ctz", gen_int_libfunc },
  { '2', "clrsb", gen_int_libfunc },
  { '2', "popcount", gen_int_libfunc },
  { '2', "parity", gen_int_libfunc },
  { '2', "cmp", gen_int_fp_fixed_libfunc },
  { '2', "ucmp", gen_int_libfunc },
  { '2', "eq", gen_fp_libfunc },
  { '2', "ne", gen_fp_libfunc },
  { '2', "gt", gen_fp_libfunc },
  { '2', "ge", gen_fp_libfunc },
  { '2', "lt", gen_fp_libfunc },
  { '2', "le", gen_fp_libfunc },
  { '2', "unord", gen_fp_libfunc },
  { '2', "powi", gen_fp_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
};

enum rtx_code const optab_to_code_[NUM_OPTABS] = {
  UNKNOWN,
  SIGN_EXTEND,
  TRUNCATE,
  ZERO_EXTEND,
  FIX,
  UNSIGNED_FIX,
  FLOAT,
  UNSIGNED_FLOAT,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  FRACT_CONVERT,
  UNSIGNED_FRACT_CONVERT,
  SAT_FRACT,
  UNSIGNED_SAT_FRACT,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  PLUS,
  PLUS,
  SS_PLUS,
  US_PLUS,
  MINUS,
  MINUS,
  SS_MINUS,
  US_MINUS,
  MULT,
  MULT,
  SS_MULT,
  US_MULT,
  DIV,
  DIV,
  SS_DIV,
  UDIV,
  US_DIV,
  UNKNOWN,
  UNKNOWN,
  MOD,
  UMOD,
  UNKNOWN,
  AND,
  IOR,
  XOR,
  ASHIFT,
  SS_ASHIFT,
  US_ASHIFT,
  ASHIFTRT,
  LSHIFTRT,
  ROTATE,
  ROTATERT,
  ASHIFT,
  ASHIFTRT,
  LSHIFTRT,
  ROTATE,
  ROTATERT,
  SMIN,
  SMAX,
  UMIN,
  UMAX,
  NEG,
  NEG,
  SS_NEG,
  US_NEG,
  ABS,
  ABS,
  NOT,
  BSWAP,
  FFS,
  CLZ,
  CTZ,
  CLRSB,
  POPCOUNT,
  PARITY,
  UNKNOWN,
  UNKNOWN,
  EQ,
  NE,
  GT,
  GE,
  LT,
  LE,
  UNORDERED,
  UNKNOWN,
  SQRT,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  SET,
  STRICT_LOW_PART,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  COMPARE,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  FMA,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  VEC_DUPLICATE,
  VEC_SERIES,
  UNKNOWN,
};

const optab code_to_optab_[NUM_RTX_CODE] = {
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  mov_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  movstrict_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  cbranch_optab,
  add_optab,
  sub_optab,
  neg_optab,
  smul_optab,
  ssmul_optab,
  usmul_optab,
  sdiv_optab,
  ssdiv_optab,
  usdiv_optab,
  smod_optab,
  udiv_optab,
  umod_optab,
  and_optab,
  ior_optab,
  xor_optab,
  one_cmpl_optab,
  ashl_optab,
  rotl_optab,
  ashr_optab,
  lshr_optab,
  rotr_optab,
  smin_optab,
  smax_optab,
  umin_optab,
  umax_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  ne_optab,
  eq_optab,
  ge_optab,
  gt_optab,
  le_optab,
  lt_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unord_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  abs_optab,
  sqrt_optab,
  bswap_optab,
  ffs_optab,
  clrsb_optab,
  clz_optab,
  ctz_optab,
  popcount_optab,
  parity_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  vec_duplicate_optab,
  vec_series_optab,
  ssadd_optab,
  usadd_optab,
  sssub_optab,
  ssneg_optab,
  usneg_optab,
  unknown_optab,
  ssashl_optab,
  usashl_optab,
  ussub_optab,
  unknown_optab,
  unknown_optab,
  fma_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
};

